/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/***************** gpre version LI-V4.0.0.2496 Firebird 4.0 **********************/
/*
 *	PROGRAM:	JRD Backup and Restore Program
 *	MODULE:		backup.epp
 *	DESCRIPTION:	Backup routine
 *
 * The contents of this file are subject to the Interbase Public
 * License Version 1.0 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy
 * of the License at http://www.Inprise.com/IPL.html
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code was created by Inprise Corporation
 * and its predecessors. Portions created by Inprise Corporation are
 * Copyright (C) Inprise Corporation.
 *
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 *
 * Toni Martir: Added verbose backup records as BACKUP_VERBOSE_INTERVAL
 * 2001.07.06 Sean Leyne - Code Cleanup, removed "#ifdef READONLY_DATABASE"
 *                         conditionals, as the engine now fully supports
 *                         readonly databases.
 * 2001.11.20 Claudio Valderrama: fix problem with embedded blanks in
 * generators and use symbol_length effective length calculation from put_text.
 * This minimizes code redundancy and fixes SF Bug #483276.
 * 2001.12.15 Claudio Valderrama: copy should run through symbol_length instead
 * of using just another length calculation algorithm. Callers of put_text, copy
 * and symbol_length (if used directly) should use sizeof. Changed all callers
 * and sizeof() works because the strings are local to the functions. This
 * eliminates the problem with harcoded limits in each call.
 * 2002.10.29 Mike Nordell: UINT64 backup message.
 * 2003.08.17 Claudio Valderrama: Fix SF Bug #750659.
 * 2005.04.29 Claudio Valderrama: Moved symbol_length to misc.cpp.
 */


#include "firebird.h"
#include <stdio.h>
#include <memory.h>
#include <string.h>
#include "../burp/burp.h"
#include "../jrd/ods.h"
#include "../jrd/align.h"
#include "../common/gdsassert.h"
#include "../jrd/constants.h"
#include "../common/stuff.h"
#include "../burp/backu_proto.h"
#include "../burp/burp_proto.h"
#include "../burp/canon_proto.h"
#include "../burp/mvol_proto.h"
#include "../remote/protocol.h"
#ifdef DEBUG
#include "../common/prett_proto.h"
#endif

#include "../common/classes/BlobWrapper.h"
#include "../common/classes/MsgPrint.h"
#include "../burp/OdsDetection.h"

using MsgFormat::SafeArg;
using Firebird::FbLocalStatus;


// For service APIs the follow DB handle is a value stored
// in thread data.  This is also done for other statics generated by
// GPRE.  This is to avoid multiple threading problems with module
// level statics.

/*DATABASE DB = STATIC FILENAME "yachts.lnk" RUNTIME * dbb_file;*/
/**** GDS Preprocessor Definitions ****/
#ifndef JRD_IBASE_H
#include <ibase.h>
#endif
#include <firebird/Interface.h>
#define CAST_CONST_MSG(A) (reinterpret_cast<const unsigned char*>(A))
#define CAST_MSG(A) (reinterpret_cast<unsigned char*>(A))

static const ISC_QUAD
   fbBlobNull = {0, 0};	/* initializer for blobs */
static Firebird::IAttachment*
   DB = 0;		/* database handle */

static Firebird::ITransaction*
   fbTrans = 0;		/* default transaction handle */
static Firebird::IMaster* fbMaster = Firebird::fb_get_master_interface();		/* master interface */
static Firebird::IProvider* fbProvider = fbMaster->getDispatcher();		/* provider interface */
static Firebird::CheckStatusWrapper fbStatusObj(fbMaster->getStatus());	/* status vector */
static Firebird::CheckStatusWrapper fbStatus2Obj(fbMaster->getStatus());	/* status vector */
static Firebird::CheckStatusWrapper* fbStatus = &fbStatusObj;	/* status vector */
static Firebird::CheckStatusWrapper* fbStatus2 = &fbStatus2Obj;	/* status vector */
static int fbIStatus;	/* last completion code */
static const unsigned char
   fb_tpb_3 [4] = {1,9,2,6};

static const unsigned char
   fb_tpb_2 [5] = {1,9,2,6,20};

static const unsigned char
   fb_tpb_1 [4] = {1,9,2,6};

static const unsigned char
   fb_tpb_0 [5] = {1,9,2,6,20};

static const unsigned
   fb_4l = 287;
static const unsigned char
   fb_4 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 11,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring2, 0,0, 7,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 19, 'R','D','B','$','U','S','E','R','_','P','R','I','V','I','L','E','G','E','S', 0, 
		  blr_boolean, 
		     blr_not, 
			blr_missing, 
			   blr_field, 0, 11, 'R','D','B','$','G','R','A','N','T','O','R', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','O','B','J','E','C','T','_','T','Y','P','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','U','S','E','R','_','T','Y','P','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','G','R','A','N','T','_','O','P','T','I','O','N', 
			blr_parameter2, 0, 5,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 8, 'R','D','B','$','U','S','E','R', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 11, 'R','D','B','$','G','R','A','N','T','O','R', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','P','R','I','V','I','L','E','G','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			blr_parameter2, 0, 10,0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_4 */

static const unsigned
   fb_17l = 222;
static const unsigned char
   fb_17 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 6,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 9, 'R','D','B','$','T','Y','P','E','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 8, 'R','D','B','$','T','Y','P','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','T','Y','P','E','_','N','A','M','E', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			blr_parameter, 0, 5,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_17 */

static const unsigned
   fb_25l = 250;
static const unsigned char
   fb_25 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 4,0, 
	    blr_cstring2, 0,0, 0,4, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 2, 
		  blr_relation, 12, 'R','D','B','$','T','R','I','G','G','E','R','S', 0, 
		  blr_relation, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','M','E','S','S','A','G','E','S', 1, 
		  blr_boolean, 
		     blr_and, 
			blr_eql, 
			   blr_field, 1, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			   blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			blr_or, 
			   blr_neq, 
			      blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			      blr_literal, blr_long, 0, 1,0,0,0,
			   blr_missing, 
			      blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 1, 11, 'R','D','B','$','M','E','S','S','A','G','E', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 1, 18, 'R','D','B','$','M','E','S','S','A','G','E','_','N','U','M','B','E','R', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 1, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			blr_parameter, 0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_25 */

static const unsigned
   fb_31l = 379;
static const unsigned char
   fb_31 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 13,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_int64, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','T','R','I','G','G','E','R','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','T','R','I','G','G','E','R','_','S','O','U','R','C','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','T','R','I','G','G','E','R','_','B','L','R', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','T','Y','P','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 9, 'R','D','B','$','F','L','A','G','S', 
			blr_parameter2, 0, 6,0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','I','N','A','C','T','I','V','E', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','S','E','Q','U','E','N','C','E', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 12,0, 10,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 4,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_31 */

static const unsigned
   fb_46l = 524;
static const unsigned char
   fb_46 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 23,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_int64, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_bool, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','T','R','I','G','G','E','R','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','E','N','T','R','Y','P','O','I','N','T', 
			blr_parameter2, 0, 0,0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','E','B','U','G','_','I','N','F','O', 
			blr_parameter2, 0, 1,0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','T','R','I','G','G','E','R','_','S','O','U','R','C','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','T','R','I','G','G','E','R','_','B','L','R', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','T','Y','P','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','V','A','L','I','D','_','B','L','R', 
			blr_parameter2, 0, 12,0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 9, 'R','D','B','$','F','L','A','G','S', 
			blr_parameter2, 0, 14,0, 13,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','I','N','A','C','T','I','V','E', 
			blr_parameter, 0, 15,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 16,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','T','R','I','G','G','E','R','_','S','E','Q','U','E','N','C','E', 
			blr_parameter, 0, 17,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			blr_parameter, 0, 19,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 20,0, 18,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','E','N','G','I','N','E','_','N','A','M','E', 
			blr_parameter2, 0, 21,0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','S','Q','L','_','S','E','C','U','R','I','T','Y', 
			blr_parameter2, 0, 22,0, 7,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 6,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_46 */

static const unsigned
   fb_71l = 114;
static const unsigned char
   fb_71 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 5,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 15, 'R','D','B','$','D','B','_','C','R','E','A','T','O','R','S', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','U','S','E','R','_','T','Y','P','E', 
			blr_parameter2, 0, 3,0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 8, 'R','D','B','$','U','S','E','R', 
			blr_parameter2, 0, 4,0, 1,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_71 */

static const unsigned
   fb_78l = 114;
static const unsigned char
   fb_78 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 2,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 9, 'R','D','B','$','R','O','L','E','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 13, 'R','D','B','$','R','O','L','E','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_parameter, 1, 1,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_78 */

static const unsigned
   fb_84l = 327;
static const unsigned char
   fb_84 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 15,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 5,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,3, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 16, 'R','D','B','$','A','U','T','H','_','M','A','P','P','I','N','G', 0, 
		  blr_boolean, 
		     blr_eql, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 0,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 0,0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','M','A','P','_','T','O','_','T','Y','P','E', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 12, 'R','D','B','$','M','A','P','_','N','A','M','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','M','A','P','_','U','S','I','N','G', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','M','A','P','_','P','L','U','G','I','N', 
			blr_parameter2, 0, 10,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 10, 'R','D','B','$','M','A','P','_','D','B', 
			blr_parameter2, 0, 11,0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','M','A','P','_','F','R','O','M','_','T','Y','P','E', 
			blr_parameter, 0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 12, 'R','D','B','$','M','A','P','_','F','R','O','M', 
			blr_parameter2, 0, 13,0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 10, 'R','D','B','$','M','A','P','_','T','O', 
			blr_parameter2, 0, 14,0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_84 */

static const unsigned
   fb_101l = 107;
static const unsigned char
   fb_101 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 3,0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 9, 'R','D','B','$','R','O','L','E','S', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','R','O','L','E','_','N','A','M','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter, 0, 2,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_101 */

static const unsigned
   fb_106l = 217;
static const unsigned char
   fb_106 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 6,0, 
	    blr_text2, 1,0, 8,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 9, 'R','D','B','$','R','O','L','E','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_eql, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 0,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 21, 'R','D','B','$','S','Y','S','T','E','M','_','P','R','I','V','I','L','E','G','E','S', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 1,0, 3,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','R','O','L','E','_','N','A','M','E', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter, 0, 5,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_106 */

static const unsigned
   fb_114l = 263;
static const unsigned char
   fb_114 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 7,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_long, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 9, 'R','D','B','$','F','I','L','E','S', 0, 
		  blr_boolean, 
		     blr_and, 
			blr_not, 
			   blr_missing, 
			      blr_field, 0, 17, 'R','D','B','$','S','H','A','D','O','W','_','N','U','M','B','E','R', 
			blr_neq, 
			   blr_field, 0, 17, 'R','D','B','$','S','H','A','D','O','W','_','N','U','M','B','E','R', 
			   blr_literal, blr_long, 0, 0,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','F','I','L','E','_','N','A','M','E', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','F','I','L','E','_','L','E','N','G','T','H', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','L','E','_','S','T','A','R','T', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','S','H','A','D','O','W','_','N','U','M','B','E','R', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','L','E','_','F','L','A','G','S', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','I','L','E','_','S','E','Q','U','E','N','C','E', 
			blr_parameter, 0, 6,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_114 */

static const unsigned
   fb_123l = 172;
static const unsigned char
   fb_123 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 4,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 20, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S','E','S', 0, 
		  blr_boolean, 
		     blr_not, 
			blr_starting, 
			   blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			   blr_literal, blr_text, 4,0, 'S','Q','L','$',
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 7, 'R','D','B','$','A','C','L', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter, 0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_123 */

static const unsigned
   fb_129l = 408;
static const unsigned char
   fb_129 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 15,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','E','X','T','E','R','N','A','L','_','F','I','L','E', 
			blr_parameter2, 0, 0,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','E','X','T','E','R','N','A','L','_','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','V','I','E','W','_','S','O','U','R','C','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 12, 'R','D','B','$','V','I','E','W','_','B','L','R', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','R','E','L','A','T','I','O','N','_','I','D', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 9, 'R','D','B','$','F','L','A','G','S', 
			blr_parameter2, 0, 10,0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 13,0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter, 0, 14,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 5,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_129 */

static const unsigned
   fb_146l = 472;
static const unsigned char
   fb_146 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 20,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_bool, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','E','X','T','E','R','N','A','L','_','F','I','L','E', 
			blr_parameter2, 0, 0,0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','E','X','T','E','R','N','A','L','_','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','V','I','E','W','_','S','O','U','R','C','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 12, 'R','D','B','$','V','I','E','W','_','B','L','R', 
			blr_parameter2, 0, 4,0, 15,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','R','E','L','A','T','I','O','N','_','I','D', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','T','Y','P','E', 
			blr_parameter2, 0, 9,0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 9, 'R','D','B','$','F','L','A','G','S', 
			blr_parameter2, 0, 13,0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 14,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 16,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 17,0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter, 0, 18,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','S','Q','L','_','S','E','C','U','R','I','T','Y', 
			blr_parameter2, 0, 19,0, 7,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 5,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_146 */

static const unsigned
   fb_168l = 359;
static const unsigned char
   fb_168 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 8,0, 
	    blr_cstring2, 0,0, 4,0, 
	    blr_cstring2, 0,0, 4,0, 
	    blr_cstring2, 0,0, 12,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 2, 
		  blr_relation, 24, 'R','D','B','$','R','E','L','A','T','I','O','N','_','C','O','N','S','T','R','A','I','N','T','S', 0, 
		  blr_relation, 13, 'R','D','B','$','R','E','L','A','T','I','O','N','S', 1, 
		  blr_boolean, 
		     blr_and, 
			blr_eql, 
			   blr_field, 1, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_or, 
			   blr_missing, 
			      blr_field, 1, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_neq, 
			      blr_field, 1, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			      blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 22, 'R','D','B','$','I','N','I','T','I','A','L','L','Y','_','D','E','F','E','R','R','E','D', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','E','F','E','R','R','A','B','L','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','N','S','T','R','A','I','N','T','_','T','Y','P','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','N','S','T','R','A','I','N','T','_','N','A','M','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
			blr_parameter2, 0, 7,0, 4,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_168 */

static const unsigned
   fb_178l = 211;
static const unsigned char
   fb_178 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 6,0, 
	    blr_cstring2, 0,0, 8,0, 
	    blr_cstring2, 0,0, 12,0, 
	    blr_cstring2, 0,0, 12,0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 19, 'R','D','B','$','R','E','F','_','C','O','N','S','T','R','A','I','N','T','S', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','M','A','T','C','H','_','O','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','L','E','T','E','_','R','U','L','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','U','P','D','A','T','E','_','R','U','L','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','N','S','T','R','A','I','N','T','_','N','A','M','E', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','C','O','N','S','T','_','N','A','M','E','_','U','Q', 
			blr_parameter, 0, 5,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_178 */

static const unsigned
   fb_186l = 127;
static const unsigned char
   fb_186 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 3,0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 22, 'R','D','B','$','P','U','B','L','I','C','A','T','I','O','N','_','T','A','B','L','E','S', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','P','U','B','L','I','C','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','T','A','B','L','E','_','N','A','M','E', 
			blr_parameter, 0, 2,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_186 */

static const unsigned
   fb_191l = 210;
static const unsigned char
   fb_191 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 8,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 16, 'R','D','B','$','P','U','B','L','I','C','A','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_neq, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','A','U','T','O','_','E','N','A','B','L','E', 
			blr_parameter2, 0, 2,0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','A','C','T','I','V','E','_','F','L','A','G', 
			blr_parameter2, 0, 4,0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','P','U','B','L','I','C','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 7,0, 5,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_191 */

static const unsigned
   fb_201l = 248;
static const unsigned char
   fb_201 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 6,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 24, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','P','A','R','A','M','E','T','E','R','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 18, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','T','Y','P','E', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','N','U','M','B','E','R', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','N','A','M','E', 
			   blr_parameter, 1, 4,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 5,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 1,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_201 */

static const unsigned
   fb_211l = 497;
static const unsigned char
   fb_211 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 18,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_message, 0, 2,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 24, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','P','A','R','A','M','E','T','E','R','S', 0, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 18, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
			   blr_equiv, 
			      blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			      blr_value_if, 
				 blr_eql, 
				    blr_parameter, 0, 1,0, 
				    blr_literal, blr_text, 0,0, 
				 blr_null, 
				 blr_parameter, 0, 1,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 23, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','M','E','C','H','A','N','I','S','M', 
			   blr_parameter2, 1, 7,0, 6,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			   blr_parameter2, 1, 9,0, 8,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			   blr_parameter2, 1, 11,0, 10,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','T','Y','P','E', 
			   blr_parameter, 1, 12,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','N','U','M','B','E','R', 
			   blr_parameter, 1, 13,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','P','A','R','A','M','E','T','E','R','_','N','A','M','E', 
			   blr_parameter, 1, 14,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 15,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter2, 1, 16,0, 5,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter2, 1, 17,0, 4,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 3,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_211 */

static const unsigned
   fb_234l = 340;
static const unsigned char
   fb_234 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 10,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','P','R','O','C','E','D','U','R','E','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','B','L','R', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','S','O','U','R','C','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 21, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','O','U','T','P','U','T','S', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','I','N','P','U','T','S', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','N','A','M','E', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 8,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter, 0, 9,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_234 */

static const unsigned
   fb_246l = 586;
static const unsigned char
   fb_246 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 28,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_bool, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','P','R','O','C','E','D','U','R','E','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','E','N','T','R','Y','P','O','I','N','T', 
			blr_parameter2, 0, 0,0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','E','B','U','G','_','I','N','F','O', 
			blr_parameter2, 0, 1,0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','B','L','R', 
			blr_parameter2, 0, 2,0, 18,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','S','O','U','R','C','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','P','R','I','V','A','T','E','_','F','L','A','G', 
			blr_parameter2, 0, 8,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','V','A','L','I','D','_','B','L','R', 
			blr_parameter2, 0, 13,0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','T','Y','P','E', 
			blr_parameter2, 0, 15,0, 14,0, 
		     blr_assignment, 
			blr_field, 0, 21, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','O','U','T','P','U','T','S', 
			blr_parameter, 0, 19,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','I','N','P','U','T','S', 
			blr_parameter, 0, 20,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			blr_parameter2, 0, 22,0, 21,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','P','R','O','C','E','D','U','R','E','_','N','A','M','E', 
			blr_parameter, 0, 23,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 24,0, 17,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 25,0, 16,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','E','N','G','I','N','E','_','N','A','M','E', 
			blr_parameter2, 0, 26,0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','S','Q','L','_','S','E','C','U','R','I','T','Y', 
			blr_parameter2, 0, 27,0, 6,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 5,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_246 */

static const unsigned
   fb_276l = 344;
static const unsigned char
   fb_276 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 16,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_bool, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','P','A','C','K','A','G','E','S', 0, 
		  blr_boolean, 
		     blr_neq, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 0,0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','P','A','C','K','A','G','E','_','B','O','D','Y','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 1,0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 25, 'R','D','B','$','P','A','C','K','A','G','E','_','H','E','A','D','E','R','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 2,0, 11,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','V','A','L','I','D','_','B','O','D','Y','_','F','L','A','G', 
			blr_parameter2, 0, 9,0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			blr_parameter, 0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 13,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 14,0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','S','Q','L','_','S','E','C','U','R','I','T','Y', 
			blr_parameter2, 0, 15,0, 4,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_276 */

static const unsigned
   fb_294l = 864;
static const unsigned char
   fb_294 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 36,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','M','I','S','S','I','N','G','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 0,0, 16,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 1,0, 17,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','M','P','U','T','E','D','_','S','O','U','R','C','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 21, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','S','O','U','R','C','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','B','L','R', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','M','I','S','S','I','N','G','_','V','A','L','U','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			blr_parameter2, 0, 10,0, 32,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			blr_parameter2, 0, 13,0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter2, 0, 15,0, 14,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','L','E','N','G','T','H', 
			blr_parameter2, 0, 19,0, 18,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			blr_parameter2, 0, 21,0, 20,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','I','M','E','N','S','I','O','N','S', 
			blr_parameter, 0, 22,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','E','X','T','E','R','N','A','L','_','S','C','A','L','E', 
			blr_parameter, 0, 23,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','E','X','T','E','R','N','A','L','_','T','Y','P','E', 
			blr_parameter, 0, 24,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','E','X','T','E','R','N','A','L','_','L','E','N','G','T','H', 
			blr_parameter, 0, 25,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 26,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','G','M','E','N','T','_','L','E','N','G','T','H', 
			blr_parameter, 0, 27,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			blr_parameter, 0, 28,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			blr_parameter, 0, 29,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			blr_parameter, 0, 30,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			blr_parameter, 0, 31,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			blr_parameter, 0, 34,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			blr_parameter2, 0, 35,0, 33,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 11,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_294 */

static const unsigned
   fb_332l = 897;
static const unsigned char
   fb_332 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 38,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','M','I','S','S','I','N','G','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 0,0, 18,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 1,0, 19,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','M','P','U','T','E','D','_','S','O','U','R','C','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 21, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','S','O','U','R','C','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','B','L','R', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','M','I','S','S','I','N','G','_','V','A','L','U','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			blr_parameter2, 0, 10,0, 34,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','F','I','E','L','D','_','P','R','E','C','I','S','I','O','N', 
			blr_parameter2, 0, 13,0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			blr_parameter2, 0, 15,0, 14,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter2, 0, 17,0, 16,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','L','E','N','G','T','H', 
			blr_parameter2, 0, 21,0, 20,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			blr_parameter2, 0, 23,0, 22,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','I','M','E','N','S','I','O','N','S', 
			blr_parameter, 0, 24,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','E','X','T','E','R','N','A','L','_','S','C','A','L','E', 
			blr_parameter, 0, 25,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','E','X','T','E','R','N','A','L','_','T','Y','P','E', 
			blr_parameter, 0, 26,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','E','X','T','E','R','N','A','L','_','L','E','N','G','T','H', 
			blr_parameter, 0, 27,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 28,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','G','M','E','N','T','_','L','E','N','G','T','H', 
			blr_parameter, 0, 29,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			blr_parameter, 0, 30,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			blr_parameter, 0, 31,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			blr_parameter, 0, 32,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			blr_parameter, 0, 33,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			blr_parameter, 0, 36,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			blr_parameter2, 0, 37,0, 35,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 11,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_332 */

static const unsigned
   fb_372l = 939;
static const unsigned char
   fb_372 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 42,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 0, 
		  blr_boolean, 
		     blr_neq, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','M','I','S','S','I','N','G','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 0,0, 20,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 1,0, 21,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','M','P','U','T','E','D','_','S','O','U','R','C','E', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 21, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','S','O','U','R','C','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','V','A','L','I','D','A','T','I','O','N','_','B','L','R', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','M','I','S','S','I','N','G','_','V','A','L','U','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			blr_parameter2, 0, 10,0, 36,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','F','I','E','L','D','_','P','R','E','C','I','S','I','O','N', 
			blr_parameter2, 0, 15,0, 14,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			blr_parameter2, 0, 17,0, 16,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter2, 0, 19,0, 18,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','L','E','N','G','T','H', 
			blr_parameter2, 0, 23,0, 22,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			blr_parameter2, 0, 25,0, 24,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','I','M','E','N','S','I','O','N','S', 
			blr_parameter, 0, 26,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','E','X','T','E','R','N','A','L','_','S','C','A','L','E', 
			blr_parameter, 0, 27,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','E','X','T','E','R','N','A','L','_','T','Y','P','E', 
			blr_parameter, 0, 28,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','E','X','T','E','R','N','A','L','_','L','E','N','G','T','H', 
			blr_parameter, 0, 29,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 30,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','G','M','E','N','T','_','L','E','N','G','T','H', 
			blr_parameter, 0, 31,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			blr_parameter, 0, 32,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			blr_parameter, 0, 33,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			blr_parameter, 0, 34,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			blr_parameter, 0, 35,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			blr_parameter, 0, 38,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			blr_parameter2, 0, 39,0, 37,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 40,0, 13,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 41,0, 12,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 11,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_372 */

static const unsigned
   fb_416l = 139;
static const unsigned char
   fb_416 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 2,0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','G','E','N','E','R','A','T','O','R','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','G','E','N','E','R','A','T','O','R','_','N','A','M','E', 
			blr_parameter, 0, 1,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_416 */

static const unsigned
   fb_420l = 168;
static const unsigned char
   fb_420 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 4,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','G','E','N','E','R','A','T','O','R','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 0,0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','G','E','N','E','R','A','T','O','R','_','N','A','M','E', 
			blr_parameter, 0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_420 */

static const unsigned
   fb_426l = 299;
static const unsigned char
   fb_426 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 12,0, 
	    blr_int64, 0, 
	    blr_quad, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','G','E','N','E','R','A','T','O','R','S', 0, 
		  blr_boolean, 
		     blr_neq, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','I','N','I','T','I','A','L','_','V','A','L','U','E', 
			blr_parameter2, 0, 0,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 1,0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','G','E','N','E','R','A','T','O','R','_','I','N','C','R','E','M','E','N','T', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','G','E','N','E','R','A','T','O','R','_','N','A','M','E', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 10,0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 11,0, 5,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_426 */

static const unsigned
   fb_440l = 325;
static const unsigned char
   fb_440 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 10,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 22, 'R','D','B','$','F','U','N','C','T','I','O','N','_','A','R','G','U','M','E','N','T','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			   blr_parameter2, 1, 2,0, 1,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 4,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 5,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','M','E','C','H','A','N','I','S','M', 
			   blr_parameter, 1, 7,0, 
			blr_assignment, 
			   blr_field, 0, 21, 'R','D','B','$','A','R','G','U','M','E','N','T','_','P','O','S','I','T','I','O','N', 
			   blr_parameter, 1, 8,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 9,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_440 */

static const unsigned
   fb_454l = 358;
static const unsigned char
   fb_454 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 12,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 22, 'R','D','B','$','F','U','N','C','T','I','O','N','_','A','R','G','U','M','E','N','T','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 19, 'R','D','B','$','F','I','E','L','D','_','P','R','E','C','I','S','I','O','N', 
			   blr_parameter2, 1, 2,0, 1,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			   blr_parameter2, 1, 4,0, 3,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 5,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 7,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 8,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','M','E','C','H','A','N','I','S','M', 
			   blr_parameter, 1, 9,0, 
			blr_assignment, 
			   blr_field, 0, 21, 'R','D','B','$','A','R','G','U','M','E','N','T','_','P','O','S','I','T','I','O','N', 
			   blr_parameter, 1, 10,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 11,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_454 */

static const unsigned
   fb_470l = 737;
static const unsigned char
   fb_470 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 34,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_message, 0, 2,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 22, 'R','D','B','$','F','U','N','C','T','I','O','N','_','A','R','G','U','M','E','N','T','S', 0, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
			   blr_equiv, 
			      blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			      blr_value_if, 
				 blr_eql, 
				    blr_parameter, 0, 1,0, 
				    blr_literal, blr_text, 0,0, 
				 blr_null, 
				 blr_parameter, 0, 1,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter2, 1, 0,0, 4,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			   blr_parameter2, 1, 1,0, 13,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			   blr_parameter2, 1, 2,0, 14,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 22, 'R','D','B','$','A','R','G','U','M','E','N','T','_','M','E','C','H','A','N','I','S','M', 
			   blr_parameter2, 1, 8,0, 7,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			   blr_parameter2, 1, 10,0, 9,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			   blr_parameter2, 1, 12,0, 11,0, 
			blr_assignment, 
			   blr_field, 0, 19, 'R','D','B','$','F','I','E','L','D','_','P','R','E','C','I','S','I','O','N', 
			   blr_parameter2, 1, 18,0, 17,0, 
			blr_assignment, 
			   blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			   blr_parameter2, 1, 20,0, 19,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 21,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 22,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 23,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 24,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','M','E','C','H','A','N','I','S','M', 
			   blr_parameter, 1, 25,0, 
			blr_assignment, 
			   blr_field, 0, 21, 'R','D','B','$','A','R','G','U','M','E','N','T','_','P','O','S','I','T','I','O','N', 
			   blr_parameter, 1, 26,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			   blr_parameter2, 1, 28,0, 27,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 29,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','A','R','G','U','M','E','N','T','_','N','A','M','E', 
			   blr_parameter2, 1, 30,0, 16,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			   blr_parameter2, 1, 31,0, 15,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter2, 1, 32,0, 6,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter2, 1, 33,0, 5,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 3,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_470 */

static const unsigned
   fb_509l = 298;
static const unsigned char
   fb_509 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 8,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 13, 'R','D','B','$','F','U','N','C','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','E','N','T','R','Y','P','O','I','N','T', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','M','O','D','U','L','E','_','N','A','M','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','T','Y','P','E', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','R','E','T','U','R','N','_','A','R','G','U','M','E','N','T', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			blr_parameter, 0, 7,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_509 */

static const unsigned
   fb_519l = 651;
static const unsigned char
   fb_519 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 34,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_bool, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 13, 'R','D','B','$','F','U','N','C','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_neq, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','D','E','B','U','G','_','I','N','F','O', 
			blr_parameter2, 0, 0,0, 14,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','F','U','N','C','T','I','O','N','_','S','O','U','R','C','E', 
			blr_parameter2, 0, 1,0, 17,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','F','U','N','C','T','I','O','N','_','B','L','R', 
			blr_parameter2, 0, 2,0, 18,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','E','N','T','R','Y','P','O','I','N','T', 
			blr_parameter2, 0, 3,0, 22,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','M','O','D','U','L','E','_','N','A','M','E', 
			blr_parameter2, 0, 4,0, 23,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 22, 'R','D','B','$','D','E','T','E','R','M','I','N','I','S','T','I','C','_','F','L','A','G', 
			blr_parameter2, 0, 9,0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','L','E','G','A','C','Y','_','F','L','A','G', 
			blr_parameter2, 0, 11,0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','V','A','L','I','D','_','B','L','R', 
			blr_parameter2, 0, 16,0, 15,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','P','R','I','V','A','T','E','_','F','L','A','G', 
			blr_parameter2, 0, 20,0, 19,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','T','Y','P','E', 
			blr_parameter, 0, 24,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','R','E','T','U','R','N','_','A','R','G','U','M','E','N','T', 
			blr_parameter, 0, 25,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			blr_parameter2, 0, 27,0, 26,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 28,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			blr_parameter, 0, 29,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','E','N','G','I','N','E','_','N','A','M','E', 
			blr_parameter2, 0, 30,0, 21,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 31,0, 13,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 32,0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','S','Q','L','_','S','E','C','U','R','I','T','Y', 
			blr_parameter2, 0, 33,0, 7,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 6,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_519 */

static const unsigned
   fb_555l = 272;
static const unsigned char
   fb_555 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 7,0, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_cstring2, 0,0, 0,1, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 11, 'R','D','B','$','F','I','L','T','E','R','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','E','N','T','R','Y','P','O','I','N','T', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','M','O','D','U','L','E','_','N','A','M','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','O','U','T','P','U','T','_','S','U','B','_','T','Y','P','E', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','I','N','P','U','T','_','S','U','B','_','T','Y','P','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 6,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 3,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_555 */

static const unsigned
   fb_564l = 167;
static const unsigned char
   fb_564 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 5,0, 
	    blr_long, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 20, 'R','D','B','$','F','I','E','L','D','_','D','I','M','E','N','S','I','O','N','S', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','U','P','P','E','R','_','B','O','U','N','D', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','L','O','W','E','R','_','B','O','U','N','D', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 13, 'R','D','B','$','D','I','M','E','N','S','I','O','N', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			blr_parameter, 0, 4,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_564 */

static const unsigned
   fb_571l = 188;
static const unsigned char
   fb_571 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 4,0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 0,4, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','E','X','C','E','P','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 11, 'R','D','B','$','M','E','S','S','A','G','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','E','X','C','E','P','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_571 */

static const unsigned
   fb_577l = 230;
static const unsigned char
   fb_577 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 8,0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 0,4, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','E','X','C','E','P','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_neq, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 11, 'R','D','B','$','M','E','S','S','A','G','E', 
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','E','X','C','E','P','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 6,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 7,0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_577 */

static const unsigned
   fb_587l = 156;
static const unsigned char
   fb_587 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 6,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','D','A','T','A','B','A','S','E', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 4,0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 22, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','N','A','M','E', 
			blr_parameter2, 0, 5,0, 2,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_587 */

static const unsigned
   fb_595l = 209;
static const unsigned char
   fb_595 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 10,0, 
	    blr_quad, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_bool, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 12, 'R','D','B','$','D','A','T','A','B','A','S','E', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 10, 'R','D','B','$','L','I','N','G','E','R', 
			blr_parameter2, 0, 1,0, 4,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 7,0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 22, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','N','A','M','E', 
			blr_parameter2, 0, 8,0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','S','Q','L','_','S','E','C','U','R','I','T','Y', 
			blr_parameter2, 0, 9,0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_595 */

static const unsigned
   fb_607l = 315;
static const unsigned char
   fb_607 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 10,0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','C','O','L','L','A','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 0,0, 3,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 1,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','A','T','T','R','I','B','U','T','E','S', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 9,0, 2,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 1,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_607 */

static const unsigned
   fb_619l = 390;
static const unsigned char
   fb_619 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 14,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','C','O','L','L','A','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','S','P','E','C','I','F','I','C','_','A','T','T','R','I','B','U','T','E','S', 
			blr_parameter2, 0, 0,0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 1,0, 6,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','A','T','T','R','I','B','U','T','E','S', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			blr_parameter, 0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 12,0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','B','A','S','E','_','C','O','L','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 13,0, 4,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_619 */

static const unsigned
   fb_635l = 432;
static const unsigned char
   fb_635 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 18,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 14, 'R','D','B','$','C','O','L','L','A','T','I','O','N','S', 0, 
		  blr_boolean, 
		     blr_neq, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_literal, blr_long, 0, 1,0,0,0,
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','S','P','E','C','I','F','I','C','_','A','T','T','R','I','B','U','T','E','S', 
			blr_parameter2, 0, 0,0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 1,0, 8,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','A','T','T','R','I','B','U','T','E','S', 
			blr_parameter, 0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			blr_parameter, 0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter, 0, 13,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 14,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','B','A','S','E','_','C','O','L','L','A','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 15,0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 16,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 17,0, 3,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_635 */

static const unsigned
   fb_655l = 131;
static const unsigned char
   fb_655 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 4,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 21, 'R','D','B','$','C','H','E','C','K','_','C','O','N','S','T','R','A','I','N','T','S', 0, 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 0,0, 
		     blr_assignment, 
			blr_field, 0, 19, 'R','D','B','$','C','O','N','S','T','R','A','I','N','T','_','N','A','M','E', 
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 16, 'R','D','B','$','T','R','I','G','G','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 3,0, 1,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 0,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_655 */

static const unsigned
   fb_661l = 457;
static const unsigned char
   fb_661 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 15,0, 
	    blr_quad, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 18, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_missing, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_or, 
			   blr_neq, 
			      blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			      blr_literal, blr_long, 0, 1,0,0,0,
			   blr_neq, 
			      blr_field, 0, 24, 'R','D','B','$','D','E','F','A','U','L','T','_','C','O','L','L','A','T','E','_','N','A','M','E', 
			      blr_field, 0, 22, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','N','A','M','E', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 0,0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','N','U','M','B','E','R','_','O','F','_','C','H','A','R','A','C','T','E','R','S', 
			blr_parameter2, 0, 1,0, 7,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','B','Y','T','E','S','_','P','E','R','_','C','H','A','R','A','C','T','E','R', 
			blr_parameter, 0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter, 0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter2, 0, 10,0, 9,0, 
		     blr_assignment, 
			blr_field, 0, 22, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','N','A','M','E', 
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','F','O','R','M','_','O','F','_','U','S','E', 
			blr_parameter2, 0, 12,0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 13,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','D','E','F','A','U','L','T','_','C','O','L','L','A','T','E','_','N','A','M','E', 
			blr_parameter, 0, 14,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_661 */

static const unsigned
   fb_678l = 495;
static const unsigned char
   fb_678 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 0, 18,0, 
	    blr_quad, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_begin, 
	    blr_for, 
	       blr_rse, 1, 
		  blr_relation, 18, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','S', 0, 
		  blr_boolean, 
		     blr_or, 
			blr_neq, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_literal, blr_long, 0, 1,0,0,0,
			blr_neq, 
			   blr_field, 0, 24, 'R','D','B','$','D','E','F','A','U','L','T','_','C','O','L','L','A','T','E','_','N','A','M','E', 
			   blr_field, 0, 22, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','N','A','M','E', 
		  blr_end, 
	       blr_send, 0, 
		  blr_begin, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			blr_parameter2, 0, 0,0, 7,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','N','U','M','B','E','R','_','O','F','_','C','H','A','R','A','C','T','E','R','S', 
			blr_parameter2, 0, 1,0, 9,0, 
		     blr_assignment, 
			blr_literal, blr_long, 0, 1,0,0,0,
			blr_parameter, 0, 2,0, 
		     blr_assignment, 
			blr_field, 0, 23, 'R','D','B','$','B','Y','T','E','S','_','P','E','R','_','C','H','A','R','A','C','T','E','R', 
			blr_parameter, 0, 5,0, 
		     blr_assignment, 
			blr_field, 0, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			blr_parameter, 0, 8,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			blr_parameter, 0, 11,0, 
		     blr_assignment, 
			blr_field, 0, 22, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','N','A','M','E', 
			blr_parameter, 0, 12,0, 
		     blr_assignment, 
			blr_field, 0, 15, 'R','D','B','$','F','O','R','M','_','O','F','_','U','S','E', 
			blr_parameter2, 0, 13,0, 10,0, 
		     blr_assignment, 
			blr_field, 0, 17, 'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A','M','E', 
			blr_parameter2, 0, 14,0, 6,0, 
		     blr_assignment, 
			blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			blr_parameter2, 0, 15,0, 4,0, 
		     blr_assignment, 
			blr_field, 0, 14, 'R','D','B','$','O','W','N','E','R','_','N','A','M','E', 
			blr_parameter2, 0, 16,0, 3,0, 
		     blr_assignment, 
			blr_field, 0, 24, 'R','D','B','$','D','E','F','A','U','L','T','_','C','O','L','L','A','T','E','_','N','A','M','E', 
			blr_parameter, 0, 17,0, 
		     blr_end, 
	    blr_send, 0, 
	       blr_assignment, 
		  blr_literal, blr_long, 0, 0,0,0,0,
		  blr_parameter, 0, 2,0, 
	    blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_678 */

static const unsigned
   fb_698l = 179;
static const unsigned char
   fb_698 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 4,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,3, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 18, 'R','D','B','$','V','I','E','W','_','R','E','L','A','T','I','O','N','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 13, 'R','D','B','$','V','I','E','W','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','V','I','E','W','_','C','O','N','T','E','X','T', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','N','T','E','X','T','_','N','A','M','E', 
			   blr_parameter, 1, 3,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_698 */

static const unsigned
   fb_706l = 240;
static const unsigned char
   fb_706 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 8,0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,3, 
	    blr_cstring, 253,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 18, 'R','D','B','$','V','I','E','W','_','R','E','L','A','T','I','O','N','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 13, 'R','D','B','$','V','I','E','W','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','N','T','E','X','T','_','T','Y','P','E', 
			   blr_parameter2, 1, 3,0, 2,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','V','I','E','W','_','C','O','N','T','E','X','T', 
			   blr_parameter, 1, 4,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 1, 5,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','N','T','E','X','T','_','N','A','M','E', 
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','P','A','C','K','A','G','E','_','N','A','M','E', 
			   blr_parameter2, 1, 7,0, 1,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_706 */

static const unsigned
   fb_718l = 148;
static const unsigned char
   fb_718 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 2,0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 18, 'R','D','B','$','I','N','D','E','X','_','S','E','G','M','E','N','T','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_sort, 1, 
			blr_ascending, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','P','O','S','I','T','I','O','N', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 1,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_718 */

static const unsigned
   fb_724l = 186;
static const unsigned char
   fb_724 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 1,0, 
	    blr_short, 0, 
	 blr_message, 0, 2,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 2, 
		     blr_relation, 18, 'R','D','B','$','I','N','D','E','X','_','S','E','G','M','E','N','T','S', 0, 
		     blr_relation, 19, 'R','D','B','$','R','E','L','A','T','I','O','N','_','F','I','E','L','D','S', 1, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			      blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_and, 
			      blr_eql, 
				 blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
				 blr_parameter, 0, 0,0, 
			      blr_eql, 
				 blr_field, 1, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
				 blr_parameter, 0, 1,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 0,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 0,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_724 */

static const unsigned
   fb_730l = 346;
static const unsigned char
   fb_730 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 13,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 11, 'R','D','B','$','I','N','D','I','C','E','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','E','X','P','R','E','S','S','I','O','N','_','B','L','R', 
			   blr_parameter2, 1, 0,0, 5,0, 
			blr_assignment, 
			   blr_field, 0, 21, 'R','D','B','$','E','X','P','R','E','S','S','I','O','N','_','S','O','U','R','C','E', 
			   blr_parameter2, 1, 1,0, 6,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','T','Y','P','E', 
			   blr_parameter, 1, 7,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','U','N','I','Q','U','E','_','F','L','A','G', 
			   blr_parameter, 1, 8,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','I','N','D','E','X','_','I','N','A','C','T','I','V','E', 
			   blr_parameter, 1, 9,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','S','E','G','M','E','N','T','_','C','O','U','N','T', 
			   blr_parameter, 1, 10,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','I','N','D','E','X','_','N','A','M','E', 
			   blr_parameter, 1, 11,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','F','O','R','E','I','G','N','_','K','E','Y', 
			   blr_parameter2, 1, 12,0, 4,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 3,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_730 */

static const unsigned
   fb_747l = 193;
static const unsigned char
   fb_747 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 4,0, 
	    blr_long, 0, 
	    blr_long, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 1, 
		     blr_relation, 20, 'R','D','B','$','F','I','E','L','D','_','D','I','M','E','N','S','I','O','N','S', 0, 
		     blr_boolean, 
			blr_eql, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 0, 0,0, 
		     blr_sort, 1, 
			blr_ascending, 
			   blr_field, 0, 13, 'R','D','B','$','D','I','M','E','N','S','I','O','N', 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','U','P','P','E','R','_','B','O','U','N','D', 
			   blr_parameter, 1, 0,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','L','O','W','E','R','_','B','O','U','N','D', 
			   blr_parameter, 1, 1,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','D','I','M','E','N','S','I','O','N', 
			   blr_parameter, 1, 3,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 2,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_747 */

static const unsigned
   fb_755l = 840;
static const unsigned char
   fb_755 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 35,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 2, 
		     blr_relation, 19, 'R','D','B','$','R','E','L','A','T','I','O','N','_','F','I','E','L','D','S', 0, 
		     blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 1, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			      blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_eql, 
			      blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			   blr_parameter2, 1, 0,0, 11,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			   blr_parameter2, 1, 1,0, 12,0, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			   blr_parameter2, 1, 4,0, 22,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter2, 1, 5,0, 23,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			   blr_parameter2, 1, 8,0, 7,0, 
			blr_assignment, 
			   blr_field, 1, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			   blr_parameter2, 1, 10,0, 9,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			   blr_parameter2, 1, 14,0, 13,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','D','I','M','E','N','S','I','O','N','S', 
			   blr_parameter, 1, 15,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_parameter, 1, 16,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','U','P','D','A','T','E','_','F','L','A','G', 
			   blr_parameter2, 1, 18,0, 17,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','V','I','E','W','_','C','O','N','T','E','X','T', 
			   blr_parameter, 1, 19,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','P','O','S','I','T','I','O','N', 
			   blr_parameter2, 1, 21,0, 20,0, 
			blr_assignment, 
			   blr_field, 0, 12, 'R','D','B','$','F','I','E','L','D','_','I','D', 
			   blr_parameter, 1, 24,0, 
			blr_assignment, 
			   blr_field, 1, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 25,0, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 26,0, 
			blr_assignment, 
			   blr_field, 1, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 27,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 28,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 29,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 30,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','B','A','S','E','_','F','I','E','L','D', 
			   blr_parameter, 1, 31,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			   blr_parameter, 1, 32,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','M','P','L','E','X','_','N','A','M','E', 
			   blr_parameter, 1, 33,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			   blr_parameter, 1, 34,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 6,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_755 */

static const unsigned
   fb_794l = 900;
static const unsigned char
   fb_794 [] = {
      blr_version4,
      blr_begin, 
	 blr_message, 1, 38,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_cstring2, 0,0, 128,0, 
	    blr_quad, 0, 
	    blr_quad, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_short, 0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	    blr_cstring, 253,0, 
	 blr_message, 0, 1,0, 
	    blr_cstring, 253,0, 
	 blr_receive, 0, 
	    blr_begin, 
	       blr_for, 
		  blr_rse, 2, 
		     blr_relation, 19, 'R','D','B','$','R','E','L','A','T','I','O','N','_','F','I','E','L','D','S', 0, 
		     blr_relation, 10, 'R','D','B','$','F','I','E','L','D','S', 1, 
		     blr_boolean, 
			blr_and, 
			   blr_eql, 
			      blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			      blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_eql, 
			      blr_field, 0, 17, 'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A','M','E', 
			      blr_parameter, 0, 0,0, 
		     blr_end, 
		  blr_send, 1, 
		     blr_begin, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','D','E','F','A','U','L','T','_','S','O','U','R','C','E', 
			   blr_parameter2, 1, 0,0, 13,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','D','E','F','A','U','L','T','_','V','A','L','U','E', 
			   blr_parameter2, 1, 1,0, 14,0, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','C','O','M','P','U','T','E','D','_','B','L','R', 
			   blr_parameter, 1, 2,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','E','D','I','T','_','S','T','R','I','N','G', 
			   blr_parameter, 1, 3,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D','E','R', 
			   blr_parameter2, 1, 4,0, 24,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N', 
			   blr_parameter2, 1, 5,0, 25,0, 
			blr_assignment, 
			   blr_literal, blr_long, 0, 1,0,0,0,
			   blr_parameter, 1, 6,0, 
			blr_assignment, 
			   blr_field, 0, 17, 'R','D','B','$','I','D','E','N','T','I','T','Y','_','T','Y','P','E', 
			   blr_parameter, 1, 7,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I','D', 
			   blr_parameter2, 1, 10,0, 9,0, 
			blr_assignment, 
			   blr_field, 1, 20, 'R','D','B','$','C','H','A','R','A','C','T','E','R','_','S','E','T','_','I','D', 
			   blr_parameter2, 1, 12,0, 11,0, 
			blr_assignment, 
			   blr_field, 0, 13, 'R','D','B','$','N','U','L','L','_','F','L','A','G', 
			   blr_parameter2, 1, 16,0, 15,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','D','I','M','E','N','S','I','O','N','S', 
			   blr_parameter, 1, 17,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G', 
			   blr_parameter, 1, 18,0, 
			blr_assignment, 
			   blr_field, 0, 15, 'R','D','B','$','U','P','D','A','T','E','_','F','L','A','G', 
			   blr_parameter2, 1, 20,0, 19,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','V','I','E','W','_','C','O','N','T','E','X','T', 
			   blr_parameter, 1, 21,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','F','I','E','L','D','_','P','O','S','I','T','I','O','N', 
			   blr_parameter2, 1, 23,0, 22,0, 
			blr_assignment, 
			   blr_field, 0, 12, 'R','D','B','$','F','I','E','L','D','_','I','D', 
			   blr_parameter, 1, 26,0, 
			blr_assignment, 
			   blr_field, 1, 15, 'R','D','B','$','F','I','E','L','D','_','S','C','A','L','E', 
			   blr_parameter, 1, 27,0, 
			blr_assignment, 
			   blr_field, 1, 16, 'R','D','B','$','F','I','E','L','D','_','L','E','N','G','T','H', 
			   blr_parameter, 1, 28,0, 
			blr_assignment, 
			   blr_field, 1, 18, 'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T','Y','P','E', 
			   blr_parameter, 1, 29,0, 
			blr_assignment, 
			   blr_field, 1, 14, 'R','D','B','$','F','I','E','L','D','_','T','Y','P','E', 
			   blr_parameter, 1, 30,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','F','I','E','L','D','_','N','A','M','E', 
			   blr_parameter, 1, 31,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C','E', 
			   blr_parameter, 1, 32,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','B','A','S','E','_','F','I','E','L','D', 
			   blr_parameter, 1, 33,0, 
			blr_assignment, 
			   blr_field, 0, 14, 'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E', 
			   blr_parameter, 1, 34,0, 
			blr_assignment, 
			   blr_field, 0, 16, 'R','D','B','$','C','O','M','P','L','E','X','_','N','A','M','E', 
			   blr_parameter, 1, 35,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S', 
			   blr_parameter, 1, 36,0, 
			blr_assignment, 
			   blr_field, 0, 18, 'R','D','B','$','G','E','N','E','R','A','T','O','R','_','N','A','M','E', 
			   blr_parameter2, 1, 37,0, 8,0, 
			blr_end, 
	       blr_send, 1, 
		  blr_assignment, 
		     blr_literal, blr_long, 0, 0,0,0,0,
		     blr_parameter, 1, 6,0, 
	       blr_end, 
	 blr_end, 
      blr_eoc
   };	/* end of blr string for request fb_794 */




#define DB			tdgbl->db_handle
#define fbTrans		tdgbl->tr_handle
#define gds_trans	tdgbl->tr_handle
#define fbStatus	(&tdgbl->status_vector)
#define isc_status	(&tdgbl->status_vector)
#define gds_status	(&tdgbl->status_vector)

namespace // unnamed, private
{

#define PUT_MESSAGE(attrib, attrib2, message) put_message((attrib), (attrib2), (message), sizeof(message))
#define PUT_TEXT(attribute, text)	put_text ((attribute), (text), sizeof(text))
#define COPY(source, target)       copy ((source), (target), sizeof(target))

inline void put(BurpGlobals* tdgbl, const UCHAR c)
{
	tdgbl->put(c);
}

inline void put(BurpGlobals* tdgbl, const att_type c)
{
	put(tdgbl, UCHAR(c));
}

inline const UCHAR* put_block(BurpGlobals* tdgbl, const UCHAR* p, ULONG n)
{
	return MVOL_write_block (tdgbl, p, n);
}


void compress(const UCHAR*, ULONG);
int copy(const TEXT*, TEXT*, ULONG);
burp_fld* get_fields(burp_rel*);
SINT64 get_gen_id(const TEXT*, SSHORT);
void get_ranges(burp_fld*);
void put_array(burp_fld*, burp_rel*, ISC_QUAD*);
void put_asciz(const att_type, const TEXT*);
void put_blob(burp_fld*, ISC_QUAD&);
bool put_blr_blob(att_type, ISC_QUAD&);
void put_data(burp_rel*);
void put_index(burp_rel*);
int put_message(att_type, att_type, const TEXT*, const ULONG);
void put_int32(att_type, SLONG);
void put_int64(att_type attribute, SINT64 value);
void put_boolean(att_type, FB_BOOLEAN value);
void put_relation(burp_rel*);
bool put_source_blob(att_type, att_type, ISC_QUAD&);
int put_text(att_type, const TEXT*, SSHORT);
void write_character_sets();
void write_check_constraints();
void write_collations();
void write_database(const TEXT*);
void write_exceptions();
void write_field_dimensions();
void write_filters();
void write_functions();
void write_function_args(const GDS_NAME, GDS_NAME);
void write_global_fields();
void write_generators();
void write_sql_roles();
void write_mapping();
void write_db_creators();
void write_packages();
void write_procedures();
void write_procedure_prms(const GDS_NAME, const GDS_NAME);
void write_publications();
void write_pub_tables();
void write_ref_constraints();
void write_rel_constraints();
void write_relations();
void write_secclasses();
void write_shadow_files();
void write_triggers();
void write_trigger_messages();
void write_types();
void write_user_privileges();
void general_on_error();


#ifdef DEBUG
UCHAR debug_on = 0;		// able to turn this on in debug mode
#endif


const UCHAR blob_items[] =
{
	isc_info_blob_max_segment,
	isc_info_blob_num_segments,
	isc_info_blob_type,
	isc_info_blob_total_length
};
const UCHAR blr_items[] =
{
	isc_info_blob_max_segment,
	isc_info_blob_total_length
};
const UCHAR source_items[] =
{
	isc_info_blob_max_segment,
	isc_info_blob_total_length,
	isc_info_blob_num_segments
};
const UCHAR db_info_items[] =
{
	isc_info_db_sql_dialect,
	isc_info_page_size,
	isc_info_sweep_interval,
	isc_info_forced_writes,
	isc_info_no_reserve,
	isc_info_set_page_buffers,
	isc_info_db_read_only,
	fb_info_replica_mode,
	isc_info_end
};
const UCHAR limbo_tpb[] =
{
	isc_tpb_version1,
	isc_tpb_ignore_limbo
};
const UCHAR limbo_nau_tpb[] =
{
	isc_tpb_version1,
	isc_tpb_ignore_limbo,
	isc_tpb_no_auto_undo
};

} // namespace


int BACKUP_backup(const TEXT* dbb_file, const TEXT* file_name)
{
/**************************************
 *
 *	B A C K U P _ b a c k u p
 *
 **************************************
 *
 * Functional description
 *	Backup a database.
 *
 **************************************/
	FbLocalStatus status_vector;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	tdgbl->gbl_database_file_name = dbb_file;

	gds_trans = 0;

	BURP_verbose(130);
	// msg 130 starting transaction

	if (tdgbl->gbl_sw_ignore_limbo)
	{
		gds_trans = DB->startTransaction(&status_vector, sizeof(limbo_nau_tpb), limbo_nau_tpb);
		if (status_vector->getState() & Firebird::IStatus::STATE_ERRORS)
		{
			gds_trans = DB->startTransaction(&status_vector, sizeof(limbo_tpb), limbo_tpb);
		}
	}
	else
	{
		/*EXEC SQL SET TRANSACTION NO_AUTO_UNDO;*/
		{
		fbTrans = DB->startTransaction(fbStatus, 5, fb_tpb_0);
		}
		if (isc_status->getState() & Firebird::IStatus::STATE_ERRORS)
			/*EXEC SQL SET TRANSACTION;*/
			{
			fbTrans = DB->startTransaction(fbStatus, 4, fb_tpb_1);
			}
	}

	if (!gds_trans)
	{
		/*EXEC SQL SET TRANSACTION NAME gds_trans NO_AUTO_UNDO;*/
		{
		gds_trans = DB->startTransaction(fbStatus, 5, fb_tpb_2);
		}
		if (isc_status->getState() & Firebird::IStatus::STATE_ERRORS)
			/*EXEC SQL SET TRANSACTION NAME gds_trans;*/
			{
			gds_trans = DB->startTransaction(fbStatus, 4, fb_tpb_3);
			}
	}


	// decide what type of database we've got

	detectRuntimeODS();
	if (tdgbl->runtimeODS < DB_VERSION_OLDEST_SUPPORTED)
	{
		BURP_error(348, true, SafeArg() << tdgbl->runtimeODS);
		// msg 348 database format @1 is too old to backup
	}

	// Write burp record first with other valuable information
	// In case of split operation, write a 'split' header first to all the files

	if (tdgbl->action->act_action == ACT_backup_split)
	{
		for (burp_fil* fil = tdgbl->gbl_sw_files; fil; fil = fil->fil_next)
		{
			tdgbl->action->act_file = fil;
			if (!MVOL_split_hdr_write())
			{
				BURP_error(269, true, tdgbl->action->act_file->fil_name.c_str());
				// msg 269 can't write a header record to file %s
			}
		}
		tdgbl->action->act_file = tdgbl->gbl_sw_files;
	}

	MVOL_init_write(file_name);

	// Write database record

	write_database(dbb_file);

	// Write global fields

	BURP_verbose(150);
	// msg 150  writing global fields
	write_global_fields();

	write_field_dimensions();

	BURP_verbose(162);
	// msg 162  writing shadow files
	write_shadow_files();

	// Write Character Sets
	BURP_verbose(msgVerbose_write_charsets);
	write_character_sets();

	// Write Collations
	BURP_verbose(msgVerbose_write_collations);
	write_collations();

	// Write relations

	BURP_verbose(154);
	// msg 154 writing tables

	write_relations();

	// Write types
	BURP_verbose(161);
	// msg 161  writing types
	write_types();

	// Write filters
	BURP_verbose(146);
	// msg 146 writing filters
	write_filters();

	// Write generators
	BURP_verbose(164);
	// msg 164  writing id generators
	write_generators();

	// Write exceptions
	BURP_verbose(197);
	// msg 197 writing exceptions
	write_exceptions();

	// Write functions
	BURP_verbose(148);
	// msg 148 writing functions
	write_functions();

	// Write procedures
	BURP_verbose(192);
	// msg 192 writing stored procedures
	write_procedures();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		// Write packages
		BURP_verbose(336);	// msg 336 writing packages
		write_packages();
	}

	// Now go back and write all data

	for (burp_rel* relation = tdgbl->relations; relation; relation = relation->rel_next)
	{
		put(tdgbl, (UCHAR) rec_relation_data);
		PUT_TEXT(att_relation_name, relation->rel_name);
		put(tdgbl, att_end);

		if (!(relation->rel_flags & REL_view) && !(relation->rel_flags & REL_external))
		{
			put_index(relation);
			if (!(tdgbl->gbl_sw_meta || tdgbl->skipRelation(relation->rel_name)))
				put_data(relation);
		}

		put(tdgbl, (UCHAR) rec_relation_end);
	}

	// now for the new triggers in rdb$triggers
	BURP_verbose(159);
	// msg 159  writing triggers
	write_triggers();
	BURP_verbose(158);
	// msg 158 writing trigger messages
	write_trigger_messages();
	write_user_privileges();

	// Last, but not least, go back and add any access control lists

	BURP_verbose(347); // msg 347 writing security classes
	write_secclasses();

	// Write relation constraints
	BURP_verbose(206);
	// msg 206 writing relation constraints
	write_rel_constraints();

	// Write referential constraints
	BURP_verbose(209);
	// msg 209 writing referential constraints
	write_ref_constraints();

	// Write check constraints
	BURP_verbose(210);
	// msg 210 writing check constraints
	write_check_constraints();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL9)
	{
		// Write SQL roles
		BURP_verbose(248);
		// msg 248 writing SQL roles
		write_sql_roles();
	}

	if (tdgbl->runtimeODS >= DB_VERSION_DDL11)
	{
		// Write names mapping
		BURP_verbose(296);
		// msg 296 writing mapping
		write_mapping();
	}

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		// Write database creators
		write_db_creators();
	}

	if (tdgbl->runtimeODS >= DB_VERSION_DDL13)
	{
		// Write publications
		BURP_verbose(396);	// msg 396 writing publications

		write_publications();
		write_pub_tables();
	}

	// Finish up

	put(tdgbl, (UCHAR) rec_end);
	FB_UINT64 cumul_count = MVOL_fini_write();
	tdgbl->action->act_action = ACT_backup_fini;
	BURP_verbose(176, SafeArg() << cumul_count);
	// msg 176 closing file, committing, and finishing.  %ld bytes written

	/*COMMIT;*/
	{
	fbTrans->commit(fbStatus);
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS))
	   fbTrans = 0;;
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	if (gds_trans)
		/*COMMIT gds_trans;*/
		{
		gds_trans->commit(fbStatus);
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS))
		   gds_trans = 0;;
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	if (tdgbl->gbl_stat_flags)
		BURP_verbose(369);
	// msg 369 total statistics

	/*FINISH*/
	{
	if (DB)
	   DB->detach(fbStatus);
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS))
	   DB = 0;;
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	return FINI_OK;
}

namespace // unnamed, private
{

void compress(const UCHAR* data, ULONG length)
{
/**************************************
 *
 *	c o m p r e s s
 *
 **************************************
 *
 * Functional description
 *	Write out data in compressed form.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	const UCHAR* p = data;
	const UCHAR* end = p + length;
	const UCHAR* q = NULL;

	while (p < end)
	{
		for (q = p + 2; q < end && (q[-2] != q[-1] || q[-1] != q[0]); q++)
			;
		ULONG run = (q < end) ? q - p - 2 : end - p;
		if (run)
		{
			for (; run > 127; run -= 127)
			{
				USHORT len = 127;
				put(tdgbl, (UCHAR) len);
				p = put_block(tdgbl, p, len);
			}
			if (run)
			{
				put(tdgbl, (UCHAR) run);
				p = put_block(tdgbl, p, run);
			}
		}
		for (q = p; q < end && *q == *p; q++)
			;
		if ((run = q - p) != 0)
		{
			for (; run > 127; run -= 127)
			{
				put(tdgbl, (UCHAR) (-127));
				put(tdgbl, (UCHAR) (*p));
			}
			if (run)
			{
				put(tdgbl, (UCHAR) (-run));
				put(tdgbl, (UCHAR) (*p));
			}
			p = q;
		}
	}
}


int copy( const TEXT* from, TEXT* to, ULONG size_len)
{
/**************************************
 *
 *	c o p y
 *
 **************************************
 *
 * Functional description
 *	Copy a blank or null terminated string into a null terminated
 *	string. It assumes there's enough room in the target.
 *
 **************************************/

	const ULONG len = (ULONG) MISC_symbol_length(from, size_len);

	memcpy(to, from, len);
	to[len] = '\0';

	return (int) len;
}


void general_on_error()
{
/**************************************
 *
 *	g e n e r a l _ o n _ e r r o r
 *
 **************************************
 *
 * Functional description
 *	Handle any general ON_ERROR clause during backup.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	BURP_print_status(true, isc_status);
	BURP_abort();
}


burp_fld* get_fields( burp_rel* relation)
{
   struct fb_758_struct {
          ISC_QUAD fb_759;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD fb_760;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD fb_761;	/* RDB$COMPUTED_BLR */
          char  fb_762 [128];	/* RDB$EDIT_STRING */
          ISC_QUAD fb_763;	/* RDB$QUERY_HEADER */
          ISC_QUAD fb_764;	/* RDB$DESCRIPTION */
          short fb_765;	/* fbUtility */
          short fb_766;	/* gds__null_flag */
          short fb_767;	/* RDB$COLLATION_ID */
          short fb_768;	/* gds__null_flag */
          short fb_769;	/* RDB$CHARACTER_SET_ID */
          short fb_770;	/* gds__null_flag */
          short fb_771;	/* gds__null_flag */
          short fb_772;	/* gds__null_flag */
          short fb_773;	/* RDB$NULL_FLAG */
          short fb_774;	/* RDB$DIMENSIONS */
          short fb_775;	/* RDB$SYSTEM_FLAG */
          short fb_776;	/* gds__null_flag */
          short fb_777;	/* RDB$UPDATE_FLAG */
          short fb_778;	/* RDB$VIEW_CONTEXT */
          short fb_779;	/* gds__null_flag */
          short fb_780;	/* RDB$FIELD_POSITION */
          short fb_781;	/* gds__null_flag */
          short fb_782;	/* gds__null_flag */
          short fb_783;	/* RDB$FIELD_ID */
          short fb_784;	/* RDB$FIELD_SCALE */
          short fb_785;	/* RDB$FIELD_LENGTH */
          short fb_786;	/* RDB$FIELD_SUB_TYPE */
          short fb_787;	/* RDB$FIELD_TYPE */
          char  fb_788 [253];	/* RDB$FIELD_NAME */
          char  fb_789 [253];	/* RDB$FIELD_SOURCE */
          char  fb_790 [253];	/* RDB$BASE_FIELD */
          char  fb_791 [253];	/* RDB$QUERY_NAME */
          char  fb_792 [253];	/* RDB$COMPLEX_NAME */
          char  fb_793 [253];	/* RDB$SECURITY_CLASS */
   } fb_758;
   struct fb_756_struct {
          char  fb_757 [253];	/* RDB$RELATION_NAME */
   } fb_756;
   struct fb_797_struct {
          ISC_QUAD fb_798;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD fb_799;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD fb_800;	/* RDB$COMPUTED_BLR */
          char  fb_801 [128];	/* RDB$EDIT_STRING */
          ISC_QUAD fb_802;	/* RDB$QUERY_HEADER */
          ISC_QUAD fb_803;	/* RDB$DESCRIPTION */
          short fb_804;	/* fbUtility */
          short fb_805;	/* RDB$IDENTITY_TYPE */
          short fb_806;	/* gds__null_flag */
          short fb_807;	/* gds__null_flag */
          short fb_808;	/* RDB$COLLATION_ID */
          short fb_809;	/* gds__null_flag */
          short fb_810;	/* RDB$CHARACTER_SET_ID */
          short fb_811;	/* gds__null_flag */
          short fb_812;	/* gds__null_flag */
          short fb_813;	/* gds__null_flag */
          short fb_814;	/* RDB$NULL_FLAG */
          short fb_815;	/* RDB$DIMENSIONS */
          short fb_816;	/* RDB$SYSTEM_FLAG */
          short fb_817;	/* gds__null_flag */
          short fb_818;	/* RDB$UPDATE_FLAG */
          short fb_819;	/* RDB$VIEW_CONTEXT */
          short fb_820;	/* gds__null_flag */
          short fb_821;	/* RDB$FIELD_POSITION */
          short fb_822;	/* gds__null_flag */
          short fb_823;	/* gds__null_flag */
          short fb_824;	/* RDB$FIELD_ID */
          short fb_825;	/* RDB$FIELD_SCALE */
          short fb_826;	/* RDB$FIELD_LENGTH */
          short fb_827;	/* RDB$FIELD_SUB_TYPE */
          short fb_828;	/* RDB$FIELD_TYPE */
          char  fb_829 [253];	/* RDB$FIELD_NAME */
          char  fb_830 [253];	/* RDB$FIELD_SOURCE */
          char  fb_831 [253];	/* RDB$BASE_FIELD */
          char  fb_832 [253];	/* RDB$QUERY_NAME */
          char  fb_833 [253];	/* RDB$COMPLEX_NAME */
          char  fb_834 [253];	/* RDB$SECURITY_CLASS */
          char  fb_835 [253];	/* RDB$GENERATOR_NAME */
   } fb_797;
   struct fb_795_struct {
          char  fb_796 [253];	/* RDB$RELATION_NAME */
   } fb_795;
/**************************************
 *
 *	g e t _ f i e l d s
 *
 **************************************
 *
 * Functional description
 *	Get fields for a relation.  Test
 *	capabilities and get system specific
 *
 **************************************/
	burp_fld* field;
	ISC_QUAD* blob_id;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	USHORT count = 1;

	Firebird::HalfStaticArray<burp_fld*, 16> field_list;

	// if we have all capabilities, use the first request to get the
	// most performance out of the latest engine; if we don't
	// have one of the capabilities we must use the second set of
	// requests--this requires more code but it is well worth it
	// for the performance benefits, especially remotely--deej

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_get_fields_req_handle1)
			X IN RDB$RELATION_FIELDS CROSS
			Y IN RDB$FIELDS WITH
			X.RDB$FIELD_SOURCE = Y.RDB$FIELD_NAME AND
			X.RDB$RELATION_NAME EQ relation->rel_name*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!tdgbl->handles_get_fields_req_handle1 && DB)
		      tdgbl->handles_get_fields_req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_794), fb_794);
		   isc_vtov ((const char*) relation->rel_name, (char*) fb_795.fb_796, 253);
		   if (tdgbl->handles_get_fields_req_handle1)
		      tdgbl->handles_get_fields_req_handle1->startAndSend(fbStatus, fbTrans, 0, 0, 253, CAST_CONST_MSG(&fb_795));
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { tdgbl->handles_get_fields_req_handle1->release(); tdgbl->handles_get_fields_req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   tdgbl->handles_get_fields_req_handle1->receive (fbStatus, 0, 1, 1989, CAST_MSG(&fb_797));
		   if (!fb_797.fb_804 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
		{
			field = (burp_fld*) BURP_alloc_zero(sizeof(burp_fld));
			field->fld_number = count++;
			field->fld_type = /*Y.RDB$FIELD_TYPE*/
					  fb_797.fb_828;
			field->fld_sub_type = /*Y.RDB$FIELD_SUB_TYPE*/
					      fb_797.fb_827;
			field->fld_length = /*Y.RDB$FIELD_LENGTH*/
					    fb_797.fb_826;
			field->fld_scale = /*Y.RDB$FIELD_SCALE*/
					   fb_797.fb_825;
			field->fld_id = /*X.RDB$FIELD_ID*/
					fb_797.fb_824;

			if (!/*X.RDB$DESCRIPTION.NULL*/
			     fb_797.fb_823)
			{
				blob_id = &/*X.RDB$DESCRIPTION*/
					   fb_797.fb_803;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high)
					field->fld_description = /*X.RDB$DESCRIPTION*/
								 fb_797.fb_803;
			}

			if (!/*X.RDB$QUERY_HEADER.NULL*/
			     fb_797.fb_822)
			{
				blob_id = &/*X.RDB$QUERY_HEADER*/
					   fb_797.fb_802;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high)
					field->fld_query_header = /*X.RDB$QUERY_HEADER*/
								  fb_797.fb_802;
			}

			if (/*X.RDB$FIELD_POSITION.NULL*/
			    fb_797.fb_820)
				field->fld_flags |= FLD_position_missing;
			else
				field->fld_position = /*X.RDB$FIELD_POSITION*/
						      fb_797.fb_821;
			field->fld_view_context = /*X.RDB$VIEW_CONTEXT*/
						  fb_797.fb_819;
			if (/*X.RDB$UPDATE_FLAG.NULL*/
			    fb_797.fb_817)
				field->fld_flags |= FLD_update_missing;
			else
				field->fld_update_flag = /*X.RDB$UPDATE_FLAG*/
							 fb_797.fb_818;

			COPY (/*X.RDB$FIELD_NAME*/
			      fb_797.fb_829, field->fld_name);
			COPY (/*X.RDB$FIELD_SOURCE*/
			      fb_797.fb_830, field->fld_source);
			COPY (/*X.RDB$BASE_FIELD*/
			      fb_797.fb_831, field->fld_base);
			COPY (/*X.RDB$QUERY_NAME*/
			      fb_797.fb_832, field->fld_query_name);
			COPY (/*X.RDB$EDIT_STRING*/
			      fb_797.fb_801, field->fld_edit_string);
			COPY (/*X.RDB$COMPLEX_NAME*/
			      fb_797.fb_833, field->fld_complex_name);

			blob_id = &/*Y.RDB$COMPUTED_BLR*/
				   fb_797.fb_800;

			if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
				field->fld_flags |= FLD_computed;
			}

			field->fld_system_flag = /*X.RDB$SYSTEM_FLAG*/
						 fb_797.fb_816;

			COPY (/*X.RDB$SECURITY_CLASS*/
			      fb_797.fb_834, field->fld_security_class);

			// use the fld_flags to mark the field as an array and
			// to differentiate it from other blobs

			if (/*Y.RDB$DIMENSIONS*/
			    fb_797.fb_815)
			{
				field->fld_flags |= FLD_array;
				field->fld_dimensions = /*Y.RDB$DIMENSIONS*/
							fb_797.fb_815;
				if (field->fld_dimensions < 0) {
					BURP_error_redirect (NULL, 52, SafeArg() << field->fld_name);
				}
				// msg 52 array dimension for field %s is invalid
				get_ranges (field);
			}

			if (!/*X.RDB$NULL_FLAG.NULL*/
			     fb_797.fb_813)
			{
				field->fld_null_flag = /*X.RDB$NULL_FLAG*/
						       fb_797.fb_814;
				field->fld_flags |= FLD_null_flag;
			}

			if (!/*X.RDB$DEFAULT_VALUE.NULL*/
			     fb_797.fb_812)
			{
				blob_id = &/*X.RDB$DEFAULT_VALUE*/
					   fb_797.fb_799;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
					field->fld_default_value = /*X.RDB$DEFAULT_VALUE*/
								   fb_797.fb_799;
				}
			}

			if (!/*X.RDB$DEFAULT_SOURCE.NULL*/
			     fb_797.fb_811)
			{
				blob_id = &/*X.RDB$DEFAULT_SOURCE*/
					   fb_797.fb_798;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
					field->fld_default_source = /*X.RDB$DEFAULT_SOURCE*/
								    fb_797.fb_798;
				}
			}

			if (!/*Y.RDB$CHARACTER_SET_ID.NULL*/
			     fb_797.fb_809)
			{
				field->fld_character_set_id = /*Y.RDB$CHARACTER_SET_ID*/
							      fb_797.fb_810;
				field->fld_flags |= FLD_charset_flag;
			}

			if (!/*X.RDB$COLLATION_ID.NULL*/
			     fb_797.fb_807)
			{
				field->fld_collation_id = /*X.RDB$COLLATION_ID*/
							  fb_797.fb_808;
				field->fld_flags |= FLD_collate_flag;
			}

			// ODS 12
			if (!/*X.RDB$GENERATOR_NAME.NULL*/
			     fb_797.fb_806)
			{
				COPY(/*X.RDB$GENERATOR_NAME*/
				     fb_797.fb_835, field->fld_generator);
				field->fld_identity_type = /*X.RDB$IDENTITY_TYPE*/
							   fb_797.fb_805;
			}

			field_list.add(field);
		}
		/*END_FOR*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_get_fields_req_handle1)
			X IN RDB$RELATION_FIELDS CROSS
			Y IN RDB$FIELDS WITH
			X.RDB$FIELD_SOURCE = Y.RDB$FIELD_NAME AND
			X.RDB$RELATION_NAME EQ relation->rel_name*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!tdgbl->handles_get_fields_req_handle1 && DB)
		      tdgbl->handles_get_fields_req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_755), fb_755);
		   isc_vtov ((const char*) relation->rel_name, (char*) fb_756.fb_757, 253);
		   if (tdgbl->handles_get_fields_req_handle1)
		      tdgbl->handles_get_fields_req_handle1->startAndSend(fbStatus, fbTrans, 0, 0, 253, CAST_CONST_MSG(&fb_756));
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { tdgbl->handles_get_fields_req_handle1->release(); tdgbl->handles_get_fields_req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   tdgbl->handles_get_fields_req_handle1->receive (fbStatus, 0, 1, 1732, CAST_MSG(&fb_758));
		   if (!fb_758.fb_765 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
		{
			field = (burp_fld*) BURP_alloc_zero(sizeof(burp_fld));
			field->fld_number = count++;
			field->fld_type = /*Y.RDB$FIELD_TYPE*/
					  fb_758.fb_787;
			field->fld_sub_type = /*Y.RDB$FIELD_SUB_TYPE*/
					      fb_758.fb_786;
			field->fld_length = /*Y.RDB$FIELD_LENGTH*/
					    fb_758.fb_785;
			field->fld_scale = /*Y.RDB$FIELD_SCALE*/
					   fb_758.fb_784;
			field->fld_id = /*X.RDB$FIELD_ID*/
					fb_758.fb_783;

			if (!/*X.RDB$DESCRIPTION.NULL*/
			     fb_758.fb_782)
			{
				blob_id = &/*X.RDB$DESCRIPTION*/
					   fb_758.fb_764;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high)
					field->fld_description = /*X.RDB$DESCRIPTION*/
								 fb_758.fb_764;
			}

			if (!/*X.RDB$QUERY_HEADER.NULL*/
			     fb_758.fb_781)
			{
				blob_id = &/*X.RDB$QUERY_HEADER*/
					   fb_758.fb_763;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high)
					field->fld_query_header = /*X.RDB$QUERY_HEADER*/
								  fb_758.fb_763;
			}

			if (/*X.RDB$FIELD_POSITION.NULL*/
			    fb_758.fb_779)
				field->fld_flags |= FLD_position_missing;
			else
				field->fld_position = /*X.RDB$FIELD_POSITION*/
						      fb_758.fb_780;
			field->fld_view_context = /*X.RDB$VIEW_CONTEXT*/
						  fb_758.fb_778;
			if (/*X.RDB$UPDATE_FLAG.NULL*/
			    fb_758.fb_776)
				field->fld_flags |= FLD_update_missing;
			else
				field->fld_update_flag = /*X.RDB$UPDATE_FLAG*/
							 fb_758.fb_777;

			COPY (/*X.RDB$FIELD_NAME*/
			      fb_758.fb_788, field->fld_name);
			COPY (/*X.RDB$FIELD_SOURCE*/
			      fb_758.fb_789, field->fld_source);
			COPY (/*X.RDB$BASE_FIELD*/
			      fb_758.fb_790, field->fld_base);
			COPY (/*X.RDB$QUERY_NAME*/
			      fb_758.fb_791, field->fld_query_name);
			COPY (/*X.RDB$EDIT_STRING*/
			      fb_758.fb_762, field->fld_edit_string);
			COPY (/*X.RDB$COMPLEX_NAME*/
			      fb_758.fb_792, field->fld_complex_name);

			blob_id = &/*Y.RDB$COMPUTED_BLR*/
				   fb_758.fb_761;

			if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
				field->fld_flags |= FLD_computed;
			}

			field->fld_system_flag = /*X.RDB$SYSTEM_FLAG*/
						 fb_758.fb_775;

			COPY (/*X.RDB$SECURITY_CLASS*/
			      fb_758.fb_793, field->fld_security_class);

			// use the fld_flags to mark the field as an array and
			// to differentiate it from other blobs

			if (/*Y.RDB$DIMENSIONS*/
			    fb_758.fb_774)
			{
				field->fld_flags |= FLD_array;
				field->fld_dimensions = /*Y.RDB$DIMENSIONS*/
							fb_758.fb_774;
				if (field->fld_dimensions < 0) {
					BURP_error_redirect (NULL, 52, SafeArg() << field->fld_name);
				}
				// msg 52 array dimension for field %s is invalid
				get_ranges (field);
			}

			if (!/*X.RDB$NULL_FLAG.NULL*/
			     fb_758.fb_772)
			{
				field->fld_null_flag = /*X.RDB$NULL_FLAG*/
						       fb_758.fb_773;
				field->fld_flags |= FLD_null_flag;
			}

			if (!/*X.RDB$DEFAULT_VALUE.NULL*/
			     fb_758.fb_771)
			{
				blob_id = &/*X.RDB$DEFAULT_VALUE*/
					   fb_758.fb_760;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
					field->fld_default_value = /*X.RDB$DEFAULT_VALUE*/
								   fb_758.fb_760;
				}
			}

			if (!/*X.RDB$DEFAULT_SOURCE.NULL*/
			     fb_758.fb_770)
			{
				blob_id = &/*X.RDB$DEFAULT_SOURCE*/
					   fb_758.fb_759;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
					field->fld_default_source = /*X.RDB$DEFAULT_SOURCE*/
								    fb_758.fb_759;
				}
			}

			if (!/*Y.RDB$CHARACTER_SET_ID.NULL*/
			     fb_758.fb_768)
			{
				field->fld_character_set_id = /*Y.RDB$CHARACTER_SET_ID*/
							      fb_758.fb_769;
				field->fld_flags |= FLD_charset_flag;
			}

			if (!/*X.RDB$COLLATION_ID.NULL*/
			     fb_758.fb_766)
			{
				field->fld_collation_id = /*X.RDB$COLLATION_ID*/
							  fb_758.fb_767;
				field->fld_flags |= FLD_collate_flag;
			}

			field_list.add(field);
		}
		/*END_FOR*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR*/
		   }
		}
	}

	burp_fld* fields = NULL;

	while (field_list.getCount())
	{
		field = field_list.pop();
		field->fld_next = fields;
		fields = field;
	}

	return fields;
}


SINT64 get_gen_id( const TEXT* name, SSHORT name_len)
{
/**************************************
 *
 *	g e t _ g e n _ i d
 *
 **************************************
 *
 * Functional description
 *	Read id for a generator;
 *
 **************************************/
	try
	{
		BurpGlobals* tdgbl = BurpGlobals::getSpecific();

		Firebird::string nm, sql;
		nm.assign(name, name_len);
		BURP_makeSymbol(tdgbl, nm);
		sql = "select first(1) gen_id(" + nm + ", 0) from rdb$database";

		BurpSql getGenerator(tdgbl, sql.c_str());
		FB_MESSAGE(GetGen, Firebird::ThrowWrapper, (FB_BIGINT, id));
		GetGen getGen(&tdgbl->throwStatus, Firebird::MasterInterfacePtr());

		getGenerator.singleSelect(tdgbl->tr_handle, &getGen);
		return getGen->id;
	}
	catch (const Firebird::FbException& ex)
	{
		Firebird::IStatus* st = ex.getStatus();

		// if there's no gen_id, never mind ...
		if (st->getErrors()[1] == isc_dsql_error)
			return 0;

		BURP_error_redirect(st, 25);
		// msg 25 Failed in put_blr_gen_id
	}
	return 0;	// warning silencer
}


void get_ranges( burp_fld* field)
{
   struct fb_750_struct {
          ISC_LONG fb_751;	/* RDB$UPPER_BOUND */
          ISC_LONG fb_752;	/* RDB$LOWER_BOUND */
          short fb_753;	/* fbUtility */
          short fb_754;	/* RDB$DIMENSION */
   } fb_750;
   struct fb_748_struct {
          char  fb_749 [253];	/* RDB$FIELD_NAME */
   } fb_748;
/**************************************
 *
 *	g e t _ r a n g e s
 *
 **************************************
 *
 * Functional description
 *	Fill in the range low and high bounds by reading
 *      the ranges in rdb$field_dimensions.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	SLONG* rp = field->fld_ranges;
	USHORT count = 0;

	// Get the array dimensions in the rdb$field_dimensions

	/*FOR (REQUEST_HANDLE tdgbl->handles_get_ranges_req_handle1)
		X IN RDB$FIELD_DIMENSIONS
		WITH X.RDB$FIELD_NAME EQ field->fld_source
		SORTED BY X.RDB$DIMENSION*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!tdgbl->handles_get_ranges_req_handle1 && DB)
	      tdgbl->handles_get_ranges_req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_747), fb_747);
	   isc_vtov ((const char*) field->fld_source, (char*) fb_748.fb_749, 253);
	   if (tdgbl->handles_get_ranges_req_handle1)
	      tdgbl->handles_get_ranges_req_handle1->startAndSend(fbStatus, fbTrans, 0, 0, 253, CAST_CONST_MSG(&fb_748));
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { tdgbl->handles_get_ranges_req_handle1->release(); tdgbl->handles_get_ranges_req_handle1 = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   tdgbl->handles_get_ranges_req_handle1->receive (fbStatus, 0, 1, 12, CAST_MSG(&fb_750));
	   if (!fb_750.fb_753 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

		if (count != /*X.RDB$DIMENSION*/
			     fb_750.fb_754)
			BURP_error_redirect (NULL, 52, SafeArg() << field->fld_name);
			// msg 52 array dimension for field %s is invalid
		*rp++ = /*X.RDB$LOWER_BOUND*/
			fb_750.fb_752;
		*rp++ = /*X.RDB$UPPER_BOUND*/
			fb_750.fb_751;
		count++;

	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	if (count != field->fld_dimensions)
		BURP_error_redirect(NULL, 52, SafeArg() << field->fld_name);
		// msg 52 array dimension for field %s is invalid
}


void put_array( burp_fld* field, burp_rel* relation, ISC_QUAD* blob_id)
{
/**************************************
 *
 *	p u t _ a r r a y
 *
 **************************************
 *
 * Functional description
 *	Write out an array.  If, however, it's null, don't even bother.
 *
 **************************************/
	SLONG range_buffer[16];	// enough for 16 dimensions
	UCHAR blr_buffer[200];		// enough for a sdl with 16 dimensions

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// If the array is null, don't store it.  It will be restored as null.

	if (!blob_id->gds_quad_low && !blob_id->gds_quad_high)
		return;

	lstring xdr_buffer;
	xdr_buffer.lstr_allocated = 0;
	xdr_buffer.lstr_address = NULL;

	UCHAR* blr = blr_buffer;
	const SLONG* const end_ranges = field->fld_ranges + 2 * field->fld_dimensions;

	USHORT field_length = field->fld_length;
	if (tdgbl->gbl_sw_transportable)
		xdr_buffer.lstr_length = field_length + 3;

	// build the sdl

	add_byte(blr, isc_sdl_version1);

	add_byte(blr, isc_sdl_struct);
	add_byte(blr, 1);

	add_byte(blr, field->fld_type);

	switch (field->fld_type)
	{
	case blr_short:
	case blr_long:
	case blr_quad:
	case blr_int64:
		add_byte(blr, field->fld_scale);
		break;
	case blr_text:
	case blr_varying:
		add_word(blr, field->fld_length);
		break;
	}

	if (field->fld_type == blr_varying)
		field_length += sizeof(USHORT);

	add_byte(blr, isc_sdl_rid);
	add_word(blr, relation->rel_id);
	add_byte(blr, isc_sdl_fid);
	add_word(blr, field->fld_id);

	USHORT count = 0;
	for (const SLONG* range = field->fld_ranges; range < end_ranges; range += 2, count++)
	{
		add_byte(blr, isc_sdl_do2);
		add_byte(blr, count);
		add_byte(blr, isc_sdl_long_integer);
		add_long(blr, range[0]);
		add_byte(blr, isc_sdl_long_integer);
		add_long(blr, range[1]);
	}

	add_byte(blr, isc_sdl_element);
	add_byte(blr, 1);
	add_byte(blr, isc_sdl_scalar);
	add_byte(blr, 0);
	add_byte(blr, field->fld_dimensions);

	for (count = 0; count < field->fld_dimensions; count++)
	{
		add_byte(blr, isc_sdl_variable);
		add_byte(blr, count);
	}

	add_byte(blr, isc_sdl_eoc);

#ifdef DEBUG
	if (debug_on)
		PRETTY_print_sdl(blr_buffer, NULL, NULL, 0);
#endif

	const USHORT blr_length = blr - blr_buffer;

	// compute the range size for each dimension = high_range - low_range

	ULONG slice_length = field_length;
	for (const SLONG* range = field->fld_ranges; range < end_ranges; range += 2)
	{
		slice_length *= (range[1] - range[0] + 1);
		if (tdgbl->gbl_sw_transportable)
			xdr_buffer.lstr_length *= (range[1] - range[0] + 1);
	}
	UCHAR* slice = BURP_alloc(slice_length);

	// allocate space for the XDR representation

	if (tdgbl->gbl_sw_transportable)
	{
		xdr_buffer.lstr_address = BURP_alloc(xdr_buffer.lstr_length);
		xdr_buffer.lstr_allocated = xdr_buffer.lstr_length;
	}

	FbLocalStatus status_vector;
	unsigned return_length = DB->getSlice(&status_vector, gds_trans, blob_id, blr_length, blr_buffer,
		0, nullptr,		// parameters for subset of an array handling
		slice_length, slice);

	if (!status_vector.isSuccess())
	{
		BURP_print(false, 81, field->fld_name);
		// msg 81 error accessing blob field %s -- continuing
		BURP_print_status(false, &status_vector);
#ifdef DEBUG
		PRETTY_print_sdl(blr_buffer, NULL, NULL, 0);
#endif
		// CVC: At this point I would expected calls to deallocate memory
		// See the end of this function.
		BURP_free(slice);
		if (xdr_buffer.lstr_allocated)
			BURP_free(xdr_buffer.lstr_address);
		return;
	}

	if (return_length != slice_length)
	{
		// Ugh.  The full array wasn't returned.  We must recompute the top
		// element to backup.

		SLONG returned_elements = (return_length / field_length) - 1;

		SLONG* returned_range = range_buffer;
		const SLONG* range = end_ranges - 2;
		for (int i1 = 0, i3 = 0;
			 range >= field->fld_ranges; range -= 2, returned_range++, i1++)
		{
			int divisor = 1;
			for (int i2 = (2 * (i1 + 1) + 1); i2 <= field->fld_dimensions * 2; i2 += 2)
			{
				divisor *= (field->fld_ranges[i2] - field->fld_ranges[i2 - 1] + 1);
			}
			*returned_range = (returned_elements - 1) / divisor + field->fld_ranges[i3];
			returned_elements -= (*returned_range - field->fld_ranges[i3]) * divisor;
			i3 += 2;
		}
	}

	put(tdgbl, (UCHAR) rec_array);
	put_int32(att_blob_field_number, field->fld_number);
	put_int32(att_array_dimensions, field->fld_dimensions);

	SLONG* returned_range = range_buffer;
	for (const SLONG* range = field->fld_ranges; range < end_ranges; range += 2, returned_range++)
	{
		put_int32(att_array_range_low, (int) range[0]);
		if (return_length == slice_length)
			put_int32(att_array_range_high, (int) range[1]);
		else
			put_int32(att_array_range_high, (int) *returned_range);
	}

	put(tdgbl, att_blob_data);
	put(tdgbl, (UCHAR) (return_length));
	put(tdgbl, (UCHAR) (return_length >> 8));
	put(tdgbl, (UCHAR) (return_length >> 16));
	put(tdgbl, (UCHAR) (return_length >> 24));

	if (return_length)
	{
		const UCHAR* p;
		if (tdgbl->gbl_sw_transportable)
		{
			lstring xdr_slice;
			xdr_slice.lstr_allocated = xdr_slice.lstr_length = return_length;
			xdr_slice.lstr_address = slice;
			return_length = CAN_slice(&xdr_buffer, &xdr_slice, true, blr_buffer);
			put(tdgbl, att_xdr_array);
			put(tdgbl, (UCHAR) (return_length));
			put(tdgbl, (UCHAR) (return_length >> 8));
			put(tdgbl, (UCHAR) (return_length >> 16));
			put(tdgbl, (UCHAR) (return_length >> 24));
			p = xdr_buffer.lstr_address;
		}
		else
			p = slice;
		put_block(tdgbl, p, return_length);
	}

	BURP_free(slice);
	if (xdr_buffer.lstr_allocated)
		BURP_free(xdr_buffer.lstr_address);
}


void put_asciz( const att_type attribute, const TEXT* string)
{
/**************************************
 *
 *	p u t _ a s c i z
 *
 **************************************
 *
 * Functional description
 *	Write an attribute starting with a null terminated string.
 *	Currently it's only called by write_database with the db's name as param.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	ULONG len = static_cast<ULONG>(strlen(string));
	// CVC: We'll have to ensure that length < MAX_FILE_NAME_SIZE.
	// For now, we'll truncate.
	// We can't honor operating systems that allow longer file names.
	if (len >= MAX_FILE_NAME_SIZE)
	{
		BURP_print(true, 343, SafeArg() << int(attribute) << "put_asciz()" << (MAX_FILE_NAME_SIZE - 1));
		// msg 343: text for attribute @1 is too large in @2, truncating to @3 bytes
		len = MAX_FILE_NAME_SIZE - 1;
	}

	put(tdgbl, attribute);
	put(tdgbl, (UCHAR) len);
	if (len)
		put_block(tdgbl, (const UCHAR*) string, len);
}


void put_blob( burp_fld* field, ISC_QUAD& blob_id)
{
/**************************************
 *
 *	p u t _ b l o b
 *
 **************************************
 *
 * Functional description
 *	Write out a blob.  If, however, it's null, don't even bother.
 *	This is for user data blobs.
 *
 **************************************/
	FbLocalStatus status_vector;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// If the blob is null, don't store it.  It will be restored as null.

	if (BlobWrapper::blobIsNull(blob_id))
		return;

	// Open the blob and get it's vital statistics

	BlobWrapper blob(&status_vector);

	if (!blob.open(DB, gds_trans, blob_id))
	{
		BURP_print(false, 81, field->fld_name);
		// msg 81 error accessing blob field %s -- continuing
		BURP_print_status(false, &status_vector);
		return;
	}

	UCHAR blob_info[32];
	if (!blob.getInfo(sizeof(blob_items), blob_items, sizeof(blob_info), blob_info))
	{
		BURP_error_redirect(&status_vector, 20);
		// msg 20 isc_blob_info failed
	}

	put(tdgbl, (UCHAR) rec_blob);
	put_int32(att_blob_field_number, field->fld_number);

	ULONG segments = 0, total_length = 0;
	USHORT max_segment = 0;
	int blob_type = 0; // 0 - segmented, 1 - stream
	const UCHAR* p = blob_info;

	UCHAR item;
	while ((item = *p++) != isc_info_end)
	{
		const USHORT l = gds__vax_integer(p, 2);
		p += 2;
		const ULONG n = gds__vax_integer(p, l);
		p += l;
		switch (item)
		{
		case isc_info_blob_max_segment:
			max_segment = n;
			break;

		case isc_info_blob_type:
			blob_type = n;
			break;

		case isc_info_blob_num_segments:
			segments = n;
			break;

		case isc_info_blob_total_length:
			total_length = n;
			break;

		default:
			BURP_error_redirect(NULL, 21, SafeArg() << int(item));
			// msg 21 don't understand blob info item %ld
		}
	}

	// NS: Compute number of chunks we are going to write for stream blob based
	// on total blob length and maximum segment size. This way we tend to
	// preserve maximum internal segment size over backup/restore. I'm not sure
	// this is beneficial, but let's do it for the moment instead of inventing
	// our own chunk size. Note, the number of segments returned by information
	// call for stream blob is always unreliable, even for zero-length blobs
	if (blob_type == 1)
	{
		if (total_length != 0)
			segments = (total_length + max_segment - 1) / max_segment;
		else
			segments = 0;
	}

	put_int32(att_blob_max_segment, max_segment);
	put_int32(att_blob_number_segments, segments);
	put_int32(att_blob_type, blob_type);

	// Allocate a buffer large enough for the largest segment and start grinding.
	UCHAR static_buffer[1024];
	UCHAR* buffer;
	if (!max_segment || max_segment <= sizeof(static_buffer))
		buffer = static_buffer;
	else
		buffer = BURP_alloc(max_segment);

	put(tdgbl, att_blob_data);

	while (segments > 0)
	{
		FB_SIZE_T segment_length;
		if (!blob.getSegment(max_segment, buffer, segment_length))
		{
			BURP_error_redirect(&status_vector, 22);
			// msg 22 isc_get_segment failed
		}

		put(tdgbl, (UCHAR) (segment_length));
		put(tdgbl, (UCHAR) (segment_length >> 8));
		if (segment_length)
		{
			put_block(tdgbl, buffer, segment_length);
		}
		--segments;
	}

	if (!blob.close())
		BURP_error_redirect(&status_vector, 23);
		// msg 23 isc_close_blob failed

	if (buffer != static_buffer)
		BURP_free(buffer);
}


bool put_blr_blob( att_type attribute, ISC_QUAD& blob_id)
{
/**************************************
 *
 *	p u t _ b l r _ b l o b
 *
 **************************************
 *
 * Functional description
 *	Write out a blr blob, if present.  Otherwise do nothing.
 *	Return true if the blob was present, false otherwise.
 *
 **************************************/
	FbLocalStatus status_vector;
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// If the blob is null, don't store it.  It will be restored as null.

	if (BlobWrapper::blobIsNull(blob_id))
		return false;

	// Open the blob and get it's vital statistics

	BlobWrapper blob(&status_vector);

	if (!blob.open(DB, gds_trans, blob_id))
	{
		BURP_error_redirect(&status_vector, 24);
		// msg 24 isc_open_blob failed
	}

	UCHAR blob_info[32];
	if (!blob.getInfo(sizeof(blr_items), blr_items, sizeof(blob_info), blob_info))
	{
		BURP_error_redirect(&status_vector, 20);
		// msg 20 isc_blob_info failed
	}

	ULONG length = 0;
	USHORT max_segment = 0;
	const UCHAR* p = blob_info;
	UCHAR item;

	while ((item = *p++) != isc_info_end)
	{
		const USHORT l = isc_vax_integer((const char*) p, 2);
		p += 2;
		const ULONG n = isc_vax_integer((const char*) p, l);
		p += l;
		switch (item)
		{
		case isc_info_blob_max_segment:
			max_segment = n;
			break;

		case isc_info_blob_total_length:
			length = n;
			break;

		default:
			BURP_print(true, 79, SafeArg() << int(item));
			// msg 79 don't understand blob info item %ld
			if (!blob.close())
				BURP_error_redirect(&status_vector, 23);
				// msg 23 isc_close_blob failed
			return false;
		}
	}

	if (!length)
	{
		if (!blob.close())
			BURP_error_redirect(&status_vector, 23);
			// msg 23 isc_close_blob failed
		return false;
	}

	// Rdb sometimes gets the length messed up

	if (length < max_segment)
		length = max_segment;

	put_int32(attribute, (int) length);

	// Allocate a buffer large enough for the largest segment and start grinding.

	UCHAR static_buffer[1024];
	UCHAR* buffer;
	if (!max_segment || max_segment <= sizeof(static_buffer))
		buffer = static_buffer;
	else
		buffer = BURP_alloc(max_segment);

	// The old code didn't accept isc_segment so we check it.
	FB_SIZE_T segment_length;
	while (blob.getSegment(max_segment, buffer, segment_length) && !blob.getCode())
	{
		if (segment_length)
		{
			put_block(tdgbl, buffer, segment_length);
		}
	}

	if (!blob.close())
	{
		BURP_error_redirect(&status_vector, 23);
		// msg 23 isc_close_blob failed
	}

	if (buffer != static_buffer)
		BURP_free(buffer);

	return true;
}


void put_data(burp_rel* relation)
{
/**************************************
 *
 *	p u t _ d a t a
 *
 **************************************
 *
 * Functional description
 *	Write relation meta-data and data.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();
	USHORT field_count = 1;	// eof field
	burp_fld* field;
	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		if (!(field->fld_flags & FLD_computed))
		{
			field_count += 2;
		}
	}
	fb_assert(field_count > 0 && field_count * 9 > 0 && field_count * 9 + 200 > 0);

	// Time to generate blr to fetch data.  Make sure we allocate a BLR buffer
	// large enough to handle the per field overhead
	UCHAR* const blr_buffer = BURP_alloc(200 + field_count * 9);
	UCHAR* blr = blr_buffer;
	add_byte(blr, blr_version4);
	add_byte(blr, blr_begin);
	add_byte(blr, blr_message);
	add_byte(blr, 0);				// Message number
	add_word(blr, field_count);		// Number of fields, counting eof

	RCRD_OFFSET offset = 0;
	USHORT count = 0;   // This is param count.

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		if (field->fld_flags & FLD_computed)
			continue;
		SSHORT alignment = 4;
		FLD_LENGTH length = field->fld_length;
		SSHORT dtype = field->fld_type;
		if (field->fld_flags & FLD_array)
		{
			dtype = blr_blob;
			length = 8;
		}
		switch (dtype)
		{
		case blr_text:
			alignment = type_alignments[dtype_text];
			add_byte(blr, field->fld_type);
			add_word(blr, field->fld_length);
			break;

		case blr_varying:
			alignment = type_alignments[dtype_varying];
			add_byte(blr, field->fld_type);
			add_word(blr, field->fld_length);
			length += sizeof(USHORT);
			break;

		case blr_short:
			alignment = type_alignments[dtype_short];
			add_byte(blr, field->fld_type);
			add_byte(blr, field->fld_scale);
			break;

		case blr_long:
			alignment = type_alignments[dtype_long];
			add_byte(blr, field->fld_type);
			add_byte(blr, field->fld_scale);
			break;

		case blr_quad:
			alignment = type_alignments[dtype_quad];
			add_byte(blr, field->fld_type);
			add_byte(blr, field->fld_scale);
			break;

		case blr_int64:
			alignment = type_alignments[dtype_int64];
			add_byte(blr, field->fld_type);
			add_byte(blr, field->fld_scale);
			break;

		case blr_int128:
			alignment = type_alignments[dtype_int128];
			add_byte(blr, field->fld_type);
			add_byte(blr, field->fld_scale);
			break;

		case blr_double:
			alignment = type_alignments[dtype_double];
			add_byte(blr, field->fld_type);
			break;

		case blr_timestamp:
			alignment = type_alignments[dtype_timestamp];
			add_byte(blr, field->fld_type);
			break;

		case blr_timestamp_tz:
			alignment = type_alignments[dtype_timestamp_tz];
			add_byte(blr, field->fld_type);
			break;

		case blr_sql_time:
			alignment = type_alignments[dtype_sql_time];
			add_byte(blr, field->fld_type);
			break;

		case blr_sql_time_tz:
			alignment = type_alignments[dtype_sql_time_tz];
			add_byte(blr, field->fld_type);
			break;

		case blr_sql_date:
			alignment = type_alignments[dtype_sql_date];
			add_byte(blr, field->fld_type);
			break;

		case blr_float:
			alignment = type_alignments[dtype_real];
			add_byte(blr, field->fld_type);
			break;

		case blr_blob:
			alignment = type_alignments[dtype_blob];
			add_byte(blr, blr_quad);
			add_byte(blr, 0);
			break;

		case blr_bool:
			alignment = type_alignments[dtype_boolean];
			add_byte(blr, field->fld_type);
			break;

		case blr_dec64:
		case blr_dec128:
			alignment = type_alignments[dtype];
			add_byte(blr, field->fld_type);
			break;

		default:
			BURP_error_redirect(NULL, 26, SafeArg() << field->fld_type);
			// msg 26 datatype %ld not understood
			break;
		}

		if (alignment)
			offset = FB_ALIGN(offset, alignment);

		field->fld_offset = offset;
		field->fld_parameter = count++;
		offset += length;
	}

	// Next, build fields for null flags

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		if (field->fld_flags & FLD_computed)
			continue;
		add_byte(blr, blr_short);
		add_byte(blr, 0);
		offset = FB_ALIGN(offset, sizeof(SSHORT));
		field->fld_missing_parameter = count++;
		offset += sizeof(SSHORT);
	}

	// Finally, make up an EOF field

	add_byte(blr, blr_short);			// eof field
	add_byte(blr, 0);					// scale for eof field
	SSHORT eof_parameter = count++;
	RCRD_OFFSET record_length = offset;
	RCRD_OFFSET eof_offset = FB_ALIGN(offset, sizeof(SSHORT));
	// To be used later for the buffer size to receive data
	const RCRD_LENGTH length = (RCRD_LENGTH) (eof_offset + sizeof(SSHORT));

	// Build FOR loop, body, and eof handler

	add_byte(blr, blr_for);
	add_byte(blr, blr_rse);
	add_byte(blr, 1);					// count of relations
	add_byte(blr, blr_rid);
	add_word(blr, relation->rel_id);
	add_byte(blr, 0);					// context variable
	add_byte(blr, blr_end);

	add_byte(blr, blr_send);
	add_byte(blr, 0);
	add_byte(blr, blr_begin);
	add_byte(blr, blr_assignment);
	add_byte(blr, blr_literal);
	add_byte(blr, blr_short);
	add_byte(blr, 0);
	add_word(blr, 1);
	add_byte(blr, blr_parameter);
	add_byte(blr, 0);
	add_word(blr, eof_parameter);

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		if (field->fld_flags & FLD_computed)
			continue;
		add_byte(blr, blr_assignment);
		add_byte(blr, blr_fid);
		add_byte(blr, 0);
		add_word(blr, field->fld_id);
		add_byte(blr, blr_parameter2);
		add_byte(blr, 0);
		add_word(blr, field->fld_parameter);
		add_word(blr, field->fld_missing_parameter);
	}

	add_byte(blr, blr_end);

	add_byte(blr, blr_send);
	add_byte(blr, 0);
	add_byte(blr, blr_assignment);
	add_byte(blr, blr_literal);
	add_byte(blr, blr_short);
	add_byte(blr, 0);
	add_word(blr, 0);
	add_byte(blr, blr_parameter);
	add_byte(blr, 0);
	add_word(blr, eof_parameter);

	add_byte(blr, blr_end);
	add_byte(blr, blr_eoc);

	unsigned blr_length = blr - blr_buffer;

#ifdef DEBUG
	if (debug_on)
		fb_print_blr(blr_buffer, blr_length, NULL, NULL, 0);
#endif

	// Compile request

	FbLocalStatus status_vector;
	Firebird::IRequest* request = DB->compileRequest(&status_vector, blr_length, blr_buffer);
	if (!status_vector.isSuccess())
	{
		BURP_error_redirect(&status_vector, 27);
		// msg 27 isc_compile_request failed
		fb_print_blr(blr_buffer, blr_length, NULL, NULL, 0);
	}

	BURP_free(blr_buffer);

	BURP_verbose(142, relation->rel_name);
	// msg 142  writing data for relation %s

	request->start(&status_vector, gds_trans, 0);
	if (!status_vector.isSuccess())
	{
		BURP_error_redirect(&status_vector, 28);
		// msg 28 isc_start_request failed
	}

	// Here is the crux of the problem -- writing data.  All this work
	// for the following small loop.

	UCHAR* buffer = BURP_alloc(length);
	SSHORT* eof = (SSHORT *) (buffer + eof_offset);

	// the XDR representation may be even fluffier
	lstring xdr_buffer;
	if (tdgbl->gbl_sw_transportable)
	{
		xdr_buffer.lstr_length = xdr_buffer.lstr_allocated = length + count * 3;
		xdr_buffer.lstr_address = BURP_alloc(xdr_buffer.lstr_length);
	}
	else
		xdr_buffer.lstr_address = NULL;

	FB_UINT64 records = 0;
	while (true)
	{
		request->receive(&status_vector, 0, 0, length, buffer);
		if (!status_vector.isSuccess())
		{
			BURP_error_redirect(&status_vector, 29);
			// msg 29 isc_receive failed
		}
		if (!*eof)
			break;
		records++;
		// Verbose records
		if ((records % tdgbl->verboseInterval) == 0)
			BURP_verbose(108, SafeArg() << records);

		put(tdgbl, (UCHAR) rec_data);
		put_int32(att_data_length, record_length);
		const UCHAR* p;
		if (tdgbl->gbl_sw_transportable)
		{
			record_length = CAN_encode_decode(relation, &xdr_buffer, buffer, true);
			put_int32(att_xdr_length, record_length);
			p = xdr_buffer.lstr_address;
		}
		else
			p = buffer;
		put(tdgbl, att_data_data);
		if (tdgbl->gbl_sw_compress)
			compress(p, record_length);
		else if (record_length)
			put_block(tdgbl, p, record_length);

		// Look for any blobs to write

		for (field = relation->rel_fields; field; field = field->fld_next)
		{
			if (field->fld_type == blr_blob &&
				!(field->fld_flags & FLD_computed) && !(field->fld_flags & FLD_array))
			{
				put_blob(field, *(ISC_QUAD*) (buffer + field->fld_offset));
			}
		}

		// Look for any array to write
		// we got back the blob_id for the array from isc_receive in the second param.
		for (field = relation->rel_fields; field; field = field->fld_next)
		{
			if (field->fld_flags & FLD_array)
			{
				put_array(field, relation, (ISC_QUAD*) (buffer + field->fld_offset));
			}
		}
	}

	BURP_free(buffer);

	if (xdr_buffer.lstr_address)
		BURP_free(xdr_buffer.lstr_address);

	BURP_verbose(108, SafeArg() << records);
	// msg 108 %ld records written

	request->free(&status_vector);
	if (!status_vector.isSuccess())
		BURP_error_redirect(&status_vector, 30);
	// msg 30 isc_release_request failed
}


void put_index( burp_rel* relation)
{
   struct fb_721_struct {
          short fb_722;	/* fbUtility */
          char  fb_723 [253];	/* RDB$FIELD_NAME */
   } fb_721;
   struct fb_719_struct {
          char  fb_720 [253];	/* RDB$INDEX_NAME */
   } fb_719;
   struct fb_728_struct {
          short fb_729;	/* fbUtility */
   } fb_728;
   struct fb_725_struct {
          char  fb_726 [253];	/* RDB$INDEX_NAME */
          char  fb_727 [253];	/* RDB$RELATION_NAME */
   } fb_725;
   struct fb_733_struct {
          ISC_QUAD fb_734;	/* RDB$EXPRESSION_BLR */
          ISC_QUAD fb_735;	/* RDB$EXPRESSION_SOURCE */
          ISC_QUAD fb_736;	/* RDB$DESCRIPTION */
          short fb_737;	/* fbUtility */
          short fb_738;	/* gds__null_flag */
          short fb_739;	/* gds__null_flag */
          short fb_740;	/* gds__null_flag */
          short fb_741;	/* RDB$INDEX_TYPE */
          short fb_742;	/* RDB$UNIQUE_FLAG */
          short fb_743;	/* RDB$INDEX_INACTIVE */
          short fb_744;	/* RDB$SEGMENT_COUNT */
          char  fb_745 [253];	/* RDB$INDEX_NAME */
          char  fb_746 [253];	/* RDB$FOREIGN_KEY */
   } fb_733;
   struct fb_731_struct {
          char  fb_732 [253];	/* RDB$RELATION_NAME */
   } fb_731;
/**************************************
 *
 *	p u t _ i n d e x
 *
 **************************************
 *
 * Functional description
 *	Write information about an index.  First
 *	check that all the segments of the
 *	index exist.
 *
 **************************************/
	ULONG count;
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// if we have all capabilities, use the first request to get the
	// most performance out of the latest engine; if we don't
	// have one of the capabilities we must use the second set of
	// requests--this requires more code but it is well worth it
	// for the performance benefits, especially remotely--deej

	/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle1)
		X IN RDB$INDICES WITH
		X.RDB$RELATION_NAME EQ relation->rel_name*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!tdgbl->handles_put_index_req_handle1 && DB)
	      tdgbl->handles_put_index_req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_730), fb_730);
	   isc_vtov ((const char*) relation->rel_name, (char*) fb_731.fb_732, 253);
	   if (tdgbl->handles_put_index_req_handle1)
	      tdgbl->handles_put_index_req_handle1->startAndSend(fbStatus, fbTrans, 0, 0, 253, CAST_CONST_MSG(&fb_731));
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { tdgbl->handles_put_index_req_handle1->release(); tdgbl->handles_put_index_req_handle1 = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   tdgbl->handles_put_index_req_handle1->receive (fbStatus, 0, 1, 546, CAST_MSG(&fb_733));
	   if (!fb_733.fb_737 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

		count = 0;
		/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle2)
			I_S IN RDB$INDEX_SEGMENTS CROSS
			RFR IN RDB$RELATION_FIELDS WITH
			I_S.RDB$FIELD_NAME = RFR.RDB$FIELD_NAME AND
			I_S.RDB$INDEX_NAME = X.RDB$INDEX_NAME AND
			RFR.RDB$RELATION_NAME = relation->rel_name*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!tdgbl->handles_put_index_req_handle2 && DB)
		      tdgbl->handles_put_index_req_handle2 = DB->compileRequest(fbStatus, sizeof(fb_724), fb_724);
		   isc_vtov ((const char*) fb_733.fb_745, (char*) fb_725.fb_726, 253);
		   isc_vtov ((const char*) relation->rel_name, (char*) fb_725.fb_727, 253);
		   if (tdgbl->handles_put_index_req_handle2)
		      tdgbl->handles_put_index_req_handle2->startAndSend(fbStatus, fbTrans, 0, 0, 506, CAST_CONST_MSG(&fb_725));
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { tdgbl->handles_put_index_req_handle2->release(); tdgbl->handles_put_index_req_handle2 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   tdgbl->handles_put_index_req_handle2->receive (fbStatus, 0, 1, 2, CAST_MSG(&fb_728));
		   if (!fb_728.fb_729 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			count++;

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}

		if (count != (ULONG) /*X.RDB$SEGMENT_COUNT*/
				     fb_733.fb_744)
		{
			BURP_print(true, 180, SafeArg() << /*X.RDB$INDEX_NAME*/
							   fb_733.fb_745 << count << /*X.RDB$SEGMENT_COUNT*/
	     fb_733.fb_744);
			continue;
		}

		put(tdgbl, rec_index);
		const ULONG l = PUT_TEXT (att_index_name, /*X.RDB$INDEX_NAME*/
							  fb_733.fb_745);
		MISC_terminate (/*X.RDB$INDEX_NAME*/
				fb_733.fb_745, temp, l, sizeof(temp));
		BURP_verbose (151, temp);
		// msg 151 writing index %s
		put_int32 (att_segment_count, /*X.RDB$SEGMENT_COUNT*/
					      fb_733.fb_744);
		put_int32 (att_index_inactive, /*X.RDB$INDEX_INACTIVE*/
					       fb_733.fb_743);
		put_int32 (att_index_unique_flag, /*X.RDB$UNIQUE_FLAG*/
						  fb_733.fb_742);

		/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle5)
			Y IN RDB$INDEX_SEGMENTS WITH
			Y.RDB$INDEX_NAME EQ X.RDB$INDEX_NAME
			SORTED BY Y.RDB$FIELD_POSITION*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!tdgbl->handles_put_index_req_handle5 && DB)
		      tdgbl->handles_put_index_req_handle5 = DB->compileRequest(fbStatus, sizeof(fb_718), fb_718);
		   isc_vtov ((const char*) fb_733.fb_745, (char*) fb_719.fb_720, 253);
		   if (tdgbl->handles_put_index_req_handle5)
		      tdgbl->handles_put_index_req_handle5->startAndSend(fbStatus, fbTrans, 0, 0, 253, CAST_CONST_MSG(&fb_719));
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { tdgbl->handles_put_index_req_handle5->release(); tdgbl->handles_put_index_req_handle5 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   tdgbl->handles_put_index_req_handle5->receive (fbStatus, 0, 1, 255, CAST_MSG(&fb_721));
		   if (!fb_721.fb_722 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			PUT_TEXT (att_index_field_name, /*Y.RDB$FIELD_NAME*/
							fb_721.fb_723);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}

		put_source_blob (att_index_description2, att_index_description, /*X.RDB$DESCRIPTION*/
										fb_733.fb_736);
		put_int32 (att_index_type, /*X.RDB$INDEX_TYPE*/
					   fb_733.fb_741);

		if (!/*X.RDB$EXPRESSION_SOURCE.NULL*/
		     fb_733.fb_740)
			put_source_blob (att_index_expression_source, att_index_expression_source,
							 /*X.RDB$EXPRESSION_SOURCE*/
							 fb_733.fb_735);
		if (!/*X.RDB$EXPRESSION_BLR.NULL*/
		     fb_733.fb_739)
			put_blr_blob (att_index_expression_blr, /*X.RDB$EXPRESSION_BLR*/
								fb_733.fb_734);
		if (!/*X.RDB$FOREIGN_KEY.NULL*/
		     fb_733.fb_738)
			PUT_TEXT (att_index_foreign_key, /*X.RDB$FOREIGN_KEY*/
							 fb_733.fb_746);
		put(tdgbl, att_end);

	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}
}


int put_message( att_type attribute, att_type attribute2, const TEXT* text, const ULONG length)
{
/**************************************
 *
 *	p u t _ m e s s a g e
 *
 **************************************
 *
 * Functional description
 *	Write a variable length text string, with embedded
 *      blanks.  Same as put_text but handles embedded blanks.
 * CVC: As v6 time, put_text handles embedded blanks, too!
 * The only difference is that put_text's length is UCHAR, so
 * in theory put_message can handle much longer input and it's
 * used for exception and trigger's messages (plus update/delete
 * rules for FKs and constraint types, where it's irrelevant
 * which function of the two you use).
 * CVC: Responsability for FKs and constraint types transferred to put_text.
 * This function tries to maintain backwards compatibility where possible.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	ULONG len = 0;
	for (const TEXT* p = text; *p && len < length; p++)
		len++;

	const ULONG newlen = MIN(len, length);
	fb_assert(newlen <= MAX_USHORT);

	// If we can store the message using the old format, we do it.
	if (newlen <= MAX_UCHAR)
	{
		put(tdgbl, attribute);
		put(tdgbl, (UCHAR) newlen);
	}
	else if (newlen <= MAX_USHORT)
	{
		if (!attribute2) // In theory, this never happens, because the caller knows what it's doing.
			BURP_error(314, true);
		put(tdgbl, attribute2);
		USHORT vax_value = (USHORT) newlen;
		vax_value = (USHORT) gds__vax_integer((const UCHAR*) &vax_value, sizeof(vax_value));
		put_block(tdgbl, (const UCHAR*) &vax_value, sizeof(vax_value));
	}
	else
		BURP_error(315, true);

	if (newlen)
		put_block(tdgbl, reinterpret_cast<const UCHAR*>(text), newlen);

	return newlen;
}


void put_int32( att_type attribute, SLONG value)
{
/**************************************
 *
 *	p u t _ i n t 3 2
 *
 **************************************
 *
 * Functional description
 *	Write a numeric value as an attribute.  The number is represented
 *	low byte first, high byte last, as in VAX.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	const SLONG vax_value = (SLONG) isc_vax_integer((const char*) &value, sizeof(value));

	put(tdgbl, attribute);
	put(tdgbl, (UCHAR) sizeof(value));
	put_block(tdgbl, (const UCHAR*) &vax_value, sizeof(vax_value));
}


void put_int64(att_type attribute, SINT64 value)
{
/**************************************
 *
 *	p u t _ i n t 6 4
 *
 **************************************
 *
 * Functional description
 *	Write a 64-bit numeric value as an attribute.
 *      The number is represented low byte first, high byte last, as in VAX.
 *      This function is just like put_int32, except that it handles an
 *      INT64 value, while put_int32 handles a 32-bit value.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	const FB_UINT64 le_value = (FB_UINT64) isc_portable_integer((const UCHAR*) &value, sizeof(value));

	put(tdgbl, attribute);
	put(tdgbl, (UCHAR) sizeof(value));
	put_block(tdgbl, (const UCHAR*) &le_value, sizeof(le_value));
}


void put_boolean(att_type attribute, const FB_BOOLEAN value)
{
/**************************************
 *
 *	p u t _ b o o l e a n
 *
 **************************************
 *
 * Functional description
 *	Write a FB_BOOLEAN value as an attribute.
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	put(tdgbl, attribute);
	put(tdgbl, value ? 1u : 0u);
}


void put_relation( burp_rel* relation)
{
   struct fb_701_struct {
          short fb_702;	/* fbUtility */
          short fb_703;	/* RDB$VIEW_CONTEXT */
          char  fb_704 [253];	/* RDB$RELATION_NAME */
          char  fb_705 [1021];	/* RDB$CONTEXT_NAME */
   } fb_701;
   struct fb_699_struct {
          char  fb_700 [253];	/* RDB$VIEW_NAME */
   } fb_699;
   struct fb_709_struct {
          short fb_710;	/* fbUtility */
          short fb_711;	/* gds__null_flag */
          short fb_712;	/* gds__null_flag */
          short fb_713;	/* RDB$CONTEXT_TYPE */
          short fb_714;	/* RDB$VIEW_CONTEXT */
          char  fb_715 [253];	/* RDB$RELATION_NAME */
          char  fb_716 [1021];	/* RDB$CONTEXT_NAME */
          char  fb_717 [253];	/* RDB$PACKAGE_NAME */
   } fb_709;
   struct fb_707_struct {
          char  fb_708 [253];	/* RDB$VIEW_NAME */
   } fb_707;
/**************************************
 *
 * 	p u t _ r e l a t i o n
 *
 **************************************
 *
 * Functional description
 *	Write relation meta-data and data.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// Write local field information.  This is made slightly more complicated
	// by the requirement that computational fields be aligned.

	burp_fld* aligned = NULL;
	burp_fld* unaligned = NULL;
	burp_fld* aligned4 = NULL;
	burp_fld* aligned8 = NULL;

	burp_fld* fields = get_fields(relation);

	// sort the list of fields into three lists, depending on alignment
	burp_fld* field;
	for (field = fields; field = fields;)
	{
		fields = field->fld_next;
		USHORT l = field->fld_length;
		if (field->fld_type == blr_varying)
			l += sizeof(USHORT);
		if (!(l & 7))
		{
			field->fld_next = aligned8;
			aligned8 = field;
		}
		else if (!(l & 3))
		{
			field->fld_next = aligned4;
			aligned4 = field;
		}
		else if (l & 1)
		{
			field->fld_next = unaligned;
			unaligned = field;
		}
		else
		{
			field->fld_next = aligned;
			aligned = field;
		}
	}

	// Next, merge the aligned and unaligned sub-lists.  In the process,
	// re-create (approximately) the original order of the fields.  This is
	// not strictly required, but it certainly is polite.

	while (field = unaligned)
	{
		unaligned = field->fld_next;
		field->fld_next = relation->rel_fields;
		relation->rel_fields = field;
	}

	while (field = aligned)
	{
		aligned = field->fld_next;
		field->fld_next = relation->rel_fields;
		relation->rel_fields = field;
	}

	while (field = aligned4)
	{
		aligned4 = field->fld_next;
		field->fld_next = relation->rel_fields;
		relation->rel_fields = field;
	}

	while (field = aligned8)
	{
		aligned8 = field->fld_next;
		field->fld_next = relation->rel_fields;
		relation->rel_fields = field;
	}

	// Now write the fields in what will become physical backup order

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		put(tdgbl, (UCHAR) rec_field);
		const USHORT l = PUT_TEXT(att_field_name, field->fld_name);
		MISC_terminate(field->fld_name, temp, l, sizeof(temp));
		BURP_verbose(144, temp);
		// msg 144  writing field %s
		PUT_TEXT(att_field_source, field->fld_source);
		if (field->fld_query_name[0])
			PUT_TEXT(att_field_query_name, field->fld_query_name);
		if (field->fld_complex_name[0])
			PUT_TEXT(att_field_complex_name, field->fld_complex_name);
		if (field->fld_edit_string[0])
			PUT_TEXT(att_field_edit_string, field->fld_edit_string);
		put_source_blob(att_field_description2, att_field_description, field->fld_description);
		put_source_blob(att_field_query_header, att_field_query_header, field->fld_query_header);
		if (field->fld_security_class[0])
			PUT_TEXT(att_field_security_class, field->fld_security_class);
		if (!(field->fld_flags & FLD_position_missing))
			put_int32(att_field_position, field->fld_position);
		put_int32(att_field_type, field->fld_type);
		put_int32(att_field_length, field->fld_length);
		put_int32(att_field_sub_type, field->fld_sub_type);
		put_int32(att_field_scale, field->fld_scale);
		put_int32(att_field_number, field->fld_number);
		put_int32(att_field_system_flag, field->fld_system_flag);
		if (!(field->fld_flags & FLD_update_missing))
			put_int32(att_field_update_flag, field->fld_update_flag);
		if (field->fld_flags & FLD_null_flag)
			put_int32(att_field_null_flag, field->fld_null_flag);
		if (field->fld_flags & FLD_charset_flag)
			put_int32(att_field_character_set, field->fld_character_set_id);
		if (field->fld_flags & FLD_collate_flag)
			put_int32(att_field_collation_id, field->fld_collation_id);
		put_blr_blob(att_field_default_value, field->fld_default_value);
		put_source_blob(att_field_default_source, att_field_default_source, field->fld_default_source);

		if (relation->rel_flags & REL_view)
		{
			put_int32(att_view_context, field->fld_view_context);
			if (field->fld_base[0])
				PUT_TEXT(att_base_field, field->fld_base);
		}

		if (field->fld_flags & FLD_computed)
			put_int32(att_field_computed_flag, TRUE);

		if (field->fld_flags & FLD_array)
		{
			put_int32(att_field_dimensions, field->fld_dimensions);
			const SLONG* rp = field->fld_ranges;
			for (USHORT n = field->fld_dimensions; n; rp += 2, n--)
			{
				put_int32(att_field_range_low, *rp);
				put_int32(att_field_range_high, *(rp + 1));
			}
		}

		if (field->fld_generator[0])
		{
			PUT_TEXT(att_field_generator_name, field->fld_generator);
			put_int32(att_field_identity_type, field->fld_identity_type);
		}

		put(tdgbl, att_end);
	}

	// Write out view relations (if a view, of course)

	if (relation->rel_flags & REL_view)
	{
		if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
		{
			/*FOR (REQUEST_HANDLE tdgbl->handles_put_relation_req_handle1)
				X IN RDB$VIEW_RELATIONS WITH X.RDB$VIEW_NAME EQ relation->rel_name*/
			{
			for (int retries = 0; retries < 2; ++retries)
			   {
			   if (!tdgbl->handles_put_relation_req_handle1 && DB)
			      tdgbl->handles_put_relation_req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_706), fb_706);
			   isc_vtov ((const char*) relation->rel_name, (char*) fb_707.fb_708, 253);
			   if (tdgbl->handles_put_relation_req_handle1)
			      tdgbl->handles_put_relation_req_handle1->startAndSend(fbStatus, fbTrans, 0, 0, 253, CAST_CONST_MSG(&fb_707));
			   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { tdgbl->handles_put_relation_req_handle1->release(); tdgbl->handles_put_relation_req_handle1 = NULL; }
			   else break;
			   }
			if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
			while (1)
			   {
			   tdgbl->handles_put_relation_req_handle1->receive (fbStatus, 0, 1, 1537, CAST_MSG(&fb_709));
			   if (!fb_709.fb_710 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
				put(tdgbl, rec_view);
				PUT_TEXT (att_view_relation_name, /*X.RDB$RELATION_NAME*/
								  fb_709.fb_715);
				put_int32 (att_view_context_id, /*X.RDB$VIEW_CONTEXT*/
								fb_709.fb_714);
				// Will need PUT_MESSAGE if this field grows to more than 255 bytes.
				PUT_TEXT (att_view_context_name, /*X.RDB$CONTEXT_NAME*/
								 fb_709.fb_716);
				if (!/*X.RDB$CONTEXT_TYPE.NULL*/
				     fb_709.fb_712)
					put_int32(att_view_context_type, /*X.RDB$CONTEXT_TYPE*/
									 fb_709.fb_713);
				if (!/*X.RDB$PACKAGE_NAME.NULL*/
				     fb_709.fb_711)
					PUT_TEXT(att_view_context_package, /*X.RDB$PACKAGE_NAME*/
									   fb_709.fb_717);
				put(tdgbl, att_end);
			/*END_FOR*/
			   }
			   };
			/*ON_ERROR*/
			if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
			   {
				general_on_error();
			/*END_ERROR;*/
			   }
			}
		}
		else
		{
			/*FOR (REQUEST_HANDLE tdgbl->handles_put_relation_req_handle1)
				X IN RDB$VIEW_RELATIONS WITH X.RDB$VIEW_NAME EQ relation->rel_name*/
			{
			for (int retries = 0; retries < 2; ++retries)
			   {
			   if (!tdgbl->handles_put_relation_req_handle1 && DB)
			      tdgbl->handles_put_relation_req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_698), fb_698);
			   isc_vtov ((const char*) relation->rel_name, (char*) fb_699.fb_700, 253);
			   if (tdgbl->handles_put_relation_req_handle1)
			      tdgbl->handles_put_relation_req_handle1->startAndSend(fbStatus, fbTrans, 0, 0, 253, CAST_CONST_MSG(&fb_699));
			   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { tdgbl->handles_put_relation_req_handle1->release(); tdgbl->handles_put_relation_req_handle1 = NULL; }
			   else break;
			   }
			if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
			while (1)
			   {
			   tdgbl->handles_put_relation_req_handle1->receive (fbStatus, 0, 1, 1278, CAST_MSG(&fb_701));
			   if (!fb_701.fb_702 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
				put(tdgbl, rec_view);
				PUT_TEXT (att_view_relation_name, /*X.RDB$RELATION_NAME*/
								  fb_701.fb_704);
				put_int32 (att_view_context_id, /*X.RDB$VIEW_CONTEXT*/
								fb_701.fb_703);
				PUT_TEXT (att_view_context_name, /*X.RDB$CONTEXT_NAME*/
								 fb_701.fb_705);
				put(tdgbl, att_end);
			/*END_FOR*/
			   }
			   };
			/*ON_ERROR*/
			if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
			   {
				general_on_error();
			/*END_ERROR;*/
			   }
			}
		}
	}
	put(tdgbl, (UCHAR) rec_relation_end);
}


bool put_source_blob(att_type attribute, att_type old_attribute, ISC_QUAD& blob_id)
{
/**************************************
 *
 *	p u t _ s o u r c e _ b l o b
 *
 **************************************
 *
 * Functional description
 *	Write out a source blob or query header if present.
 *	Return true is there was the blob was present, false otherwise.
 *	Include the NULL character to separate each segment.
 *
 **************************************/
	FbLocalStatus status_vector;
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// If the blob is null, don't store it.  It will be restored as null.

	if (BlobWrapper::blobIsNull(blob_id))
		return false;

	if (tdgbl->gbl_sw_old_descriptions && attribute != att_field_query_header)
		return put_blr_blob(old_attribute, blob_id);

	// Open the blob and get it's vital statistics

	BlobWrapper blob(&status_vector);

	if (!blob.open(DB, gds_trans, blob_id))
	{
		BURP_error_redirect(&status_vector, 24);
		// msg 24 isc_open_blob failed
	}

	UCHAR blob_info[48];
	if (!blob.getInfo(sizeof(source_items), source_items, sizeof(blob_info), blob_info))
	{
		BURP_error_redirect(&status_vector, 20);
		// msg 20 isc_blob_info failed
	}

	ULONG length = 0;
	ULONG num_seg = 0;
	USHORT max_segment = 0;
	const UCHAR* p = blob_info;
	UCHAR item;

	while ((item = *p++) != isc_info_end)
	{
		const USHORT l = gds__vax_integer(p, 2);
		p += 2;
		const ULONG n = gds__vax_integer(p, l);
		p += l;
		switch (item)
		{
		case isc_info_blob_max_segment:
			max_segment = n;
			break;

		case isc_info_blob_total_length:
			length = n;
			break;

		case isc_info_blob_num_segments:
			num_seg = n;
			break;

		default:
			BURP_print(true, 79, SafeArg() << int(item));
			// msg 79 don't understand blob info item %ld
			if (!blob.close())
			{
				BURP_error_redirect(&status_vector, 23);
				// msg 23 isc_close_blob failed
			}
			return false;
		}
	}

	if (!length)
	{
		if (!blob.close())
		{
			BURP_error_redirect(&status_vector, 23);
			// msg 23 isc_close_blob failed
		}
		return false;
	}

	// Rdb sometimes gets the length messed up

	if (length < max_segment)
		length = max_segment;

	fb_assert(FB_UINT64(length) + num_seg <= FB_UINT64(MAX_ULONG));
	put_int32(attribute, length + num_seg);

	// Allocate a buffer large enough for the largest segment and start grinding.

	UCHAR static_buffer[1024];
	UCHAR* buffer;
	if (!max_segment || max_segment <= sizeof(static_buffer))
		buffer = static_buffer;
	else
		buffer = BURP_alloc(max_segment);

	// The old code didn't accept isc_segment so we check it.
	FB_SIZE_T segment_length;
	while (blob.getSegment(max_segment, buffer, segment_length) && !blob.getCode())
	{
		if (segment_length)
		{
			put_block(tdgbl, buffer, segment_length);
		}
		put(tdgbl, (UCHAR) 0);
	}

	if (!blob.close())
		BURP_error_redirect(&status_vector, 23);
	// msg 23 isc_close_blob failed

	if (buffer != static_buffer)
		BURP_free(buffer);

	return true;
}


int put_text( att_type attribute, const TEXT* text, SSHORT size_len)
{
/**************************************
 *
 *	p u t _ t e x t
 *
 **************************************
 *
 * Functional description
 * Write a variable length text string, with embedded spaces.
 * Truncate trailing spaces.
 * Now this routine does not truncate trailing spaces, 3-2002 MOD
 * transfering changes from fb1, I believe this is to do with problems
 * with quoted names and embedded spaces.
 * CVC: This routine does trailing spaces truncation, but correctly.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	SSHORT l = (SSHORT) MISC_symbol_length(text, (ULONG) size_len);
	fb_assert(l <= MAX_UCHAR);
	if (l > MAX_UCHAR)
	{
		BURP_print(true, 343, SafeArg() << int(attribute) << "put_text()" << MAX_UCHAR);
		// msg 343: text for attribute @1 is too large in @2, truncating to @3 bytes
		l = MAX_UCHAR;
	}

	put(tdgbl, attribute);
	put(tdgbl, (UCHAR) l);
	if (l)
		put_block(tdgbl, (const UCHAR*) text, l);

	return l;
}


void write_character_sets()
{
   struct fb_662_struct {
          ISC_QUAD fb_663;	/* RDB$DESCRIPTION */
          ISC_LONG fb_664;	/* RDB$NUMBER_OF_CHARACTERS */
          short fb_665;	/* fbUtility */
          short fb_666;	/* RDB$BYTES_PER_CHARACTER */
          short fb_667;	/* gds__null_flag */
          short fb_668;	/* gds__null_flag */
          short fb_669;	/* RDB$CHARACTER_SET_ID */
          short fb_670;	/* gds__null_flag */
          short fb_671;	/* gds__null_flag */
          short fb_672;	/* gds__null_flag */
          short fb_673;	/* RDB$SYSTEM_FLAG */
          char  fb_674 [253];	/* RDB$CHARACTER_SET_NAME */
          char  fb_675 [253];	/* RDB$FORM_OF_USE */
          char  fb_676 [253];	/* RDB$FUNCTION_NAME */
          char  fb_677 [253];	/* RDB$DEFAULT_COLLATE_NAME */
   } fb_662;
   struct fb_679_struct {
          ISC_QUAD fb_680;	/* RDB$DESCRIPTION */
          ISC_LONG fb_681;	/* RDB$NUMBER_OF_CHARACTERS */
          short fb_682;	/* fbUtility */
          short fb_683;	/* gds__null_flag */
          short fb_684;	/* gds__null_flag */
          short fb_685;	/* RDB$BYTES_PER_CHARACTER */
          short fb_686;	/* gds__null_flag */
          short fb_687;	/* gds__null_flag */
          short fb_688;	/* RDB$CHARACTER_SET_ID */
          short fb_689;	/* gds__null_flag */
          short fb_690;	/* gds__null_flag */
          short fb_691;	/* RDB$SYSTEM_FLAG */
          char  fb_692 [253];	/* RDB$CHARACTER_SET_NAME */
          char  fb_693 [253];	/* RDB$FORM_OF_USE */
          char  fb_694 [253];	/* RDB$FUNCTION_NAME */
          char  fb_695 [253];	/* RDB$SECURITY_CLASS */
          char  fb_696 [253];	/* RDB$OWNER_NAME */
          char  fb_697 [253];	/* RDB$DEFAULT_COLLATE_NAME */
   } fb_679;
/**************************************
 *
 *	w r i t e _ c h a r a c t e r _ s e t s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each user defined character set.
 *
 **************************************/
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$CHARACTER_SETS
			WITH X.RDB$SYSTEM_FLAG NE 1 OR
				 X.RDB$DEFAULT_COLLATE_NAME NE X.RDB$CHARACTER_SET_NAME*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_678), fb_678);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 1550, CAST_MSG(&fb_679));
		   if (!fb_679.fb_682 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			put(tdgbl, rec_charset);
			PUT_TEXT (att_charset_name, /*X.RDB$CHARACTER_SET_NAME*/
						    fb_679.fb_692);

			if (/*X.RDB$SYSTEM_FLAG*/
			    fb_679.fb_691 != 1)
			{
				if (!/*X.RDB$FORM_OF_USE.NULL*/
				     fb_679.fb_690)
					PUT_TEXT (att_charset_form, /*X.RDB$FORM_OF_USE*/
								    fb_679.fb_693);
				if (!/*X.RDB$NUMBER_OF_CHARACTERS.NULL*/
				     fb_679.fb_689)
					put_int32 (att_charset_numchar, /*X.RDB$NUMBER_OF_CHARACTERS*/
									fb_679.fb_681);
				put_int32 (att_charset_id, /*X.RDB$CHARACTER_SET_ID*/
							   fb_679.fb_688);
				if (/*X.RDB$SYSTEM_FLAG*/
				    fb_679.fb_691)
					put_int32 (att_charset_sysflag, /*X.RDB$SYSTEM_FLAG*/
									fb_679.fb_691);
				if (!/*X.RDB$DESCRIPTION.NULL*/
				     fb_679.fb_687)
				{
					put_source_blob (att_charset_description, att_charset_description, /*X.RDB$DESCRIPTION*/
													   fb_679.fb_680);
				}
				if (!/*X.RDB$FUNCTION_NAME.NULL*/
				     fb_679.fb_686)
					PUT_TEXT (att_charset_funct, /*X.RDB$FUNCTION_NAME*/
								     fb_679.fb_694);
				put_int32 (att_charset_bytes_char, /*X.RDB$BYTES_PER_CHARACTER*/
								   fb_679.fb_685);

				// CVC: Not sure if this code goes inside or outside this "if" block.
				if (!/*X.RDB$SECURITY_CLASS.NULL*/
				     fb_679.fb_684)
					PUT_TEXT(att_charset_security_class, /*X.RDB$SECURITY_CLASS*/
									     fb_679.fb_695);
				if (!/*X.RDB$OWNER_NAME.NULL*/
				     fb_679.fb_683)
					PUT_TEXT(att_charset_owner_name, /*X.RDB$OWNER_NAME*/
									 fb_679.fb_696);
			}

			PUT_TEXT (att_charset_coll, /*X.RDB$DEFAULT_COLLATE_NAME*/
						    fb_679.fb_697);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$CHARACTER_SETS
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1 OR
				 X.RDB$DEFAULT_COLLATE_NAME NE X.RDB$CHARACTER_SET_NAME*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_661), fb_661);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 1042, CAST_MSG(&fb_662));
		   if (!fb_662.fb_665 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			put(tdgbl, rec_charset);
			PUT_TEXT (att_charset_name, /*X.RDB$CHARACTER_SET_NAME*/
						    fb_662.fb_674);

			if (/*X.RDB$SYSTEM_FLAG.NULL*/
			    fb_662.fb_672 || /*X.RDB$SYSTEM_FLAG*/
    fb_662.fb_673 != 1)
			{
				if (!/*X.RDB$FORM_OF_USE.NULL*/
				     fb_662.fb_671)
					PUT_TEXT (att_charset_form, /*X.RDB$FORM_OF_USE*/
								    fb_662.fb_675);
				if (!/*X.RDB$NUMBER_OF_CHARACTERS.NULL*/
				     fb_662.fb_670)
					put_int32 (att_charset_numchar, /*X.RDB$NUMBER_OF_CHARACTERS*/
									fb_662.fb_664);
				put_int32 (att_charset_id, /*X.RDB$CHARACTER_SET_ID*/
							   fb_662.fb_669);
				if (/*X.RDB$SYSTEM_FLAG*/
				    fb_662.fb_673)
					put_int32 (att_charset_sysflag, /*X.RDB$SYSTEM_FLAG*/
									fb_662.fb_673);
				if (!/*X.RDB$DESCRIPTION.NULL*/
				     fb_662.fb_668)
				{
					put_source_blob (att_charset_description, att_charset_description, /*X.RDB$DESCRIPTION*/
													   fb_662.fb_663);
				}
				if (!/*X.RDB$FUNCTION_NAME.NULL*/
				     fb_662.fb_667)
					PUT_TEXT (att_charset_funct, /*X.RDB$FUNCTION_NAME*/
								     fb_662.fb_676);
				put_int32 (att_charset_bytes_char, /*X.RDB$BYTES_PER_CHARACTER*/
								   fb_662.fb_666);
			}

			PUT_TEXT (att_charset_coll, /*X.RDB$DEFAULT_COLLATE_NAME*/
						    fb_662.fb_677);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_check_constraints()
{
   struct fb_656_struct {
          short fb_657;	/* fbUtility */
          short fb_658;	/* gds__null_flag */
          char  fb_659 [253];	/* RDB$CONSTRAINT_NAME */
          char  fb_660 [253];	/* RDB$TRIGGER_NAME */
   } fb_656;
/**************************************
 *
 *	w r i t e _ c h e c k _ c o n s t r a i n t s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each check constraint.
 *
 **************************************/
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$CHECK_CONSTRAINTS*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle1 && DB)
	      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_655), fb_655);
	   if (req_handle1)
	      req_handle1->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle1->receive (fbStatus, 0, 0, 510, CAST_MSG(&fb_656));
	   if (!fb_656.fb_657 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
		put(tdgbl, rec_chk_constraint);

		PUT_TEXT (att_chk_constraint_name, /*X.RDB$CONSTRAINT_NAME*/
						   fb_656.fb_659);
		if (!/*X.RDB$TRIGGER_NAME.NULL*/
		     fb_656.fb_658)
			PUT_TEXT (att_chk_trigger_name, /*X.RDB$TRIGGER_NAME*/
							fb_656.fb_660);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_collations()
{
   struct fb_608_struct {
          ISC_QUAD fb_609;	/* RDB$DESCRIPTION */
          short fb_610;	/* fbUtility */
          short fb_611;	/* gds__null_flag */
          short fb_612;	/* gds__null_flag */
          short fb_613;	/* RDB$SYSTEM_FLAG */
          short fb_614;	/* RDB$COLLATION_ATTRIBUTES */
          short fb_615;	/* RDB$CHARACTER_SET_ID */
          short fb_616;	/* RDB$COLLATION_ID */
          char  fb_617 [253];	/* RDB$COLLATION_NAME */
          char  fb_618 [253];	/* RDB$FUNCTION_NAME */
   } fb_608;
   struct fb_620_struct {
          ISC_QUAD fb_621;	/* RDB$SPECIFIC_ATTRIBUTES */
          ISC_QUAD fb_622;	/* RDB$DESCRIPTION */
          short fb_623;	/* fbUtility */
          short fb_624;	/* gds__null_flag */
          short fb_625;	/* gds__null_flag */
          short fb_626;	/* gds__null_flag */
          short fb_627;	/* gds__null_flag */
          short fb_628;	/* RDB$SYSTEM_FLAG */
          short fb_629;	/* RDB$COLLATION_ATTRIBUTES */
          short fb_630;	/* RDB$CHARACTER_SET_ID */
          short fb_631;	/* RDB$COLLATION_ID */
          char  fb_632 [253];	/* RDB$COLLATION_NAME */
          char  fb_633 [253];	/* RDB$FUNCTION_NAME */
          char  fb_634 [253];	/* RDB$BASE_COLLATION_NAME */
   } fb_620;
   struct fb_636_struct {
          ISC_QUAD fb_637;	/* RDB$SPECIFIC_ATTRIBUTES */
          ISC_QUAD fb_638;	/* RDB$DESCRIPTION */
          short fb_639;	/* fbUtility */
          short fb_640;	/* gds__null_flag */
          short fb_641;	/* gds__null_flag */
          short fb_642;	/* gds__null_flag */
          short fb_643;	/* gds__null_flag */
          short fb_644;	/* gds__null_flag */
          short fb_645;	/* gds__null_flag */
          short fb_646;	/* RDB$SYSTEM_FLAG */
          short fb_647;	/* RDB$COLLATION_ATTRIBUTES */
          short fb_648;	/* RDB$CHARACTER_SET_ID */
          short fb_649;	/* RDB$COLLATION_ID */
          char  fb_650 [253];	/* RDB$COLLATION_NAME */
          char  fb_651 [253];	/* RDB$FUNCTION_NAME */
          char  fb_652 [253];	/* RDB$BASE_COLLATION_NAME */
          char  fb_653 [253];	/* RDB$SECURITY_CLASS */
          char  fb_654 [253];	/* RDB$OWNER_NAME */
   } fb_636;
/**************************************
 *
 *	w r i t e _ c o l l a t i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each user defined collation
 *
 **************************************/
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$COLLATIONS WITH X.RDB$SYSTEM_FLAG NE 1*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_635), fb_635);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 1303, CAST_MSG(&fb_636));
		   if (!fb_636.fb_639 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			put(tdgbl, rec_collation);
			PUT_TEXT (att_coll_name, /*X.RDB$COLLATION_NAME*/
						 fb_636.fb_650);
			put_int32 (att_coll_id, /*X.RDB$COLLATION_ID*/
						fb_636.fb_649);
			put_int32 (att_coll_cs_id, /*X.RDB$CHARACTER_SET_ID*/
						   fb_636.fb_648);
			put_int32 (att_coll_attr, /*X.RDB$COLLATION_ATTRIBUTES*/
						  fb_636.fb_647);
			if (/*X.RDB$SYSTEM_FLAG*/
			    fb_636.fb_646)
				put_int32 (att_coll_sysflag, /*X.RDB$SYSTEM_FLAG*/
							     fb_636.fb_646);
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     fb_636.fb_645)
				put_source_blob (att_coll_description, att_coll_description, /*X.RDB$DESCRIPTION*/
											     fb_636.fb_638);
			if (!/*X.RDB$FUNCTION_NAME.NULL*/
			     fb_636.fb_644)
				PUT_TEXT (att_coll_funct, /*X.RDB$FUNCTION_NAME*/
							  fb_636.fb_651);
			if (!/*X.RDB$BASE_COLLATION_NAME.NULL*/
			     fb_636.fb_643)
				PUT_TEXT(att_coll_base_collation_name, /*X.RDB$BASE_COLLATION_NAME*/
								       fb_636.fb_652);
			if (!/*X.RDB$SPECIFIC_ATTRIBUTES.NULL*/
			     fb_636.fb_642)
				put_source_blob (att_coll_specific_attr, att_coll_specific_attr, /*X.RDB$SPECIFIC_ATTRIBUTES*/
												 fb_636.fb_637);

			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     fb_636.fb_641)
				PUT_TEXT(att_coll_security_class, /*X.RDB$SECURITY_CLASS*/
								  fb_636.fb_653);
			if (!/*X.RDB$OWNER_NAME.NULL*/
			     fb_636.fb_640)
				PUT_TEXT(att_coll_owner_name, /*X.RDB$OWNER_NAME*/
							      fb_636.fb_654);

			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else if (tdgbl->runtimeODS >= DB_VERSION_DDL11)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$COLLATIONS WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_619), fb_619);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 793, CAST_MSG(&fb_620));
		   if (!fb_620.fb_623 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			put(tdgbl, rec_collation);
			PUT_TEXT (att_coll_name, /*X.RDB$COLLATION_NAME*/
						 fb_620.fb_632);
			put_int32 (att_coll_id, /*X.RDB$COLLATION_ID*/
						fb_620.fb_631);
			put_int32 (att_coll_cs_id, /*X.RDB$CHARACTER_SET_ID*/
						   fb_620.fb_630);
			put_int32 (att_coll_attr, /*X.RDB$COLLATION_ATTRIBUTES*/
						  fb_620.fb_629);
			if (/*X.RDB$SYSTEM_FLAG*/
			    fb_620.fb_628)
				put_int32 (att_coll_sysflag, /*X.RDB$SYSTEM_FLAG*/
							     fb_620.fb_628);
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     fb_620.fb_627)
				put_source_blob (att_coll_description, att_coll_description, /*X.RDB$DESCRIPTION*/
											     fb_620.fb_622);
			if (!/*X.RDB$FUNCTION_NAME.NULL*/
			     fb_620.fb_626)
				PUT_TEXT (att_coll_funct, /*X.RDB$FUNCTION_NAME*/
							  fb_620.fb_633);
			if (!/*X.RDB$BASE_COLLATION_NAME.NULL*/
			     fb_620.fb_625)
				PUT_TEXT(att_coll_base_collation_name, /*X.RDB$BASE_COLLATION_NAME*/
								       fb_620.fb_634);
			if (!/*X.RDB$SPECIFIC_ATTRIBUTES.NULL*/
			     fb_620.fb_624)
				put_source_blob (att_coll_specific_attr, att_coll_specific_attr, /*X.RDB$SPECIFIC_ATTRIBUTES*/
												 fb_620.fb_621);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$COLLATIONS WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_607), fb_607);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 528, CAST_MSG(&fb_608));
		   if (!fb_608.fb_610 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			put(tdgbl, rec_collation);
			PUT_TEXT (att_coll_name, /*X.RDB$COLLATION_NAME*/
						 fb_608.fb_617);
			put_int32 (att_coll_id, /*X.RDB$COLLATION_ID*/
						fb_608.fb_616);
			put_int32 (att_coll_cs_id, /*X.RDB$CHARACTER_SET_ID*/
						   fb_608.fb_615);
			put_int32 (att_coll_attr, /*X.RDB$COLLATION_ATTRIBUTES*/
						  fb_608.fb_614);
			if (/*X.RDB$SYSTEM_FLAG*/
			    fb_608.fb_613)
				put_int32 (att_coll_sysflag, /*X.RDB$SYSTEM_FLAG*/
							     fb_608.fb_613);
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     fb_608.fb_612)
				put_source_blob (att_coll_description, att_coll_description, /*X.RDB$DESCRIPTION*/
											     fb_608.fb_609);
			if (!/*X.RDB$FUNCTION_NAME.NULL*/
			     fb_608.fb_611)
				PUT_TEXT (att_coll_funct, /*X.RDB$FUNCTION_NAME*/
							  fb_608.fb_618);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_database( const TEXT* dbb_file)
{
   struct fb_588_struct {
          ISC_QUAD fb_589;	/* RDB$DESCRIPTION */
          short fb_590;	/* fbUtility */
          short fb_591;	/* gds__null_flag */
          short fb_592;	/* gds__null_flag */
          char  fb_593 [253];	/* RDB$SECURITY_CLASS */
          char  fb_594 [253];	/* RDB$CHARACTER_SET_NAME */
   } fb_588;
   struct fb_596_struct {
          ISC_QUAD fb_597;	/* RDB$DESCRIPTION */
          ISC_LONG fb_598;	/* RDB$LINGER */
          short fb_599;	/* fbUtility */
          short fb_600;	/* gds__null_flag */
          short fb_601;	/* gds__null_flag */
          short fb_602;	/* gds__null_flag */
          short fb_603;	/* gds__null_flag */
          char  fb_604 [253];	/* RDB$SECURITY_CLASS */
          char  fb_605 [253];	/* RDB$CHARACTER_SET_NAME */
          FB_BOOLEAN fb_606;	/* RDB$SQL_SECURITY */
   } fb_596;
/**************************************
 *
 *	w r i t e _ d a t a b a s e
 *
 **************************************
 *
 * Functional description
 * 	write a physical database record and a
 *	logical database record in the burp file for
 *	the database itself.
 *
 **************************************/
	FbLocalStatus status_vector;
	UCHAR buffer[256];
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	put(tdgbl, (UCHAR) rec_physical_db);

	DB->getInfo(&status_vector, sizeof(db_info_items), db_info_items,
						  sizeof(buffer), buffer);
	if (!status_vector.isSuccess())
	{
		BURP_error_redirect(&status_vector, 31);
		// msg 31 isc_database_info failed
	}

	USHORT page_size = 0, forced_writes, no_reserve, db_read_only, replica_mode;
 	ULONG sweep_interval, page_buffers;
 	USHORT length = 0;
	for (const UCHAR* d = buffer; *d != isc_info_end; d += length)
	{
		const UCHAR item = *d++;
		length = (USHORT) gds__vax_integer(d, 2);
		d += 2;
		switch (item)
		{
		case isc_info_end:
			break;

		case isc_info_page_size:
			page_size = (USHORT) gds__vax_integer(d, length);
			put_int32(att_page_size, page_size);
			break;

		case isc_info_sweep_interval:
			sweep_interval = gds__vax_integer(d, length);
			put_int32(att_sweep_interval, sweep_interval);
			break;

		case isc_info_forced_writes:
			forced_writes = (USHORT) gds__vax_integer(d, length);
			put_int32(att_forced_writes, forced_writes);
			break;

		case isc_info_no_reserve:
			if (no_reserve = (USHORT) gds__vax_integer(d, length))
				put_int32(att_no_reserve, no_reserve);
			break;

		case isc_info_set_page_buffers:
			if (page_buffers = gds__vax_integer(d, length))
				put_int32(att_page_buffers, page_buffers);
			break;

		case isc_info_error:	// old server does not understand new isc_info
			break;				// parameter and returns isc_info_error. skip it

		case isc_info_db_sql_dialect:
			tdgbl->gbl_dialect = (USHORT) gds__vax_integer(d, length);
			put_int32(att_SQL_dialect, tdgbl->gbl_dialect);
			break;

		case isc_info_db_read_only:
			if (db_read_only = (USHORT) gds__vax_integer(d, length))
				put_int32(att_db_read_only, db_read_only);
			break;

		case fb_info_replica_mode:
			if (replica_mode = (USHORT) gds__vax_integer(d, length))
				put_int32(att_replica_mode, replica_mode);
			break;

		default:
			BURP_error_redirect(&status_vector, 31);
			// msg 31 isc_database_info failed
			break;
		}
	}

	put_asciz(att_file_name, dbb_file);

	BURP_verbose(77, SafeArg() << dbb_file << page_size);
	// msg 77 database %s has a page size of %ld bytes.

	put(tdgbl, att_end);

	put(tdgbl, (UCHAR) rec_database);

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			D IN RDB$DATABASE*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_595), fb_595);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 529, CAST_MSG(&fb_596));
		   if (!fb_596.fb_599 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			if (!/*D.RDB$SECURITY_CLASS.NULL*/
			     fb_596.fb_603)
				PUT_TEXT (att_database_security_class, /*D.RDB$SECURITY_CLASS*/
								       fb_596.fb_604);
			put_source_blob (att_database_description2, att_database_description, /*D.RDB$DESCRIPTION*/
											      fb_596.fb_597);
			if (!/*D.RDB$CHARACTER_SET_NAME.NULL*/
			     fb_596.fb_602)
				PUT_TEXT (att_database_dfl_charset, /*D.RDB$CHARACTER_SET_NAME*/
								    fb_596.fb_605);
			if (!/*D.RDB$LINGER.NULL*/
			     fb_596.fb_601)
				put_int32(att_database_linger, /*D.RDB$LINGER*/
							       fb_596.fb_598);
			if (!/*D.RDB$SQL_SECURITY.NULL*/
			     fb_596.fb_600)
				put_boolean(att_database_sql_security, /*D.RDB$SQL_SECURITY*/
								       fb_596.fb_606);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			D IN RDB$DATABASE*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_587), fb_587);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 520, CAST_MSG(&fb_588));
		   if (!fb_588.fb_590 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			if (!/*D.RDB$SECURITY_CLASS.NULL*/
			     fb_588.fb_592)
				PUT_TEXT (att_database_security_class, /*D.RDB$SECURITY_CLASS*/
								       fb_588.fb_593);
			put_source_blob (att_database_description2, att_database_description, /*D.RDB$DESCRIPTION*/
											      fb_588.fb_589);
			if (!/*D.RDB$CHARACTER_SET_NAME.NULL*/
			     fb_588.fb_591)
				PUT_TEXT (att_database_dfl_charset, /*D.RDB$CHARACTER_SET_NAME*/
								    fb_588.fb_594);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);

	put(tdgbl, att_end);
}


void write_exceptions()
{
   struct fb_572_struct {
          ISC_QUAD fb_573;	/* RDB$DESCRIPTION */
          char  fb_574 [1024];	/* RDB$MESSAGE */
          short fb_575;	/* fbUtility */
          char  fb_576 [253];	/* RDB$EXCEPTION_NAME */
   } fb_572;
   struct fb_578_struct {
          ISC_QUAD fb_579;	/* RDB$DESCRIPTION */
          char  fb_580 [1024];	/* RDB$MESSAGE */
          short fb_581;	/* fbUtility */
          short fb_582;	/* gds__null_flag */
          short fb_583;	/* gds__null_flag */
          char  fb_584 [253];	/* RDB$EXCEPTION_NAME */
          char  fb_585 [253];	/* RDB$SECURITY_CLASS */
          char  fb_586 [253];	/* RDB$OWNER_NAME */
   } fb_578;
/**************************************
 *
 *	w r i t e _ e x c e p t i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each exception.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$EXCEPTIONS
			WITH X.RDB$SYSTEM_FLAG NE 1*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_577), fb_577);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 1797, CAST_MSG(&fb_578));
		   if (!fb_578.fb_581 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			put(tdgbl, rec_exception);
			const SSHORT l = PUT_TEXT (att_exception_name, /*X.RDB$EXCEPTION_NAME*/
								       fb_578.fb_584);
			MISC_terminate (/*X.RDB$EXCEPTION_NAME*/
					fb_578.fb_584, temp, l, sizeof(temp));
			BURP_verbose (198, temp);
			// msg 198 writing exception %s
			PUT_MESSAGE(att_exception_msg, att_exception_msg2, /*X.RDB$MESSAGE*/
									   fb_578.fb_580);
			put_source_blob (att_exception_description2, att_exception_description, /*X.RDB$DESCRIPTION*/
												fb_578.fb_579);

			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     fb_578.fb_583)
				PUT_TEXT(att_exception_security_class, /*X.RDB$SECURITY_CLASS*/
								       fb_578.fb_585);
			if (!/*X.RDB$OWNER_NAME.NULL*/
			     fb_578.fb_582)
				PUT_TEXT(att_exception_owner_name, /*X.RDB$OWNER_NAME*/
								   fb_578.fb_586);

			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$EXCEPTIONS
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_571), fb_571);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 1287, CAST_MSG(&fb_572));
		   if (!fb_572.fb_575 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			put(tdgbl, rec_exception);
			const SSHORT l = PUT_TEXT (att_exception_name, /*X.RDB$EXCEPTION_NAME*/
								       fb_572.fb_576);
			MISC_terminate (/*X.RDB$EXCEPTION_NAME*/
					fb_572.fb_576, temp, l, sizeof(temp));
			BURP_verbose (198, temp);
			// msg 198 writing exception %s
			PUT_MESSAGE(att_exception_msg, att_exception_msg2, /*X.RDB$MESSAGE*/
									   fb_572.fb_574);
			put_source_blob (att_exception_description2, att_exception_description, /*X.RDB$DESCRIPTION*/
												fb_572.fb_573);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_field_dimensions()
{
   struct fb_565_struct {
          ISC_LONG fb_566;	/* RDB$UPPER_BOUND */
          ISC_LONG fb_567;	/* RDB$LOWER_BOUND */
          short fb_568;	/* fbUtility */
          short fb_569;	/* RDB$DIMENSION */
          char  fb_570 [253];	/* RDB$FIELD_NAME */
   } fb_565;
/**************************************
 *
 *	w r i t e _ f i e l d _ d i m e n s i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each array field dimension.
 *
 **************************************/
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$FIELD_DIMENSIONS*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle1 && DB)
	      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_564), fb_564);
	   if (req_handle1)
	      req_handle1->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle1->receive (fbStatus, 0, 0, 265, CAST_MSG(&fb_565));
	   if (!fb_565.fb_568 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
		put(tdgbl, rec_field_dimensions);
		PUT_TEXT (att_field_name, /*X.RDB$FIELD_NAME*/
					  fb_565.fb_570);
		put_int32 (att_field_dimensions, /*X.RDB$DIMENSION*/
						 fb_565.fb_569);
		put_int32 (att_field_range_low, /*X.RDB$LOWER_BOUND*/
						fb_565.fb_567);
		put_int32 (att_field_range_high, /*X.RDB$UPPER_BOUND*/
						 fb_565.fb_566);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_filters()
{
   struct fb_556_struct {
          char  fb_557 [256];	/* RDB$ENTRYPOINT */
          char  fb_558 [256];	/* RDB$MODULE_NAME */
          ISC_QUAD fb_559;	/* RDB$DESCRIPTION */
          short fb_560;	/* fbUtility */
          short fb_561;	/* RDB$OUTPUT_SUB_TYPE */
          short fb_562;	/* RDB$INPUT_SUB_TYPE */
          char  fb_563 [253];	/* RDB$FUNCTION_NAME */
   } fb_556;
/**************************************
 *
 *	w r i t e _ f i l t e r s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each filter.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$FILTERS
		WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle1 && DB)
	      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_555), fb_555);
	   if (req_handle1)
	      req_handle1->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle1->receive (fbStatus, 0, 0, 779, CAST_MSG(&fb_556));
	   if (!fb_556.fb_560 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
		put(tdgbl, rec_filter);
		const SSHORT l = PUT_TEXT (att_filter_name, /*X.RDB$FUNCTION_NAME*/
							    fb_556.fb_563);
		MISC_terminate (/*X.RDB$FUNCTION_NAME*/
				fb_556.fb_563, temp, l, sizeof(temp));
		BURP_verbose (145, temp);
		// msg 145 writing filter %s
		put_source_blob (att_filter_description2, att_filter_description, /*X.RDB$DESCRIPTION*/
										  fb_556.fb_559);
		PUT_TEXT (att_filter_module_name, /*X.RDB$MODULE_NAME*/
						  fb_556.fb_558);
		PUT_TEXT (att_filter_entrypoint, /*X.RDB$ENTRYPOINT*/
						 fb_556.fb_557);
		put_int32 (att_filter_input_sub_type, /*X.RDB$INPUT_SUB_TYPE*/
						      fb_556.fb_562);
		put_int32 (att_filter_output_sub_type, /*X.RDB$OUTPUT_SUB_TYPE*/
						       fb_556.fb_561);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_functions()
{
   struct fb_510_struct {
          char  fb_511 [256];	/* RDB$ENTRYPOINT */
          char  fb_512 [256];	/* RDB$MODULE_NAME */
          ISC_QUAD fb_513;	/* RDB$DESCRIPTION */
          short fb_514;	/* fbUtility */
          short fb_515;	/* RDB$FUNCTION_TYPE */
          short fb_516;	/* RDB$RETURN_ARGUMENT */
          char  fb_517 [253];	/* RDB$FUNCTION_NAME */
          char  fb_518 [253];	/* RDB$QUERY_NAME */
   } fb_510;
   struct fb_520_struct {
          ISC_QUAD fb_521;	/* RDB$DEBUG_INFO */
          ISC_QUAD fb_522;	/* RDB$FUNCTION_SOURCE */
          ISC_QUAD fb_523;	/* RDB$FUNCTION_BLR */
          char  fb_524 [256];	/* RDB$ENTRYPOINT */
          char  fb_525 [256];	/* RDB$MODULE_NAME */
          ISC_QUAD fb_526;	/* RDB$DESCRIPTION */
          short fb_527;	/* fbUtility */
          short fb_528;	/* gds__null_flag */
          short fb_529;	/* gds__null_flag */
          short fb_530;	/* RDB$DETERMINISTIC_FLAG */
          short fb_531;	/* gds__null_flag */
          short fb_532;	/* RDB$LEGACY_FLAG */
          short fb_533;	/* gds__null_flag */
          short fb_534;	/* gds__null_flag */
          short fb_535;	/* gds__null_flag */
          short fb_536;	/* gds__null_flag */
          short fb_537;	/* RDB$VALID_BLR */
          short fb_538;	/* gds__null_flag */
          short fb_539;	/* gds__null_flag */
          short fb_540;	/* gds__null_flag */
          short fb_541;	/* RDB$PRIVATE_FLAG */
          short fb_542;	/* gds__null_flag */
          short fb_543;	/* gds__null_flag */
          short fb_544;	/* gds__null_flag */
          short fb_545;	/* RDB$FUNCTION_TYPE */
          short fb_546;	/* RDB$RETURN_ARGUMENT */
          short fb_547;	/* gds__null_flag */
          char  fb_548 [253];	/* RDB$PACKAGE_NAME */
          char  fb_549 [253];	/* RDB$FUNCTION_NAME */
          char  fb_550 [253];	/* RDB$QUERY_NAME */
          char  fb_551 [253];	/* RDB$ENGINE_NAME */
          char  fb_552 [253];	/* RDB$SECURITY_CLASS */
          char  fb_553 [253];	/* RDB$OWNER_NAME */
          FB_BOOLEAN fb_554;	/* RDB$SQL_SECURITY */
   } fb_520;
/**************************************
 *
 *	w r i t e _ f u n c t i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each function.
 *
 **************************************/
	GDS_NAME func;
	TEXT temp[GDS_NAME_LEN * 2];
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$FUNCTIONS WITH X.RDB$SYSTEM_FLAG NE 1*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_519), fb_519);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 2105, CAST_MSG(&fb_520));
		   if (!fb_520.fb_527 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			put(tdgbl, rec_function);

			SSHORT prefixLen = 0;

			if (!/*X.RDB$PACKAGE_NAME.NULL*/
			     fb_520.fb_547)
			{
				prefixLen = PUT_TEXT(att_function_package_name, /*X.RDB$PACKAGE_NAME*/
										fb_520.fb_548);
				MISC_terminate(/*X.RDB$PACKAGE_NAME*/
					       fb_520.fb_548, temp, prefixLen, sizeof(temp));
				temp[prefixLen++] = '.';
			}

			const SSHORT l = PUT_TEXT (att_function_name, /*X.RDB$FUNCTION_NAME*/
								      fb_520.fb_549);
			MISC_terminate (/*X.RDB$FUNCTION_NAME*/
					fb_520.fb_549, temp + prefixLen, l, sizeof(temp) - prefixLen);
			BURP_verbose (147, temp);
			// msg 147 writing function %.*s
			put_source_blob (att_function_description2, att_function_description, /*X.RDB$DESCRIPTION*/
											      fb_520.fb_526);
			put_int32 (att_function_return_arg, /*X.RDB$RETURN_ARGUMENT*/
							    fb_520.fb_546);
			put_int32 (att_function_type, /*X.RDB$FUNCTION_TYPE*/
						      fb_520.fb_545);
			PUT_TEXT (att_function_query_name, /*X.RDB$QUERY_NAME*/
							   fb_520.fb_550);

			if (!/*X.RDB$MODULE_NAME.NULL*/
			     fb_520.fb_544)
				PUT_TEXT(att_function_module_name, /*X.RDB$MODULE_NAME*/
								   fb_520.fb_525);
			if (!/*X.RDB$ENTRYPOINT.NULL*/
			     fb_520.fb_543)
				PUT_TEXT(att_function_entrypoint, /*X.RDB$ENTRYPOINT*/
								  fb_520.fb_524);

			if (!/*X.RDB$ENGINE_NAME.NULL*/
			     fb_520.fb_542)
				PUT_TEXT(att_function_engine_name, /*X.RDB$ENGINE_NAME*/
								   fb_520.fb_551);
			if (!/*X.RDB$PRIVATE_FLAG.NULL*/
			     fb_520.fb_540)
				put_int32(att_function_private_flag, /*X.RDB$PRIVATE_FLAG*/
								     fb_520.fb_541);
			if (!/*X.RDB$FUNCTION_BLR.NULL*/
			     fb_520.fb_539)
				put_blr_blob(att_function_blr, /*X.RDB$FUNCTION_BLR*/
							       fb_520.fb_523);
			if (!/*X.RDB$FUNCTION_SOURCE.NULL*/
			     fb_520.fb_538)
				put_source_blob(att_function_source, att_function_source, /*X.RDB$FUNCTION_SOURCE*/
											  fb_520.fb_522);
			if (!/*X.RDB$VALID_BLR.NULL*/
			     fb_520.fb_536)
				put_int32(att_function_valid_blr, /*X.RDB$VALID_BLR*/
								  fb_520.fb_537);
			if (!/*X.RDB$DEBUG_INFO.NULL*/
			     fb_520.fb_535)
				put_blr_blob(att_function_debug_info, /*X.RDB$DEBUG_INFO*/
								      fb_520.fb_521);
			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     fb_520.fb_534)
				PUT_TEXT(att_function_security_class, /*X.RDB$SECURITY_CLASS*/
								      fb_520.fb_552);
			if (!/*X.RDB$OWNER_NAME.NULL*/
			     fb_520.fb_533)
				PUT_TEXT(att_function_owner_name, /*X.RDB$OWNER_NAME*/
								  fb_520.fb_553);
			if (!/*X.RDB$LEGACY_FLAG.NULL*/
			     fb_520.fb_531)
				put_int32(att_function_legacy_flag, /*X.RDB$LEGACY_FLAG*/
								    fb_520.fb_532);
			if (!/*X.RDB$DETERMINISTIC_FLAG.NULL*/
			     fb_520.fb_529)
				put_int32(att_function_deterministic_flag, /*X.RDB$DETERMINISTIC_FLAG*/
									   fb_520.fb_530);
			if (!/*X.RDB$SQL_SECURITY.NULL*/
			     fb_520.fb_528)
				put_boolean(att_function_sql_security, /*X.RDB$SQL_SECURITY*/
								       fb_520.fb_554);

			put(tdgbl, att_end);

			COPY (/*X.RDB$FUNCTION_NAME*/
			      fb_520.fb_549, func);
			write_function_args ((/*X.RDB$PACKAGE_NAME.NULL*/
					      fb_520.fb_547 ? "" : /*X.RDB$PACKAGE_NAME*/
	fb_520.fb_548), func);
			put(tdgbl, rec_function_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$FUNCTIONS WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_509), fb_509);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 1032, CAST_MSG(&fb_510));
		   if (!fb_510.fb_514 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			put(tdgbl, rec_function);
			const SSHORT l = PUT_TEXT (att_function_name, /*X.RDB$FUNCTION_NAME*/
								      fb_510.fb_517);
			MISC_terminate (/*X.RDB$FUNCTION_NAME*/
					fb_510.fb_517, temp, l, sizeof(temp));
			BURP_verbose (147, temp);
			// msg 147 writing function %.*s
			put_source_blob (att_function_description2, att_function_description, /*X.RDB$DESCRIPTION*/
											      fb_510.fb_513);
			PUT_TEXT (att_function_module_name, /*X.RDB$MODULE_NAME*/
							    fb_510.fb_512);
			PUT_TEXT (att_function_entrypoint, /*X.RDB$ENTRYPOINT*/
							   fb_510.fb_511);
			put_int32 (att_function_return_arg, /*X.RDB$RETURN_ARGUMENT*/
							    fb_510.fb_516);
			put_int32 (att_function_type, /*X.RDB$FUNCTION_TYPE*/
						      fb_510.fb_515);
			PUT_TEXT (att_function_query_name, /*X.RDB$QUERY_NAME*/
							   fb_510.fb_518);
			put(tdgbl, att_end);
			COPY (/*X.RDB$FUNCTION_NAME*/
			      fb_510.fb_517, func);
			write_function_args ("", func);
			put(tdgbl, rec_function_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_function_args(const GDS_NAME package, GDS_NAME funcptr)
{
   struct fb_443_struct {
          short fb_444;	/* fbUtility */
          short fb_445;	/* gds__null_flag */
          short fb_446;	/* RDB$CHARACTER_SET_ID */
          short fb_447;	/* RDB$FIELD_SUB_TYPE */
          short fb_448;	/* RDB$FIELD_LENGTH */
          short fb_449;	/* RDB$FIELD_SCALE */
          short fb_450;	/* RDB$FIELD_TYPE */
          short fb_451;	/* RDB$MECHANISM */
          short fb_452;	/* RDB$ARGUMENT_POSITION */
          char  fb_453 [253];	/* RDB$FUNCTION_NAME */
   } fb_443;
   struct fb_441_struct {
          char  fb_442 [253];	/* RDB$FUNCTION_NAME */
   } fb_441;
   struct fb_457_struct {
          short fb_458;	/* fbUtility */
          short fb_459;	/* gds__null_flag */
          short fb_460;	/* RDB$FIELD_PRECISION */
          short fb_461;	/* gds__null_flag */
          short fb_462;	/* RDB$CHARACTER_SET_ID */
          short fb_463;	/* RDB$FIELD_SUB_TYPE */
          short fb_464;	/* RDB$FIELD_LENGTH */
          short fb_465;	/* RDB$FIELD_SCALE */
          short fb_466;	/* RDB$FIELD_TYPE */
          short fb_467;	/* RDB$MECHANISM */
          short fb_468;	/* RDB$ARGUMENT_POSITION */
          char  fb_469 [253];	/* RDB$FUNCTION_NAME */
   } fb_457;
   struct fb_455_struct {
          char  fb_456 [253];	/* RDB$FUNCTION_NAME */
   } fb_455;
   struct fb_474_struct {
          ISC_QUAD fb_475;	/* RDB$DESCRIPTION */
          ISC_QUAD fb_476;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD fb_477;	/* RDB$DEFAULT_VALUE */
          short fb_478;	/* fbUtility */
          short fb_479;	/* gds__null_flag */
          short fb_480;	/* gds__null_flag */
          short fb_481;	/* gds__null_flag */
          short fb_482;	/* gds__null_flag */
          short fb_483;	/* RDB$ARGUMENT_MECHANISM */
          short fb_484;	/* gds__null_flag */
          short fb_485;	/* RDB$NULL_FLAG */
          short fb_486;	/* gds__null_flag */
          short fb_487;	/* RDB$COLLATION_ID */
          short fb_488;	/* gds__null_flag */
          short fb_489;	/* gds__null_flag */
          short fb_490;	/* gds__null_flag */
          short fb_491;	/* gds__null_flag */
          short fb_492;	/* gds__null_flag */
          short fb_493;	/* RDB$FIELD_PRECISION */
          short fb_494;	/* gds__null_flag */
          short fb_495;	/* RDB$CHARACTER_SET_ID */
          short fb_496;	/* RDB$FIELD_SUB_TYPE */
          short fb_497;	/* RDB$FIELD_LENGTH */
          short fb_498;	/* RDB$FIELD_SCALE */
          short fb_499;	/* RDB$FIELD_TYPE */
          short fb_500;	/* RDB$MECHANISM */
          short fb_501;	/* RDB$ARGUMENT_POSITION */
          short fb_502;	/* gds__null_flag */
          char  fb_503 [253];	/* RDB$PACKAGE_NAME */
          char  fb_504 [253];	/* RDB$FUNCTION_NAME */
          char  fb_505 [253];	/* RDB$ARGUMENT_NAME */
          char  fb_506 [253];	/* RDB$FIELD_SOURCE */
          char  fb_507 [253];	/* RDB$FIELD_NAME */
          char  fb_508 [253];	/* RDB$RELATION_NAME */
   } fb_474;
   struct fb_471_struct {
          char  fb_472 [253];	/* RDB$FUNCTION_NAME */
          char  fb_473 [253];	/* RDB$PACKAGE_NAME */
   } fb_471;
/**************************************
 *
 *	w r i t e _ f u n c t i o n _ a r g s
 *
 **************************************
 *
 * Functional description
 * 	write all arguments for a function.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN * 2];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// if we have all capabilities, use the first request to get the
	// most performance out of the latest engine; if we don't
	// have one of the capabilities we must use the second set of
	// requests--this requires more code but it is well worth it
	// for the performance benefits, especially remotely--deej

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_write_function_args_req_handle1)
			X IN RDB$FUNCTION_ARGUMENTS
			WITH X.RDB$FUNCTION_NAME EQ funcptr AND
				 X.RDB$PACKAGE_NAME EQUIV NULLIF(package, '')*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!tdgbl->handles_write_function_args_req_handle1 && DB)
		      tdgbl->handles_write_function_args_req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_470), fb_470);
		   isc_vtov ((const char*) funcptr, (char*) fb_471.fb_472, 253);
		   isc_vtov ((const char*) package, (char*) fb_471.fb_473, 253);
		   if (tdgbl->handles_write_function_args_req_handle1)
		      tdgbl->handles_write_function_args_req_handle1->startAndSend(fbStatus, fbTrans, 0, 0, 506, CAST_CONST_MSG(&fb_471));
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { tdgbl->handles_write_function_args_req_handle1->release(); tdgbl->handles_write_function_args_req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   tdgbl->handles_write_function_args_req_handle1->receive (fbStatus, 0, 1, 1592, CAST_MSG(&fb_474));
		   if (!fb_474.fb_478 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			put(tdgbl, rec_function_arg);

			SSHORT prefixLen = 0;

			if (!/*X.RDB$PACKAGE_NAME.NULL*/
			     fb_474.fb_502)
			{
				prefixLen = PUT_TEXT(att_functionarg_package_name, /*X.RDB$PACKAGE_NAME*/
										   fb_474.fb_503);
				MISC_terminate(/*X.RDB$PACKAGE_NAME*/
					       fb_474.fb_503, temp, prefixLen, sizeof(temp));
				temp[prefixLen++] = '.';
			}

			const SSHORT l = PUT_TEXT (att_functionarg_name, /*X.RDB$FUNCTION_NAME*/
									 fb_474.fb_504);
			MISC_terminate (/*X.RDB$FUNCTION_NAME*/
					fb_474.fb_504, temp + prefixLen, l, sizeof(temp) - prefixLen);
			BURP_verbose (141, temp);
			// msg 141 writing argument for function %s

			put_int32 (att_functionarg_position, /*X.RDB$ARGUMENT_POSITION*/
							     fb_474.fb_501);
			put_int32 (att_functionarg_passing_mechanism, /*X.RDB$MECHANISM*/
								      fb_474.fb_500);
			put_int32 (att_functionarg_field_type, /*X.RDB$FIELD_TYPE*/
							       fb_474.fb_499);
			put_int32 (att_functionarg_field_scale, /*X.RDB$FIELD_SCALE*/
								fb_474.fb_498);
			put_int32 (att_functionarg_field_length, /*X.RDB$FIELD_LENGTH*/
								 fb_474.fb_497);
			put_int32 (att_functionarg_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
								   fb_474.fb_496);
			if (!/*X.RDB$CHARACTER_SET_ID.NULL*/
			     fb_474.fb_494)
				put_int32 (att_functionarg_character_set, /*X.RDB$CHARACTER_SET_ID*/
									  fb_474.fb_495);

			if (!/*X.RDB$FIELD_PRECISION.NULL*/
			     fb_474.fb_492)
				put_int32 (att_functionarg_field_precision, /*X.RDB$FIELD_PRECISION*/
									    fb_474.fb_493);

			if (!/*X.RDB$ARGUMENT_NAME.NULL*/
			     fb_474.fb_491)
				PUT_TEXT(att_functionarg_arg_name, /*X.RDB$ARGUMENT_NAME*/
								   fb_474.fb_505);
			if (!/*X.RDB$FIELD_SOURCE.NULL*/
			     fb_474.fb_490)
				PUT_TEXT(att_functionarg_field_source, /*X.RDB$FIELD_SOURCE*/
								       fb_474.fb_506);
			if (!/*X.RDB$DEFAULT_VALUE.NULL*/
			     fb_474.fb_489)
				put_blr_blob(att_functionarg_default_value, /*X.RDB$DEFAULT_VALUE*/
									    fb_474.fb_477);
			if (!/*X.RDB$DEFAULT_SOURCE.NULL*/
			     fb_474.fb_488)
				put_source_blob(att_functionarg_default_source, att_functionarg_default_source,
								/*X.RDB$DEFAULT_SOURCE*/
								fb_474.fb_476);
			if (!/*X.RDB$COLLATION_ID.NULL*/
			     fb_474.fb_486)
				put_int32(att_functionarg_collation_id, /*X.RDB$COLLATION_ID*/
									fb_474.fb_487);
			if (!/*X.RDB$NULL_FLAG.NULL*/
			     fb_474.fb_484)
				put_int32(att_functionarg_null_flag, /*X.RDB$NULL_FLAG*/
								     fb_474.fb_485);
			if (!/*X.RDB$ARGUMENT_MECHANISM.NULL*/
			     fb_474.fb_482)
				put_int32(att_functionarg_type_mechanism, /*X.RDB$ARGUMENT_MECHANISM*/
									  fb_474.fb_483);
			if (!/*X.RDB$FIELD_NAME.NULL*/
			     fb_474.fb_481)
				PUT_TEXT(att_functionarg_field_name, /*X.RDB$FIELD_NAME*/
								     fb_474.fb_507);
			if (!/*X.RDB$RELATION_NAME.NULL*/
			     fb_474.fb_480)
				PUT_TEXT(att_functionarg_relation_name, /*X.RDB$RELATION_NAME*/
									fb_474.fb_508);
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     fb_474.fb_479)
				put_source_blob(att_functionarg_description, att_functionarg_description, /*X.RDB$DESCRIPTION*/
													  fb_474.fb_475);

			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else if (tdgbl->runtimeODS >= DB_VERSION_DDL10)
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_write_function_args_req_handle1)
			X IN RDB$FUNCTION_ARGUMENTS WITH
			X.RDB$FUNCTION_NAME EQ funcptr*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!tdgbl->handles_write_function_args_req_handle1 && DB)
		      tdgbl->handles_write_function_args_req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_454), fb_454);
		   isc_vtov ((const char*) funcptr, (char*) fb_455.fb_456, 253);
		   if (tdgbl->handles_write_function_args_req_handle1)
		      tdgbl->handles_write_function_args_req_handle1->startAndSend(fbStatus, fbTrans, 0, 0, 253, CAST_CONST_MSG(&fb_455));
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { tdgbl->handles_write_function_args_req_handle1->release(); tdgbl->handles_write_function_args_req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   tdgbl->handles_write_function_args_req_handle1->receive (fbStatus, 0, 1, 275, CAST_MSG(&fb_457));
		   if (!fb_457.fb_458 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			put(tdgbl, rec_function_arg);
			const SSHORT l = PUT_TEXT (att_functionarg_name, /*X.RDB$FUNCTION_NAME*/
									 fb_457.fb_469);
			MISC_terminate (/*X.RDB$FUNCTION_NAME*/
					fb_457.fb_469, temp, l, sizeof(temp));
			BURP_verbose (141, temp);
			// msg 141 writing argument for function %s
			put_int32 (att_functionarg_position, /*X.RDB$ARGUMENT_POSITION*/
							     fb_457.fb_468);
			put_int32 (att_functionarg_passing_mechanism, /*X.RDB$MECHANISM*/
								      fb_457.fb_467);
			put_int32 (att_functionarg_field_type, /*X.RDB$FIELD_TYPE*/
							       fb_457.fb_466);
			put_int32 (att_functionarg_field_scale, /*X.RDB$FIELD_SCALE*/
								fb_457.fb_465);
			put_int32 (att_functionarg_field_length, /*X.RDB$FIELD_LENGTH*/
								 fb_457.fb_464);
			put_int32 (att_functionarg_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
								   fb_457.fb_463);
			if (!/*X.RDB$CHARACTER_SET_ID.NULL*/
			     fb_457.fb_461)
				put_int32 (att_functionarg_character_set, /*X.RDB$CHARACTER_SET_ID*/
									  fb_457.fb_462);

			if (!/*X.RDB$FIELD_PRECISION.NULL*/
			     fb_457.fb_459)
				put_int32 (att_functionarg_field_precision, /*X.RDB$FIELD_PRECISION*/
									    fb_457.fb_460);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_write_function_args_req_handle1)
			X IN RDB$FUNCTION_ARGUMENTS WITH
			X.RDB$FUNCTION_NAME EQ funcptr*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!tdgbl->handles_write_function_args_req_handle1 && DB)
		      tdgbl->handles_write_function_args_req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_440), fb_440);
		   isc_vtov ((const char*) funcptr, (char*) fb_441.fb_442, 253);
		   if (tdgbl->handles_write_function_args_req_handle1)
		      tdgbl->handles_write_function_args_req_handle1->startAndSend(fbStatus, fbTrans, 0, 0, 253, CAST_CONST_MSG(&fb_441));
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { tdgbl->handles_write_function_args_req_handle1->release(); tdgbl->handles_write_function_args_req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   tdgbl->handles_write_function_args_req_handle1->receive (fbStatus, 0, 1, 271, CAST_MSG(&fb_443));
		   if (!fb_443.fb_444 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			put(tdgbl, rec_function_arg);
			const SSHORT l = PUT_TEXT (att_functionarg_name, /*X.RDB$FUNCTION_NAME*/
									 fb_443.fb_453);
			MISC_terminate (/*X.RDB$FUNCTION_NAME*/
					fb_443.fb_453, temp, l, sizeof(temp));
			BURP_verbose (141, temp);
			// msg 141 writing argument for function %s
			put_int32 (att_functionarg_position, /*X.RDB$ARGUMENT_POSITION*/
							     fb_443.fb_452);
			put_int32 (att_functionarg_passing_mechanism, /*X.RDB$MECHANISM*/
								      fb_443.fb_451);
			put_int32 (att_functionarg_field_type, /*X.RDB$FIELD_TYPE*/
							       fb_443.fb_450);
			put_int32 (att_functionarg_field_scale, /*X.RDB$FIELD_SCALE*/
								fb_443.fb_449);
			put_int32 (att_functionarg_field_length, /*X.RDB$FIELD_LENGTH*/
								 fb_443.fb_448);
			put_int32 (att_functionarg_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
								   fb_443.fb_447);

			if (!/*X.RDB$CHARACTER_SET_ID.NULL*/
			     fb_443.fb_445)
				put_int32 (att_functionarg_character_set, /*X.RDB$CHARACTER_SET_ID*/
									  fb_443.fb_446);
			// Note that DB_VERSION_DDL10 canNOT be set if we're in this
			// "else" branch.  Hence there is no need to test that
			// bit and store the RDB$FIELD_PRECISION.

			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
}


void write_generators()
{
   struct fb_417_struct {
          short fb_418;	/* fbUtility */
          char  fb_419 [253];	/* RDB$GENERATOR_NAME */
   } fb_417;
   struct fb_421_struct {
          ISC_QUAD fb_422;	/* RDB$DESCRIPTION */
          short fb_423;	/* fbUtility */
          short fb_424;	/* gds__null_flag */
          char  fb_425 [253];	/* RDB$GENERATOR_NAME */
   } fb_421;
   struct fb_427_struct {
          ISC_INT64 fb_428;	/* RDB$INITIAL_VALUE */
          ISC_QUAD fb_429;	/* RDB$DESCRIPTION */
          ISC_LONG fb_430;	/* RDB$GENERATOR_INCREMENT */
          short fb_431;	/* fbUtility */
          short fb_432;	/* gds__null_flag */
          short fb_433;	/* gds__null_flag */
          short fb_434;	/* gds__null_flag */
          short fb_435;	/* RDB$SYSTEM_FLAG */
          short fb_436;	/* gds__null_flag */
          char  fb_437 [253];	/* RDB$GENERATOR_NAME */
          char  fb_438 [253];	/* RDB$SECURITY_CLASS */
          char  fb_439 [253];	/* RDB$OWNER_NAME */
   } fb_427;
/**************************************
 *
 *	w r i t e _ g e n e r a t o r s
 *
 **************************************
 *
 * Functional description
 *	Write any defined generators.
 *
 **************************************/
	Firebird::IRequest* req_handle1 = nullptr;
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$GENERATORS
			WITH X.RDB$SYSTEM_FLAG NE 1*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_426), fb_426);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 791, CAST_MSG(&fb_427));
		   if (!fb_427.fb_431 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			put(tdgbl, rec_generator);
			const SSHORT l = PUT_TEXT (att_gen_generator, /*X.RDB$GENERATOR_NAME*/
								      fb_427.fb_437);
			SINT64 value = 0;
			if (!tdgbl->gbl_sw_meta)
			{
				value = get_gen_id (/*X.RDB$GENERATOR_NAME*/
						    fb_427.fb_437, l);
				put_int64 (att_gen_value_int64, value);
			}
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     fb_427.fb_436) {
				put_source_blob (att_gen_description, att_gen_description, /*X.RDB$DESCRIPTION*/
											   fb_427.fb_429);
			}

			if (/*X.RDB$SYSTEM_FLAG*/
			    fb_427.fb_435)
				put_int32(att_gen_sysflag, /*X.RDB$SYSTEM_FLAG*/
							   fb_427.fb_435);

			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     fb_427.fb_434)
				PUT_TEXT(att_gen_security_class, /*X.RDB$SECURITY_CLASS*/
								 fb_427.fb_438);
			if (!/*X.RDB$OWNER_NAME.NULL*/
			     fb_427.fb_433)
				PUT_TEXT(att_gen_owner_name, /*X.RDB$OWNER_NAME*/
							     fb_427.fb_439);
			if (!/*X.RDB$INITIAL_VALUE.NULL*/
			     fb_427.fb_432)
				put_int64(att_gen_init_val, /*X.RDB$INITIAL_VALUE*/
							    fb_427.fb_428);

			put_int32(att_gen_id_increment, /*X.RDB$GENERATOR_INCREMENT*/
							fb_427.fb_430);

			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$GENERATOR_NAME*/
					fb_427.fb_437, temp, l, sizeof(temp));
			BURP_verbose (165, SafeArg() << temp << value);
			// msg 165 writing generator %s value %ld
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else if (tdgbl->runtimeODS >= DB_VERSION_DDL11)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$GENERATORS
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_420), fb_420);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 265, CAST_MSG(&fb_421));
		   if (!fb_421.fb_423 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			put(tdgbl, rec_generator);
			const SSHORT l = PUT_TEXT (att_gen_generator, /*X.RDB$GENERATOR_NAME*/
								      fb_421.fb_425);
			SINT64 value = 0;
			if (!tdgbl->gbl_sw_meta)
			{
				value = get_gen_id (/*X.RDB$GENERATOR_NAME*/
						    fb_421.fb_425, l);
				put_int64 (att_gen_value_int64, value);
			}
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     fb_421.fb_424) {
				put_source_blob (att_gen_description, att_gen_description, /*X.RDB$DESCRIPTION*/
											   fb_421.fb_422);
			}
			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$GENERATOR_NAME*/
					fb_421.fb_425, temp, l, sizeof(temp));
			BURP_verbose (165, SafeArg() << temp << value);
			// msg 165 writing generator %s value %ld
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$GENERATORS
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_416), fb_416);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 255, CAST_MSG(&fb_417));
		   if (!fb_417.fb_418 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			put(tdgbl, rec_generator);
			const SSHORT l = PUT_TEXT (att_gen_generator, /*X.RDB$GENERATOR_NAME*/
								      fb_417.fb_419);
			SINT64 value = 0;
			if (!tdgbl->gbl_sw_meta)
			{
				value = get_gen_id (/*X.RDB$GENERATOR_NAME*/
						    fb_417.fb_419, l);
				put_int64 (att_gen_value_int64, value);
			}
			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$GENERATOR_NAME*/
					fb_417.fb_419, temp, l, sizeof(temp));
			BURP_verbose (165, SafeArg() << temp << value);
			// msg 165 writing generator %s value %ld
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_global_fields()
{
   struct fb_295_struct {
          ISC_QUAD fb_296;	/* RDB$MISSING_SOURCE */
          ISC_QUAD fb_297;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD fb_298;	/* RDB$DESCRIPTION */
          ISC_QUAD fb_299;	/* RDB$COMPUTED_SOURCE */
          ISC_QUAD fb_300;	/* RDB$COMPUTED_BLR */
          ISC_QUAD fb_301;	/* RDB$VALIDATION_SOURCE */
          ISC_QUAD fb_302;	/* RDB$VALIDATION_BLR */
          ISC_QUAD fb_303;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD fb_304;	/* RDB$MISSING_VALUE */
          ISC_QUAD fb_305;	/* RDB$QUERY_HEADER */
          char  fb_306 [128];	/* RDB$EDIT_STRING */
          short fb_307;	/* fbUtility */
          short fb_308;	/* gds__null_flag */
          short fb_309;	/* RDB$COLLATION_ID */
          short fb_310;	/* gds__null_flag */
          short fb_311;	/* RDB$CHARACTER_SET_ID */
          short fb_312;	/* gds__null_flag */
          short fb_313;	/* gds__null_flag */
          short fb_314;	/* gds__null_flag */
          short fb_315;	/* RDB$CHARACTER_LENGTH */
          short fb_316;	/* gds__null_flag */
          short fb_317;	/* RDB$NULL_FLAG */
          short fb_318;	/* RDB$DIMENSIONS */
          short fb_319;	/* RDB$EXTERNAL_SCALE */
          short fb_320;	/* RDB$EXTERNAL_TYPE */
          short fb_321;	/* RDB$EXTERNAL_LENGTH */
          short fb_322;	/* RDB$SYSTEM_FLAG */
          short fb_323;	/* RDB$SEGMENT_LENGTH */
          short fb_324;	/* RDB$FIELD_SCALE */
          short fb_325;	/* RDB$FIELD_SUB_TYPE */
          short fb_326;	/* RDB$FIELD_LENGTH */
          short fb_327;	/* RDB$FIELD_TYPE */
          short fb_328;	/* gds__null_flag */
          short fb_329;	/* gds__null_flag */
          char  fb_330 [253];	/* RDB$FIELD_NAME */
          char  fb_331 [253];	/* RDB$QUERY_NAME */
   } fb_295;
   struct fb_333_struct {
          ISC_QUAD fb_334;	/* RDB$MISSING_SOURCE */
          ISC_QUAD fb_335;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD fb_336;	/* RDB$DESCRIPTION */
          ISC_QUAD fb_337;	/* RDB$COMPUTED_SOURCE */
          ISC_QUAD fb_338;	/* RDB$COMPUTED_BLR */
          ISC_QUAD fb_339;	/* RDB$VALIDATION_SOURCE */
          ISC_QUAD fb_340;	/* RDB$VALIDATION_BLR */
          ISC_QUAD fb_341;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD fb_342;	/* RDB$MISSING_VALUE */
          ISC_QUAD fb_343;	/* RDB$QUERY_HEADER */
          char  fb_344 [128];	/* RDB$EDIT_STRING */
          short fb_345;	/* fbUtility */
          short fb_346;	/* gds__null_flag */
          short fb_347;	/* RDB$FIELD_PRECISION */
          short fb_348;	/* gds__null_flag */
          short fb_349;	/* RDB$COLLATION_ID */
          short fb_350;	/* gds__null_flag */
          short fb_351;	/* RDB$CHARACTER_SET_ID */
          short fb_352;	/* gds__null_flag */
          short fb_353;	/* gds__null_flag */
          short fb_354;	/* gds__null_flag */
          short fb_355;	/* RDB$CHARACTER_LENGTH */
          short fb_356;	/* gds__null_flag */
          short fb_357;	/* RDB$NULL_FLAG */
          short fb_358;	/* RDB$DIMENSIONS */
          short fb_359;	/* RDB$EXTERNAL_SCALE */
          short fb_360;	/* RDB$EXTERNAL_TYPE */
          short fb_361;	/* RDB$EXTERNAL_LENGTH */
          short fb_362;	/* RDB$SYSTEM_FLAG */
          short fb_363;	/* RDB$SEGMENT_LENGTH */
          short fb_364;	/* RDB$FIELD_SCALE */
          short fb_365;	/* RDB$FIELD_SUB_TYPE */
          short fb_366;	/* RDB$FIELD_LENGTH */
          short fb_367;	/* RDB$FIELD_TYPE */
          short fb_368;	/* gds__null_flag */
          short fb_369;	/* gds__null_flag */
          char  fb_370 [253];	/* RDB$FIELD_NAME */
          char  fb_371 [253];	/* RDB$QUERY_NAME */
   } fb_333;
   struct fb_373_struct {
          ISC_QUAD fb_374;	/* RDB$MISSING_SOURCE */
          ISC_QUAD fb_375;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD fb_376;	/* RDB$DESCRIPTION */
          ISC_QUAD fb_377;	/* RDB$COMPUTED_SOURCE */
          ISC_QUAD fb_378;	/* RDB$COMPUTED_BLR */
          ISC_QUAD fb_379;	/* RDB$VALIDATION_SOURCE */
          ISC_QUAD fb_380;	/* RDB$VALIDATION_BLR */
          ISC_QUAD fb_381;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD fb_382;	/* RDB$MISSING_VALUE */
          ISC_QUAD fb_383;	/* RDB$QUERY_HEADER */
          char  fb_384 [128];	/* RDB$EDIT_STRING */
          short fb_385;	/* fbUtility */
          short fb_386;	/* gds__null_flag */
          short fb_387;	/* gds__null_flag */
          short fb_388;	/* gds__null_flag */
          short fb_389;	/* RDB$FIELD_PRECISION */
          short fb_390;	/* gds__null_flag */
          short fb_391;	/* RDB$COLLATION_ID */
          short fb_392;	/* gds__null_flag */
          short fb_393;	/* RDB$CHARACTER_SET_ID */
          short fb_394;	/* gds__null_flag */
          short fb_395;	/* gds__null_flag */
          short fb_396;	/* gds__null_flag */
          short fb_397;	/* RDB$CHARACTER_LENGTH */
          short fb_398;	/* gds__null_flag */
          short fb_399;	/* RDB$NULL_FLAG */
          short fb_400;	/* RDB$DIMENSIONS */
          short fb_401;	/* RDB$EXTERNAL_SCALE */
          short fb_402;	/* RDB$EXTERNAL_TYPE */
          short fb_403;	/* RDB$EXTERNAL_LENGTH */
          short fb_404;	/* RDB$SYSTEM_FLAG */
          short fb_405;	/* RDB$SEGMENT_LENGTH */
          short fb_406;	/* RDB$FIELD_SCALE */
          short fb_407;	/* RDB$FIELD_SUB_TYPE */
          short fb_408;	/* RDB$FIELD_LENGTH */
          short fb_409;	/* RDB$FIELD_TYPE */
          short fb_410;	/* gds__null_flag */
          short fb_411;	/* gds__null_flag */
          char  fb_412 [253];	/* RDB$FIELD_NAME */
          char  fb_413 [253];	/* RDB$QUERY_NAME */
          char  fb_414 [253];	/* RDB$SECURITY_CLASS */
          char  fb_415 [253];	/* RDB$OWNER_NAME */
   } fb_373;
/**************************************
 *
 *	w r i t e _ g l o b a l _ f i e l d s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each global field.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// if we have all capabilities, use the first request to get the
	// most performance out of the latest engine; if we don't
	// have one of the capabilities we must use the second set of
	// requests--this requires more code but it is well worth it
	// for the performance benefits, especially remotely--deej

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$FIELDS WITH
			X.RDB$SYSTEM_FLAG NE 1*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_372), fb_372);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 1274, CAST_MSG(&fb_373));
		   if (!fb_373.fb_385 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			put(tdgbl, rec_global_field);
			const SSHORT l = PUT_TEXT (att_field_name, /*X.RDB$FIELD_NAME*/
								   fb_373.fb_412);
			MISC_terminate (/*X.RDB$FIELD_NAME*/
					fb_373.fb_412, temp, l, sizeof(temp));
			BURP_verbose (149, temp);
			// msg 149  writing global field %.*s
			if (!/*X.RDB$QUERY_NAME.NULL*/
			     fb_373.fb_411 && /*X.RDB$QUERY_NAME*/
    fb_373.fb_413 [0] != ' ')
				PUT_TEXT (att_field_query_name, /*X.RDB$QUERY_NAME*/
								fb_373.fb_413);
			if (!/*X.RDB$EDIT_STRING.NULL*/
			     fb_373.fb_410 && /*X.RDB$EDIT_STRING*/
    fb_373.fb_384 [0] != ' ')
				PUT_TEXT (att_field_edit_string, /*X.RDB$EDIT_STRING*/
								 fb_373.fb_384);
			put_source_blob (att_field_query_header, att_field_query_header, /*X.RDB$QUERY_HEADER*/
											 fb_373.fb_383);
			put_int32 (att_field_type, /*X.RDB$FIELD_TYPE*/
						   fb_373.fb_409);
			put_int32 (att_field_length, /*X.RDB$FIELD_LENGTH*/
						     fb_373.fb_408);
			put_int32 (att_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
						       fb_373.fb_407);
			put_int32 (att_field_scale, /*X.RDB$FIELD_SCALE*/
						    fb_373.fb_406);
			put_blr_blob (att_field_missing_value, /*X.RDB$MISSING_VALUE*/
							       fb_373.fb_382);
			put_blr_blob (att_field_default_value, /*X.RDB$DEFAULT_VALUE*/
							       fb_373.fb_381);
			put_blr_blob (att_field_validation_blr, /*X.RDB$VALIDATION_BLR*/
								fb_373.fb_380);
			put_source_blob(att_field_validation_source2, att_field_validation_source,
							/*X.RDB$VALIDATION_SOURCE*/
							fb_373.fb_379);
			put_blr_blob (att_field_computed_blr, /*X.RDB$COMPUTED_BLR*/
							      fb_373.fb_378);
			put_source_blob(att_field_computed_source2, att_field_computed_source,
							/*X.RDB$COMPUTED_SOURCE*/
							fb_373.fb_377);
			if (/*X.RDB$SEGMENT_LENGTH*/
			    fb_373.fb_405)
				put_int32 (att_field_segment_length, /*X.RDB$SEGMENT_LENGTH*/
								     fb_373.fb_405);
			if (/*X.RDB$SYSTEM_FLAG*/
			    fb_373.fb_404)
				put_int32 (att_field_system_flag, /*X.RDB$SYSTEM_FLAG*/
								  fb_373.fb_404);
			put_source_blob (att_field_description2, att_field_description, /*X.RDB$DESCRIPTION*/
											fb_373.fb_376);

			if (/*X.RDB$EXTERNAL_LENGTH*/
			    fb_373.fb_403)
				put_int32 (att_field_external_length, /*X.RDB$EXTERNAL_LENGTH*/
								      fb_373.fb_403);
			if (/*X.RDB$EXTERNAL_TYPE*/
			    fb_373.fb_402)
				put_int32 (att_field_external_type, /*X.RDB$EXTERNAL_TYPE*/
								    fb_373.fb_402);
			if (/*X.RDB$EXTERNAL_SCALE*/
			    fb_373.fb_401)
				put_int32 (att_field_external_scale, /*X.RDB$EXTERNAL_SCALE*/
								     fb_373.fb_401);
			if (/*X.RDB$DIMENSIONS*/
			    fb_373.fb_400)
				put_int32 (att_field_dimensions, /*X.RDB$DIMENSIONS*/
								 fb_373.fb_400);
			if (!/*X.RDB$NULL_FLAG.NULL*/
			     fb_373.fb_398)
				put_int32 (att_field_null_flag, /*X.RDB$NULL_FLAG*/
								fb_373.fb_399);
			if (!/*X.RDB$CHARACTER_LENGTH.NULL*/
			     fb_373.fb_396)
				put_int32 (att_field_character_length, /*X.RDB$CHARACTER_LENGTH*/
								       fb_373.fb_397);
			if (!/*X.RDB$DEFAULT_SOURCE.NULL*/
			     fb_373.fb_395)
				put_source_blob(att_field_default_source, att_field_default_source,
								/*X.RDB$DEFAULT_SOURCE*/
								fb_373.fb_375);
			if (!/*X.RDB$MISSING_SOURCE.NULL*/
			     fb_373.fb_394)
				put_source_blob(att_field_missing_source, att_field_missing_source,
								/*X.RDB$MISSING_SOURCE*/
								fb_373.fb_374);
			if (!/*X.RDB$CHARACTER_SET_ID.NULL*/
			     fb_373.fb_392)
				put_int32 (att_field_character_set, /*X.RDB$CHARACTER_SET_ID*/
								    fb_373.fb_393);
			if (!/*X.RDB$COLLATION_ID.NULL*/
			     fb_373.fb_390)
				put_int32 (att_field_collation_id, /*X.RDB$COLLATION_ID*/
								   fb_373.fb_391);
			if (!/*X.RDB$FIELD_PRECISION.NULL*/
			     fb_373.fb_388)
				put_int32 (att_field_precision, /*X.RDB$FIELD_PRECISION*/
								fb_373.fb_389);

			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     fb_373.fb_387)
				PUT_TEXT(att_field_security_class, /*X.RDB$SECURITY_CLASS*/
								   fb_373.fb_414);
			if (!/*X.RDB$OWNER_NAME.NULL*/
			     fb_373.fb_386)
				PUT_TEXT(att_field_owner_name, /*X.RDB$OWNER_NAME*/
							       fb_373.fb_415);

			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else if (tdgbl->runtimeODS >= DB_VERSION_DDL10)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$FIELDS WITH
			X.RDB$SYSTEM_FLAG NE 1 OR
			X.RDB$SYSTEM_FLAG MISSING*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_332), fb_332);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 764, CAST_MSG(&fb_333));
		   if (!fb_333.fb_345 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			put(tdgbl, rec_global_field);
			const SSHORT l = PUT_TEXT (att_field_name, /*X.RDB$FIELD_NAME*/
								   fb_333.fb_370);
			MISC_terminate (/*X.RDB$FIELD_NAME*/
					fb_333.fb_370, temp, l, sizeof(temp));
			BURP_verbose (149, temp);
			// msg 149  writing global field %.*s
			if (!/*X.RDB$QUERY_NAME.NULL*/
			     fb_333.fb_369 && /*X.RDB$QUERY_NAME*/
    fb_333.fb_371 [0] != ' ')
				PUT_TEXT (att_field_query_name, /*X.RDB$QUERY_NAME*/
								fb_333.fb_371);
			if (!/*X.RDB$EDIT_STRING.NULL*/
			     fb_333.fb_368 && /*X.RDB$EDIT_STRING*/
    fb_333.fb_344 [0] != ' ')
				PUT_TEXT (att_field_edit_string, /*X.RDB$EDIT_STRING*/
								 fb_333.fb_344);
			put_source_blob (att_field_query_header, att_field_query_header, /*X.RDB$QUERY_HEADER*/
											 fb_333.fb_343);
			put_int32 (att_field_type, /*X.RDB$FIELD_TYPE*/
						   fb_333.fb_367);
			put_int32 (att_field_length, /*X.RDB$FIELD_LENGTH*/
						     fb_333.fb_366);
			put_int32 (att_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
						       fb_333.fb_365);
			put_int32 (att_field_scale, /*X.RDB$FIELD_SCALE*/
						    fb_333.fb_364);
			put_blr_blob (att_field_missing_value, /*X.RDB$MISSING_VALUE*/
							       fb_333.fb_342);
			put_blr_blob (att_field_default_value, /*X.RDB$DEFAULT_VALUE*/
							       fb_333.fb_341);
			put_blr_blob (att_field_validation_blr, /*X.RDB$VALIDATION_BLR*/
								fb_333.fb_340);
			put_source_blob(att_field_validation_source2, att_field_validation_source,
							/*X.RDB$VALIDATION_SOURCE*/
							fb_333.fb_339);
			put_blr_blob (att_field_computed_blr, /*X.RDB$COMPUTED_BLR*/
							      fb_333.fb_338);
			put_source_blob(att_field_computed_source2, att_field_computed_source,
							/*X.RDB$COMPUTED_SOURCE*/
							fb_333.fb_337);
			if (/*X.RDB$SEGMENT_LENGTH*/
			    fb_333.fb_363)
				put_int32 (att_field_segment_length, /*X.RDB$SEGMENT_LENGTH*/
								     fb_333.fb_363);
			if (/*X.RDB$SYSTEM_FLAG*/
			    fb_333.fb_362)
				put_int32 (att_field_system_flag, /*X.RDB$SYSTEM_FLAG*/
								  fb_333.fb_362);
			put_source_blob (att_field_description2, att_field_description, /*X.RDB$DESCRIPTION*/
											fb_333.fb_336);

			if (/*X.RDB$EXTERNAL_LENGTH*/
			    fb_333.fb_361)
				put_int32 (att_field_external_length, /*X.RDB$EXTERNAL_LENGTH*/
								      fb_333.fb_361);
			if (/*X.RDB$EXTERNAL_TYPE*/
			    fb_333.fb_360)
				put_int32 (att_field_external_type, /*X.RDB$EXTERNAL_TYPE*/
								    fb_333.fb_360);
			if (/*X.RDB$EXTERNAL_SCALE*/
			    fb_333.fb_359)
				put_int32 (att_field_external_scale, /*X.RDB$EXTERNAL_SCALE*/
								     fb_333.fb_359);
			if (/*X.RDB$DIMENSIONS*/
			    fb_333.fb_358)
				put_int32 (att_field_dimensions, /*X.RDB$DIMENSIONS*/
								 fb_333.fb_358);
			if (!/*X.RDB$NULL_FLAG.NULL*/
			     fb_333.fb_356)
				put_int32 (att_field_null_flag, /*X.RDB$NULL_FLAG*/
								fb_333.fb_357);
			if (!/*X.RDB$CHARACTER_LENGTH.NULL*/
			     fb_333.fb_354)
				put_int32 (att_field_character_length, /*X.RDB$CHARACTER_LENGTH*/
								       fb_333.fb_355);
			if (!/*X.RDB$DEFAULT_SOURCE.NULL*/
			     fb_333.fb_353)
				put_source_blob(att_field_default_source, att_field_default_source,
								/*X.RDB$DEFAULT_SOURCE*/
								fb_333.fb_335);
			if (!/*X.RDB$MISSING_SOURCE.NULL*/
			     fb_333.fb_352)
				put_source_blob(att_field_missing_source, att_field_missing_source,
								/*X.RDB$MISSING_SOURCE*/
								fb_333.fb_334);
			if (!/*X.RDB$CHARACTER_SET_ID.NULL*/
			     fb_333.fb_350)
				put_int32 (att_field_character_set, /*X.RDB$CHARACTER_SET_ID*/
								    fb_333.fb_351);
			if (!/*X.RDB$COLLATION_ID.NULL*/
			     fb_333.fb_348)
				put_int32 (att_field_collation_id, /*X.RDB$COLLATION_ID*/
								   fb_333.fb_349);

			if (!/*X.RDB$FIELD_PRECISION.NULL*/
			     fb_333.fb_346)
				put_int32 (att_field_precision, /*X.RDB$FIELD_PRECISION*/
								fb_333.fb_347);

			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$FIELDS WITH
			X.RDB$SYSTEM_FLAG NE 1 OR
			X.RDB$SYSTEM_FLAG MISSING*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_294), fb_294);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 760, CAST_MSG(&fb_295));
		   if (!fb_295.fb_307 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			put(tdgbl, rec_global_field);
			const SSHORT l = PUT_TEXT (att_field_name, /*X.RDB$FIELD_NAME*/
								   fb_295.fb_330);
			MISC_terminate (/*X.RDB$FIELD_NAME*/
					fb_295.fb_330, temp, l, sizeof(temp));
			BURP_verbose (149, temp);
			// msg 149  writing global field %.*s
			if (!/*X.RDB$QUERY_NAME.NULL*/
			     fb_295.fb_329 && /*X.RDB$QUERY_NAME*/
    fb_295.fb_331 [0] != ' ')
				PUT_TEXT (att_field_query_name, /*X.RDB$QUERY_NAME*/
								fb_295.fb_331);
			if (!/*X.RDB$EDIT_STRING.NULL*/
			     fb_295.fb_328 && /*X.RDB$EDIT_STRING*/
    fb_295.fb_306 [0] != ' ')
				PUT_TEXT (att_field_edit_string, /*X.RDB$EDIT_STRING*/
								 fb_295.fb_306);
			put_source_blob (att_field_query_header, att_field_query_header, /*X.RDB$QUERY_HEADER*/
											 fb_295.fb_305);
			put_int32 (att_field_type, /*X.RDB$FIELD_TYPE*/
						   fb_295.fb_327);
			put_int32 (att_field_length, /*X.RDB$FIELD_LENGTH*/
						     fb_295.fb_326);
			put_int32 (att_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
						       fb_295.fb_325);
			put_int32 (att_field_scale, /*X.RDB$FIELD_SCALE*/
						    fb_295.fb_324);
			put_blr_blob (att_field_missing_value, /*X.RDB$MISSING_VALUE*/
							       fb_295.fb_304);
			put_blr_blob (att_field_default_value, /*X.RDB$DEFAULT_VALUE*/
							       fb_295.fb_303);
			put_blr_blob (att_field_validation_blr, /*X.RDB$VALIDATION_BLR*/
								fb_295.fb_302);
			put_source_blob(att_field_validation_source2, att_field_validation_source,
							/*X.RDB$VALIDATION_SOURCE*/
							fb_295.fb_301);
			put_blr_blob (att_field_computed_blr, /*X.RDB$COMPUTED_BLR*/
							      fb_295.fb_300);
			put_source_blob (att_field_computed_source2, att_field_computed_source,
				/*X.RDB$COMPUTED_SOURCE*/
				fb_295.fb_299);
			if (/*X.RDB$SEGMENT_LENGTH*/
			    fb_295.fb_323)
				put_int32 (att_field_segment_length, /*X.RDB$SEGMENT_LENGTH*/
								     fb_295.fb_323);
			if (/*X.RDB$SYSTEM_FLAG*/
			    fb_295.fb_322)
				put_int32 (att_field_system_flag, /*X.RDB$SYSTEM_FLAG*/
								  fb_295.fb_322);
			put_source_blob (att_field_description2, att_field_description, /*X.RDB$DESCRIPTION*/
											fb_295.fb_298);
			if (/*X.RDB$EXTERNAL_LENGTH*/
			    fb_295.fb_321)
				put_int32 (att_field_external_length, /*X.RDB$EXTERNAL_LENGTH*/
								      fb_295.fb_321);
			if (/*X.RDB$EXTERNAL_TYPE*/
			    fb_295.fb_320)
				put_int32 (att_field_external_type, /*X.RDB$EXTERNAL_TYPE*/
								    fb_295.fb_320);
			if (/*X.RDB$EXTERNAL_SCALE*/
			    fb_295.fb_319)
				put_int32 (att_field_external_scale, /*X.RDB$EXTERNAL_SCALE*/
								     fb_295.fb_319);
			if (/*X.RDB$DIMENSIONS*/
			    fb_295.fb_318)
				put_int32 (att_field_dimensions, /*X.RDB$DIMENSIONS*/
								 fb_295.fb_318);
			if (!/*X.RDB$NULL_FLAG.NULL*/
			     fb_295.fb_316)
				put_int32 (att_field_null_flag, /*X.RDB$NULL_FLAG*/
								fb_295.fb_317);
			if (!/*X.RDB$CHARACTER_LENGTH.NULL*/
			     fb_295.fb_314)
				put_int32 (att_field_character_length, /*X.RDB$CHARACTER_LENGTH*/
								       fb_295.fb_315);
			if (!/*X.RDB$DEFAULT_SOURCE.NULL*/
			     fb_295.fb_313)
				put_source_blob(att_field_default_source, att_field_default_source,
								/*X.RDB$DEFAULT_SOURCE*/
								fb_295.fb_297);
			if (!/*X.RDB$MISSING_SOURCE.NULL*/
			     fb_295.fb_312)
				put_source_blob(att_field_missing_source, att_field_missing_source,
								/*X.RDB$MISSING_SOURCE*/
								fb_295.fb_296);
			if (!/*X.RDB$CHARACTER_SET_ID.NULL*/
			     fb_295.fb_310)
				put_int32 (att_field_character_set, /*X.RDB$CHARACTER_SET_ID*/
								    fb_295.fb_311);
			if (!/*X.RDB$COLLATION_ID.NULL*/
			     fb_295.fb_308)
				put_int32 (att_field_collation_id, /*X.RDB$COLLATION_ID*/
								   fb_295.fb_309);

			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_packages()
{
   struct fb_277_struct {
          ISC_QUAD fb_278;	/* RDB$DESCRIPTION */
          ISC_QUAD fb_279;	/* RDB$PACKAGE_BODY_SOURCE */
          ISC_QUAD fb_280;	/* RDB$PACKAGE_HEADER_SOURCE */
          short fb_281;	/* fbUtility */
          short fb_282;	/* gds__null_flag */
          short fb_283;	/* gds__null_flag */
          short fb_284;	/* gds__null_flag */
          short fb_285;	/* gds__null_flag */
          short fb_286;	/* gds__null_flag */
          short fb_287;	/* RDB$VALID_BODY_FLAG */
          short fb_288;	/* gds__null_flag */
          short fb_289;	/* gds__null_flag */
          char  fb_290 [253];	/* RDB$PACKAGE_NAME */
          char  fb_291 [253];	/* RDB$SECURITY_CLASS */
          char  fb_292 [253];	/* RDB$OWNER_NAME */
          FB_BOOLEAN fb_293;	/* RDB$SQL_SECURITY */
   } fb_277;
/**************************************
 *
 *	w r i t e _ p a c k a g e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each package.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// This code is for DDL12 onwards, so no need to check for null sysflag.
	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$PACKAGES
		WITH X.RDB$SYSTEM_FLAG NE 1*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle1 && DB)
	      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_276), fb_276);
	   if (req_handle1)
	      req_handle1->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle1->receive (fbStatus, 0, 0, 802, CAST_MSG(&fb_277));
	   if (!fb_277.fb_281 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
	{
		put(tdgbl, rec_package);
		const SSHORT l = PUT_TEXT(att_package_name, /*X.RDB$PACKAGE_NAME*/
							    fb_277.fb_290);
		MISC_terminate(/*X.RDB$PACKAGE_NAME*/
			       fb_277.fb_290, temp, l, sizeof(temp));

		BURP_verbose(335, temp);	// msg 335 writing package @1

		if (!/*X.RDB$PACKAGE_HEADER_SOURCE.NULL*/
		     fb_277.fb_289)
		{
			put_source_blob(att_package_header_source, att_package_header_source,
				/*X.RDB$PACKAGE_HEADER_SOURCE*/
				fb_277.fb_280);
		}

		if (!/*X.RDB$PACKAGE_BODY_SOURCE.NULL*/
		     fb_277.fb_288)
		{
			put_source_blob(att_package_body_source, att_package_body_source,
				/*X.RDB$PACKAGE_BODY_SOURCE*/
				fb_277.fb_279);
		}

		if (!/*X.RDB$VALID_BODY_FLAG.NULL*/
		     fb_277.fb_286)
			put_int32(att_package_valid_body_flag, /*X.RDB$VALID_BODY_FLAG*/
							       fb_277.fb_287);

		if (!/*X.RDB$SECURITY_CLASS.NULL*/
		     fb_277.fb_285)
			PUT_TEXT(att_package_security_class, /*X.RDB$SECURITY_CLASS*/
							     fb_277.fb_291);
		if (!/*X.RDB$OWNER_NAME.NULL*/
		     fb_277.fb_284)
			PUT_TEXT(att_package_owner_name, /*X.RDB$OWNER_NAME*/
							 fb_277.fb_292);

		if (!/*X.RDB$DESCRIPTION.NULL*/
		     fb_277.fb_283)
			put_source_blob(att_package_description, att_package_description, /*X.RDB$DESCRIPTION*/
											  fb_277.fb_278);

		if (!/*X.RDB$SQL_SECURITY.NULL*/
		     fb_277.fb_282)
			put_boolean(att_package_sql_security, /*X.RDB$SQL_SECURITY*/
							      fb_277.fb_293);

		put(tdgbl, att_end);
	}
	/*END_FOR*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_procedures()
{
   struct fb_235_struct {
          ISC_QUAD fb_236;	/* RDB$PROCEDURE_BLR */
          ISC_QUAD fb_237;	/* RDB$PROCEDURE_SOURCE */
          ISC_QUAD fb_238;	/* RDB$DESCRIPTION */
          short fb_239;	/* fbUtility */
          short fb_240;	/* gds__null_flag */
          short fb_241;	/* RDB$PROCEDURE_OUTPUTS */
          short fb_242;	/* RDB$PROCEDURE_INPUTS */
          char  fb_243 [253];	/* RDB$PROCEDURE_NAME */
          char  fb_244 [253];	/* RDB$SECURITY_CLASS */
          char  fb_245 [253];	/* RDB$OWNER_NAME */
   } fb_235;
   struct fb_247_struct {
          char  fb_248 [256];	/* RDB$ENTRYPOINT */
          ISC_QUAD fb_249;	/* RDB$DEBUG_INFO */
          ISC_QUAD fb_250;	/* RDB$PROCEDURE_BLR */
          ISC_QUAD fb_251;	/* RDB$PROCEDURE_SOURCE */
          ISC_QUAD fb_252;	/* RDB$DESCRIPTION */
          short fb_253;	/* fbUtility */
          short fb_254;	/* gds__null_flag */
          short fb_255;	/* gds__null_flag */
          short fb_256;	/* RDB$PRIVATE_FLAG */
          short fb_257;	/* gds__null_flag */
          short fb_258;	/* gds__null_flag */
          short fb_259;	/* gds__null_flag */
          short fb_260;	/* gds__null_flag */
          short fb_261;	/* RDB$VALID_BLR */
          short fb_262;	/* gds__null_flag */
          short fb_263;	/* RDB$PROCEDURE_TYPE */
          short fb_264;	/* gds__null_flag */
          short fb_265;	/* gds__null_flag */
          short fb_266;	/* gds__null_flag */
          short fb_267;	/* RDB$PROCEDURE_OUTPUTS */
          short fb_268;	/* RDB$PROCEDURE_INPUTS */
          short fb_269;	/* gds__null_flag */
          char  fb_270 [253];	/* RDB$PACKAGE_NAME */
          char  fb_271 [253];	/* RDB$PROCEDURE_NAME */
          char  fb_272 [253];	/* RDB$SECURITY_CLASS */
          char  fb_273 [253];	/* RDB$OWNER_NAME */
          char  fb_274 [253];	/* RDB$ENGINE_NAME */
          FB_BOOLEAN fb_275;	/* RDB$SQL_SECURITY */
   } fb_247;
/**************************************
 *
 *	w r i t e _ p r o c e d u r e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each stored procedure.
 *
 **************************************/
	GDS_NAME proc;
	TEXT temp[GDS_NAME_LEN * 2];
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL11_1)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$PROCEDURES
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_246), fb_246);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 1588, CAST_MSG(&fb_247));
		   if (!fb_247.fb_253 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			put(tdgbl, rec_procedure);

			SSHORT prefixLen = 0;

			if (!/*X.RDB$PACKAGE_NAME.NULL*/
			     fb_247.fb_269)
			{
				prefixLen = PUT_TEXT(att_procedure_package_name, /*X.RDB$PACKAGE_NAME*/
										 fb_247.fb_270);
				MISC_terminate (/*X.RDB$PACKAGE_NAME*/
						fb_247.fb_270, temp, prefixLen, sizeof(temp));
				temp[prefixLen++] = '.';
			}

			const SSHORT len = PUT_TEXT (att_procedure_name, /*X.RDB$PROCEDURE_NAME*/
									 fb_247.fb_271);
			MISC_terminate (/*X.RDB$PROCEDURE_NAME*/
					fb_247.fb_271, temp + prefixLen, len, sizeof(temp) - prefixLen);

			BURP_verbose (193, temp);
			// msg 193 writing stored procedure %.*s
			put_int32 (att_procedure_inputs, /*X.RDB$PROCEDURE_INPUTS*/
							 fb_247.fb_268);
			put_int32 (att_procedure_outputs, /*X.RDB$PROCEDURE_OUTPUTS*/
							  fb_247.fb_267);
			put_source_blob(att_procedure_description2, att_procedure_description, /*X.RDB$DESCRIPTION*/
											       fb_247.fb_252);
			put_source_blob (att_procedure_source2, att_procedure_source, /*X.RDB$PROCEDURE_SOURCE*/
										      fb_247.fb_251);

			if (!/*X.RDB$PROCEDURE_BLR.NULL*/
			     fb_247.fb_266)
				put_blr_blob (att_procedure_blr, /*X.RDB$PROCEDURE_BLR*/
								 fb_247.fb_250);

			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     fb_247.fb_265)
				PUT_TEXT (att_procedure_security_class, /*X.RDB$SECURITY_CLASS*/
									fb_247.fb_272);
			if (!/*X.RDB$OWNER_NAME.NULL*/
			     fb_247.fb_264)
				PUT_TEXT (att_procedure_owner_name, /*X.RDB$OWNER_NAME*/
								    fb_247.fb_273);
			if (!/*X.RDB$PROCEDURE_TYPE.NULL*/
			     fb_247.fb_262)
				put_int32 (att_procedure_type, /*X.RDB$PROCEDURE_TYPE*/
							       fb_247.fb_263);
			if (!/*X.RDB$VALID_BLR.NULL*/
			     fb_247.fb_260)
				put_int32 (att_procedure_valid_blr, /*X.RDB$VALID_BLR*/
								    fb_247.fb_261);
			if (!/*X.RDB$DEBUG_INFO.NULL*/
			     fb_247.fb_259)
				put_blr_blob (att_procedure_debug_info, /*X.RDB$DEBUG_INFO*/
									fb_247.fb_249);

			if (!/*X.RDB$ENGINE_NAME.NULL*/
			     fb_247.fb_258)
				PUT_TEXT(att_procedure_engine_name, /*X.RDB$ENGINE_NAME*/
								    fb_247.fb_274);

			if (!/*X.RDB$ENTRYPOINT.NULL*/
			     fb_247.fb_257)
				PUT_TEXT(att_procedure_entrypoint, /*X.RDB$ENTRYPOINT*/
								   fb_247.fb_248);

			if (!/*X.RDB$PRIVATE_FLAG.NULL*/
			     fb_247.fb_255)
				put_int32(att_procedure_private_flag, /*X.RDB$PRIVATE_FLAG*/
								      fb_247.fb_256);

			if (!/*X.RDB$SQL_SECURITY.NULL*/
			     fb_247.fb_254)
				put_boolean(att_procedure_sql_security, /*X.RDB$SQL_SECURITY*/
									fb_247.fb_275);

			put(tdgbl, att_end);
			COPY(/*X.RDB$PROCEDURE_NAME*/
			     fb_247.fb_271, proc);
			write_procedure_prms ((/*X.RDB$PACKAGE_NAME.NULL*/
					       fb_247.fb_269 ? "" : /*X.RDB$PACKAGE_NAME*/
	fb_247.fb_270), proc);
			put(tdgbl, rec_procedure_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$PROCEDURES
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_234), fb_234);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 791, CAST_MSG(&fb_235));
		   if (!fb_235.fb_239 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			put(tdgbl, rec_procedure);
			const SSHORT l = PUT_TEXT (att_procedure_name, /*X.RDB$PROCEDURE_NAME*/
								       fb_235.fb_243);
			MISC_terminate (/*X.RDB$PROCEDURE_NAME*/
					fb_235.fb_243, temp, l, sizeof(temp));
			BURP_verbose (193, temp);
			// msg 193 writing stored procedure %.*s
			put_int32 (att_procedure_inputs, /*X.RDB$PROCEDURE_INPUTS*/
							 fb_235.fb_242);
			put_int32 (att_procedure_outputs, /*X.RDB$PROCEDURE_OUTPUTS*/
							  fb_235.fb_241);
			put_source_blob (att_procedure_description2, att_procedure_description, /*X.RDB$DESCRIPTION*/
												fb_235.fb_238);
			put_source_blob (att_procedure_source2, att_procedure_source, /*X.RDB$PROCEDURE_SOURCE*/
										      fb_235.fb_237);
			put_blr_blob (att_procedure_blr, /*X.RDB$PROCEDURE_BLR*/
							 fb_235.fb_236);
			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     fb_235.fb_240)
				PUT_TEXT (att_procedure_security_class, /*X.RDB$SECURITY_CLASS*/
									fb_235.fb_244);
			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     fb_235.fb_240)
				PUT_TEXT (att_procedure_owner_name, /*X.RDB$OWNER_NAME*/
								    fb_235.fb_245);
			put(tdgbl, att_end);
			COPY(/*X.RDB$PROCEDURE_NAME*/
			     fb_235.fb_243, proc);
			write_procedure_prms ("", proc);
			put(tdgbl, rec_procedure_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_procedure_prms(const GDS_NAME package, const GDS_NAME procptr)
{
   struct fb_204_struct {
          ISC_QUAD fb_205;	/* RDB$DESCRIPTION */
          short fb_206;	/* fbUtility */
          short fb_207;	/* RDB$PARAMETER_TYPE */
          short fb_208;	/* RDB$PARAMETER_NUMBER */
          char  fb_209 [253];	/* RDB$PARAMETER_NAME */
          char  fb_210 [253];	/* RDB$FIELD_SOURCE */
   } fb_204;
   struct fb_202_struct {
          char  fb_203 [253];	/* RDB$PROCEDURE_NAME */
   } fb_202;
   struct fb_215_struct {
          ISC_QUAD fb_216;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD fb_217;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD fb_218;	/* RDB$DESCRIPTION */
          short fb_219;	/* fbUtility */
          short fb_220;	/* gds__null_flag */
          short fb_221;	/* gds__null_flag */
          short fb_222;	/* gds__null_flag */
          short fb_223;	/* RDB$PARAMETER_MECHANISM */
          short fb_224;	/* gds__null_flag */
          short fb_225;	/* RDB$NULL_FLAG */
          short fb_226;	/* gds__null_flag */
          short fb_227;	/* RDB$COLLATION_ID */
          short fb_228;	/* RDB$PARAMETER_TYPE */
          short fb_229;	/* RDB$PARAMETER_NUMBER */
          char  fb_230 [253];	/* RDB$PARAMETER_NAME */
          char  fb_231 [253];	/* RDB$FIELD_SOURCE */
          char  fb_232 [253];	/* RDB$FIELD_NAME */
          char  fb_233 [253];	/* RDB$RELATION_NAME */
   } fb_215;
   struct fb_212_struct {
          char  fb_213 [253];	/* RDB$PROCEDURE_NAME */
          char  fb_214 [253];	/* RDB$PACKAGE_NAME */
   } fb_212;
/**************************************
 *
 *	w r i t e _ p r o c e d u r e _ p r m s
 *
 **************************************
 *
 * Functional description
 * 	write all parameters of a stored procedure.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL11_1)
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_write_procedure_prms_req_handle1)
			X IN RDB$PROCEDURE_PARAMETERS
			WITH X.RDB$PROCEDURE_NAME EQ procptr AND
				 X.RDB$PACKAGE_NAME EQUIV NULLIF(package, '')*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!tdgbl->handles_write_procedure_prms_req_handle1 && DB)
		      tdgbl->handles_write_procedure_prms_req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_211), fb_211);
		   isc_vtov ((const char*) procptr, (char*) fb_212.fb_213, 253);
		   isc_vtov ((const char*) package, (char*) fb_212.fb_214, 253);
		   if (tdgbl->handles_write_procedure_prms_req_handle1)
		      tdgbl->handles_write_procedure_prms_req_handle1->startAndSend(fbStatus, fbTrans, 0, 0, 506, CAST_CONST_MSG(&fb_212));
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { tdgbl->handles_write_procedure_prms_req_handle1->release(); tdgbl->handles_write_procedure_prms_req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   tdgbl->handles_write_procedure_prms_req_handle1->receive (fbStatus, 0, 1, 1058, CAST_MSG(&fb_215));
		   if (!fb_215.fb_219 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
		{
			put(tdgbl, rec_procedure_prm);
			const SSHORT l = PUT_TEXT (att_procedureprm_name, /*X.RDB$PARAMETER_NAME*/
									  fb_215.fb_230);
			MISC_terminate (/*X.RDB$PARAMETER_NAME*/
					fb_215.fb_230, temp, l, sizeof(temp));
			BURP_verbose (194, temp);
			// msg 194 writing parameter %s for stored procedure
			put_int32 (att_procedureprm_number, /*X.RDB$PARAMETER_NUMBER*/
							    fb_215.fb_229);
			put_int32 (att_procedureprm_type, /*X.RDB$PARAMETER_type*/
							  fb_215.fb_228);
			PUT_TEXT (att_procedureprm_field_source, /*X.RDB$FIELD_SOURCE*/
								 fb_215.fb_231);
			put_source_blob(att_procedureprm_description2, att_procedureprm_description,
							/*X.RDB$DESCRIPTION*/
							fb_215.fb_218);
			put_blr_blob (att_procedureprm_default_value, /*X.RDB$DEFAULT_VALUE*/
								      fb_215.fb_217);
			put_source_blob(att_procedureprm_default_source, att_procedureprm_default_source,
							/*X.RDB$DEFAULT_SOURCE*/
							fb_215.fb_216);
			if (!/*X.RDB$COLLATION_ID.NULL*/
			     fb_215.fb_226)
				put_int32 (att_procedureprm_collation_id, /*X.RDB$COLLATION_ID*/
									  fb_215.fb_227);
			if (!/*X.RDB$NULL_FLAG.NULL*/
			     fb_215.fb_224)
				put_int32 (att_procedureprm_null_flag, /*X.RDB$NULL_FLAG*/
								       fb_215.fb_225);
			if (!/*X.RDB$PARAMETER_MECHANISM.NULL*/
			     fb_215.fb_222)
				put_int32 (att_procedureprm_mechanism, /*X.RDB$PARAMETER_MECHANISM*/
								       fb_215.fb_223);

			// DB_VERSION_DDL11_2
			if (!/*X.RDB$FIELD_NAME.NULL*/
			     fb_215.fb_221)
				PUT_TEXT(att_procedureprm_field_name, /*X.RDB$FIELD_NAME*/
								      fb_215.fb_232);
			if (!/*X.RDB$RELATION_NAME.NULL*/
			     fb_215.fb_220)
				PUT_TEXT(att_procedureprm_relation_name, /*X.RDB$RELATION_NAME*/
									 fb_215.fb_233);

			put(tdgbl, att_end);
		}
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_write_procedure_prms_req_handle1)
			X IN RDB$PROCEDURE_PARAMETERS WITH X.RDB$PROCEDURE_NAME EQ procptr*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!tdgbl->handles_write_procedure_prms_req_handle1 && DB)
		      tdgbl->handles_write_procedure_prms_req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_201), fb_201);
		   isc_vtov ((const char*) procptr, (char*) fb_202.fb_203, 253);
		   if (tdgbl->handles_write_procedure_prms_req_handle1)
		      tdgbl->handles_write_procedure_prms_req_handle1->startAndSend(fbStatus, fbTrans, 0, 0, 253, CAST_CONST_MSG(&fb_202));
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { tdgbl->handles_write_procedure_prms_req_handle1->release(); tdgbl->handles_write_procedure_prms_req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   tdgbl->handles_write_procedure_prms_req_handle1->receive (fbStatus, 0, 1, 520, CAST_MSG(&fb_204));
		   if (!fb_204.fb_206 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
			put(tdgbl, rec_procedure_prm);
			const SSHORT l = PUT_TEXT (att_procedureprm_name, /*X.RDB$PARAMETER_NAME*/
									  fb_204.fb_209);
			MISC_terminate (/*X.RDB$PARAMETER_NAME*/
					fb_204.fb_209, temp, l, sizeof(temp));
			BURP_verbose (194, temp);
			// msg 194 writing parameter %s for stored procedure
			put_int32 (att_procedureprm_number, /*X.RDB$PARAMETER_NUMBER*/
							    fb_204.fb_208);
			put_int32 (att_procedureprm_type, /*X.RDB$PARAMETER_type*/
							  fb_204.fb_207);
			PUT_TEXT (att_procedureprm_field_source, /*X.RDB$FIELD_SOURCE*/
								 fb_204.fb_210);
			put_source_blob(att_procedureprm_description2, att_procedureprm_description,
							/*X.RDB$DESCRIPTION*/
							fb_204.fb_205);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
}


void write_publications()
{
   struct fb_192_struct {
          short fb_193;	/* fbUtility */
          short fb_194;	/* gds__null_flag */
          short fb_195;	/* RDB$AUTO_ENABLE */
          short fb_196;	/* gds__null_flag */
          short fb_197;	/* RDB$ACTIVE_FLAG */
          short fb_198;	/* gds__null_flag */
          char  fb_199 [253];	/* RDB$PUBLICATION_NAME */
          char  fb_200 [253];	/* RDB$OWNER_NAME */
   } fb_192;
/**************************************
 *
 *	w r i t e _ p u b l i c a t i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each publication.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	Firebird::IRequest* req_handle = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle)
		X IN RDB$PUBLICATIONS
		WITH X.RDB$SYSTEM_FLAG NE 1*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle && DB)
	      req_handle = DB->compileRequest(fbStatus, sizeof(fb_191), fb_191);
	   if (req_handle)
	      req_handle->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle->release(); req_handle = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle->receive (fbStatus, 0, 0, 518, CAST_MSG(&fb_192));
	   if (!fb_192.fb_193 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
	{
		put(tdgbl, rec_publication);

		const SSHORT l = PUT_TEXT(att_pub_name, /*X.RDB$PUBLICATION_NAME*/
							fb_192.fb_199);
		MISC_terminate(/*X.RDB$PUBLICATION_NAME*/
			       fb_192.fb_199, temp, l, sizeof(temp));

		BURP_verbose(397, temp);
		// msg 397 writing publication %s

		if (!/*X.RDB$OWNER_NAME.NULL*/
		     fb_192.fb_198)
			PUT_TEXT(att_pub_owner_name, /*X.RDB$OWNER_NAME*/
						     fb_192.fb_200);

		if (!/*X.RDB$ACTIVE_FLAG.NULL*/
		     fb_192.fb_196)
			put_int32(att_pub_active_flag, /*X.RDB$ACTIVE_FLAG*/
						       fb_192.fb_197);

		if (!/*X.RDB$AUTO_ENABLE.NULL*/
		     fb_192.fb_194)
			put_int32(att_pub_auto_enable, /*X.RDB$AUTO_ENABLE*/
						       fb_192.fb_195);

		put(tdgbl, att_end);
	}
	/*END_FOR*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR*/
	   }
	}

	MISC_release_request_silent(req_handle);
}


void write_pub_tables()
{
   struct fb_187_struct {
          short fb_188;	/* fbUtility */
          char  fb_189 [253];	/* RDB$PUBLICATION_NAME */
          char  fb_190 [253];	/* RDB$TABLE_NAME */
   } fb_187;
/**************************************
 *
 *	w r i t e _ p u b _ t a b l e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each publication table.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	Firebird::IRequest* req_handle = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle)
		X IN RDB$PUBLICATION_TABLES*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle && DB)
	      req_handle = DB->compileRequest(fbStatus, sizeof(fb_186), fb_186);
	   if (req_handle)
	      req_handle->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle->release(); req_handle = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle->receive (fbStatus, 0, 0, 508, CAST_MSG(&fb_187));
	   if (!fb_187.fb_188 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
	{
		put(tdgbl, rec_pub_table);

		PUT_TEXT(att_ptab_pub_name, /*X.RDB$PUBLICATION_NAME*/
					    fb_187.fb_189);

		const SSHORT l = PUT_TEXT(att_ptab_table_name, /*X.RDB$TABLE_NAME*/
							       fb_187.fb_190);
		MISC_terminate(/*X.RDB$TABLE_NAME*/
			       fb_187.fb_190, temp, l, sizeof(temp));

		BURP_verbose(398, temp);
		// msg 398 writing publication for table %s

		put(tdgbl, att_end);
	}
	/*END_FOR*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR*/
	   }
	}

	MISC_release_request_silent(req_handle);
}


void write_ref_constraints()
{
   struct fb_179_struct {
          char  fb_180 [8];	/* RDB$MATCH_OPTION */
          char  fb_181 [12];	/* RDB$DELETE_RULE */
          char  fb_182 [12];	/* RDB$UPDATE_RULE */
          short fb_183;	/* fbUtility */
          char  fb_184 [253];	/* RDB$CONSTRAINT_NAME */
          char  fb_185 [253];	/* RDB$CONST_NAME_UQ */
   } fb_179;
/**************************************
 *
 *	w r i t e _ r e f _ c o n s t r a i n t s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each referential constraint.
 *
 **************************************/
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$REF_CONSTRAINTS*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle1 && DB)
	      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_178), fb_178);
	   if (req_handle1)
	      req_handle1->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle1->receive (fbStatus, 0, 0, 540, CAST_MSG(&fb_179));
	   if (!fb_179.fb_183 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
		put(tdgbl, rec_ref_constraint);
		PUT_TEXT (att_ref_constraint_name, /*X.RDB$CONSTRAINT_NAME*/
						   fb_179.fb_184);
		PUT_TEXT (att_ref_unique_const_name, /*X.RDB$CONST_NAME_UQ*/
						     fb_179.fb_185);
		PUT_TEXT (att_ref_match_option, /*X.RDB$MATCH_OPTION*/
						fb_179.fb_180);
		PUT_TEXT (att_ref_update_rule, /*X.RDB$UPDATE_RULE*/
					       fb_179.fb_182);
		PUT_TEXT (att_ref_delete_rule, /*X.RDB$DELETE_RULE*/
					       fb_179.fb_181);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_rel_constraints()
{
   struct fb_169_struct {
          char  fb_170 [4];	/* RDB$INITIALLY_DEFERRED */
          char  fb_171 [4];	/* RDB$DEFERRABLE */
          char  fb_172 [12];	/* RDB$CONSTRAINT_TYPE */
          short fb_173;	/* fbUtility */
          short fb_174;	/* gds__null_flag */
          char  fb_175 [253];	/* RDB$CONSTRAINT_NAME */
          char  fb_176 [253];	/* RDB$RELATION_NAME */
          char  fb_177 [253];	/* RDB$INDEX_NAME */
   } fb_169;
/**************************************
 *
 *	w r i t e _ r e l _ c o n s t r a i n t s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each relation constraint.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$RELATION_CONSTRAINTS CROSS
		REL IN RDB$RELATIONS
		WITH REL.RDB$RELATION_NAME EQ X.RDB$RELATION_NAME AND
			 (REL.RDB$SYSTEM_FLAG MISSING OR REL.RDB$SYSTEM_FLAG NE 1)*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle1 && DB)
	      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_168), fb_168);
	   if (req_handle1)
	      req_handle1->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle1->receive (fbStatus, 0, 0, 783, CAST_MSG(&fb_169));
	   if (!fb_169.fb_173 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
		put(tdgbl, rec_rel_constraint);
		const SSHORT l = PUT_TEXT (att_rel_constraint_name, /*X.RDB$CONSTRAINT_NAME*/
								    fb_169.fb_175);
		MISC_terminate (/*X.RDB$CONSTRAINT_NAME*/
				fb_169.fb_175, temp, l, sizeof(temp));
		BURP_verbose (207, temp);
		// msg 207 writing constraint %s
		PUT_TEXT (att_rel_constraint_type, /*X.RDB$CONSTRAINT_TYPE*/
						   fb_169.fb_172);
		PUT_TEXT (att_rel_constraint_rel_name, /*X.RDB$RELATION_NAME*/
						       fb_169.fb_176);
		PUT_TEXT (att_rel_constraint_defer, /*X.RDB$DEFERRABLE*/
						    fb_169.fb_171);
		PUT_TEXT (att_rel_constraint_init, /*X.RDB$INITIALLY_DEFERRED*/
						   fb_169.fb_170);
		if (!/*X.RDB$INDEX_NAME.NULL*/
		     fb_169.fb_174)
			PUT_TEXT (att_rel_constraint_index, /*X.RDB$INDEX_NAME*/
							    fb_169.fb_177);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_relations()
{
   struct fb_130_struct {
          char  fb_131 [256];	/* RDB$EXTERNAL_FILE */
          ISC_QUAD fb_132;	/* RDB$EXTERNAL_DESCRIPTION */
          ISC_QUAD fb_133;	/* RDB$VIEW_SOURCE */
          ISC_QUAD fb_134;	/* RDB$DESCRIPTION */
          ISC_QUAD fb_135;	/* RDB$VIEW_BLR */
          short fb_136;	/* fbUtility */
          short fb_137;	/* RDB$RELATION_ID */
          short fb_138;	/* gds__null_flag */
          short fb_139;	/* gds__null_flag */
          short fb_140;	/* gds__null_flag */
          short fb_141;	/* RDB$FLAGS */
          short fb_142;	/* RDB$SYSTEM_FLAG */
          char  fb_143 [253];	/* RDB$RELATION_NAME */
          char  fb_144 [253];	/* RDB$SECURITY_CLASS */
          char  fb_145 [253];	/* RDB$OWNER_NAME */
   } fb_130;
   struct fb_147_struct {
          char  fb_148 [256];	/* RDB$EXTERNAL_FILE */
          ISC_QUAD fb_149;	/* RDB$EXTERNAL_DESCRIPTION */
          ISC_QUAD fb_150;	/* RDB$VIEW_SOURCE */
          ISC_QUAD fb_151;	/* RDB$DESCRIPTION */
          ISC_QUAD fb_152;	/* RDB$VIEW_BLR */
          short fb_153;	/* fbUtility */
          short fb_154;	/* RDB$RELATION_ID */
          short fb_155;	/* gds__null_flag */
          short fb_156;	/* gds__null_flag */
          short fb_157;	/* RDB$RELATION_TYPE */
          short fb_158;	/* gds__null_flag */
          short fb_159;	/* gds__null_flag */
          short fb_160;	/* gds__null_flag */
          short fb_161;	/* RDB$FLAGS */
          short fb_162;	/* RDB$SYSTEM_FLAG */
          short fb_163;	/* gds__null_flag */
          char  fb_164 [253];	/* RDB$RELATION_NAME */
          char  fb_165 [253];	/* RDB$SECURITY_CLASS */
          char  fb_166 [253];	/* RDB$OWNER_NAME */
          FB_BOOLEAN fb_167;	/* RDB$SQL_SECURITY */
   } fb_147;
/**************************************
 *
 *	w r i t e _ r e l a t i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each relation.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// if we have all capabilities, use the first request to get the
	// most performance out of the latest engine; if we don't
	// have one of the capabilities we must use the second set of
	// requests--this requires more code but it is well worth it
	// for the performance benefits, especially remotely--deej

	if (tdgbl->runtimeODS >= DB_VERSION_DDL11_1)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$RELATIONS WITH X.RDB$SYSTEM_FLAG NE 1 OR
			X.RDB$SYSTEM_FLAG MISSING*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_146), fb_146);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 1070, CAST_MSG(&fb_147));
		   if (!fb_147.fb_153 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			SSHORT flags = 0;
			put(tdgbl, rec_relation);
			const SSHORT l = PUT_TEXT (att_relation_name, /*X.RDB$RELATION_NAME*/
								      fb_147.fb_164);
			MISC_terminate (/*X.RDB$RELATION_NAME*/
					fb_147.fb_164, temp, l, sizeof(temp));
			if (/*X.RDB$VIEW_BLR.NULL*/
			    fb_147.fb_163)
				BURP_verbose(153, temp); // msg 153 writing table @1
			else
				BURP_verbose(345, temp); // msg 345 writing view @1

			// RDB$VIEW_BLR must be the first blob field in the backup file.
			// RESTORE.EPP makes this assumption in get_relation().

			if (put_blr_blob (att_relation_view_blr, /*X.RDB$VIEW_BLR*/
								 fb_147.fb_152))
				flags |= REL_view;
			if (/*X.RDB$SYSTEM_FLAG*/
			    fb_147.fb_162)
				put_int32 (att_relation_system_flag, /*X.RDB$SYSTEM_FLAG*/
								     fb_147.fb_162);
			if (!/*X.RDB$FLAGS.NULL*/
			     fb_147.fb_160)
				put_int32 (att_relation_flags, /*X.RDB$FLAGS*/
							       fb_147.fb_161);
			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     fb_147.fb_159)
				PUT_TEXT (att_relation_security_class, /*X.RDB$SECURITY_CLASS*/
								       fb_147.fb_165);

			put_source_blob (att_relation_description2, att_relation_description,
				/*X.RDB$DESCRIPTION*/
				fb_147.fb_151);
			put_source_blob (att_relation_view_source2, att_relation_view_source, /*X.RDB$VIEW_SOURCE*/
											      fb_147.fb_150);

			put_source_blob(att_relation_ext_description2, att_relation_ext_description,
							/*X.RDB$EXTERNAL_DESCRIPTION*/
							fb_147.fb_149);
			PUT_TEXT (att_relation_owner_name, /*X.RDB$OWNER_NAME*/
							   fb_147.fb_166);
			if (!/*X.RDB$EXTERNAL_FILE.NULL*/
			     fb_147.fb_158)
			{
				if (!tdgbl->gbl_sw_convert_ext_tables)
				{
					PUT_TEXT(att_relation_ext_file_name, /*X.RDB$EXTERNAL_FILE*/
									     fb_147.fb_148);
					flags |= REL_external;
				}
			}

			if (!/*X.RDB$RELATION_TYPE.NULL*/
			     fb_147.fb_156)
				put_int32 (att_relation_type, /*X.RDB$RELATION_TYPE*/
							      fb_147.fb_157);

			if (!/*X.RDB$SQL_SECURITY.NULL*/
			     fb_147.fb_155)
				put_boolean(att_relation_sql_security, /*X.RDB$SQL_SECURITY*/
								       fb_147.fb_167);

			put(tdgbl, att_end);
			burp_rel* relation = (burp_rel*) BURP_alloc_zero (sizeof(burp_rel));
			relation->rel_next = tdgbl->relations;
			tdgbl->relations = relation;
			relation->rel_id = /*X.RDB$RELATION_ID*/
					   fb_147.fb_154;
			relation->rel_name_length = COPY(/*X.RDB$RELATION_NAME*/
							 fb_147.fb_164, relation->rel_name);
			relation->rel_flags |= flags;
			put_relation (relation);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$RELATIONS WITH X.RDB$SYSTEM_FLAG NE 1 OR
			X.RDB$SYSTEM_FLAG MISSING*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_129), fb_129);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 1061, CAST_MSG(&fb_130));
		   if (!fb_130.fb_136 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			SSHORT flags = 0;
			put(tdgbl, rec_relation);
			const SSHORT l = PUT_TEXT(att_relation_name, /*X.RDB$RELATION_NAME*/
								     fb_130.fb_143);
			MISC_terminate (/*X.RDB$RELATION_NAME*/
					fb_130.fb_143, temp, l, sizeof(temp));
			BURP_verbose (153, temp);
			// msg 153 writing table %.*s

			// RDB$VIEW_BLR must be the first blob field in the backup file.
			// RESTORE.EPP makes this assumption in get_relation().

			if (put_blr_blob (att_relation_view_blr, /*X.RDB$VIEW_BLR*/
								 fb_130.fb_135))
				flags |= REL_view;
			if (/*X.RDB$SYSTEM_FLAG*/
			    fb_130.fb_142)
				put_int32 (att_relation_system_flag, /*X.RDB$SYSTEM_FLAG*/
								     fb_130.fb_142);
			if (!/*X.RDB$FLAGS.NULL*/
			     fb_130.fb_140)
				put_int32 (att_relation_flags, /*X.RDB$FLAGS*/
							       fb_130.fb_141);
			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     fb_130.fb_139)
				PUT_TEXT(att_relation_security_class, /*X.RDB$SECURITY_CLASS*/
								      fb_130.fb_144);
			put_source_blob (att_relation_description2, att_relation_description, /*X.RDB$DESCRIPTION*/
											      fb_130.fb_134);
			put_source_blob (att_relation_view_source2, att_relation_view_source, /*X.RDB$VIEW_SOURCE*/
											      fb_130.fb_133);
			put_source_blob(att_relation_ext_description2, att_relation_ext_description,
							/*X.RDB$EXTERNAL_DESCRIPTION*/
							fb_130.fb_132);
			PUT_TEXT(att_relation_owner_name, /*X.RDB$OWNER_NAME*/
							  fb_130.fb_145);
			if (!/*X.RDB$EXTERNAL_FILE.NULL*/
			     fb_130.fb_138)
			{
				if (!tdgbl->gbl_sw_convert_ext_tables)
				{
					PUT_TEXT(att_relation_ext_file_name, /*X.RDB$EXTERNAL_FILE*/
									     fb_130.fb_131);
					flags |= REL_external;
				}
			}
			put(tdgbl, att_end);
			burp_rel* relation = (burp_rel*) BURP_alloc_zero (sizeof(burp_rel));
			relation->rel_next = tdgbl->relations;
			tdgbl->relations = relation;
			relation->rel_id = /*X.RDB$RELATION_ID*/
					   fb_130.fb_137;
			relation->rel_name_length = COPY(/*X.RDB$RELATION_NAME*/
							 fb_130.fb_143, relation->rel_name);
			relation->rel_flags |= flags;
			put_relation (relation);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_secclasses()
{
   struct fb_124_struct {
          ISC_QUAD fb_125;	/* RDB$DESCRIPTION */
          ISC_QUAD fb_126;	/* RDB$ACL */
          short fb_127;	/* fbUtility */
          char  fb_128 [253];	/* RDB$SECURITY_CLASS */
   } fb_124;
	TEXT temp[GDS_NAME_LEN];
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$SECURITY_CLASSES WITH X.RDB$SECURITY_CLASS NOT STARTING "SQL$"*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle1 && DB)
	      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_123), fb_123);
	   if (req_handle1)
	      req_handle1->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle1->receive (fbStatus, 0, 0, 271, CAST_MSG(&fb_124));
	   if (!fb_124.fb_127 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
		put(tdgbl, rec_security_class);
		const ULONG l = PUT_TEXT (att_class_security_class, /*X.RDB$SECURITY_CLASS*/
								    fb_124.fb_128);
		MISC_terminate (/*X.RDB$SECURITY_CLASS*/
				fb_124.fb_128, temp, l, sizeof(temp));
		BURP_verbose (155, temp);
		// msg 155 writing security class @1
		put_blr_blob (att_class_acl, /*X.RDB$ACL*/
					     fb_124.fb_126);
		put_source_blob (att_class_description2, att_class_description, /*X.RDB$DESCRIPTION*/
										fb_124.fb_125);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_shadow_files()
{
   struct fb_115_struct {
          char  fb_116 [256];	/* RDB$FILE_NAME */
          ISC_LONG fb_117;	/* RDB$FILE_LENGTH */
          ISC_LONG fb_118;	/* RDB$FILE_START */
          short fb_119;	/* fbUtility */
          short fb_120;	/* RDB$SHADOW_NUMBER */
          short fb_121;	/* RDB$FILE_FLAGS */
          short fb_122;	/* RDB$FILE_SEQUENCE */
   } fb_115;
/**************************************
 *
 *	w r i t e _ s h a d o w _ f i l e s
 *
 **************************************
 *
 * Functional description
 *	Write out files to use as shadows.
 *
 **************************************/
	/*BASED ON RDB$FILES.RDB$FILE_NAME temp;*/
	char
	   temp[256];

	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$FILES
		WITH X.RDB$SHADOW_NUMBER NOT MISSING
		AND X.RDB$SHADOW_NUMBER NE 0*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle1 && DB)
	      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_114), fb_114);
	   if (req_handle1)
	      req_handle1->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle1->receive (fbStatus, 0, 0, 272, CAST_MSG(&fb_115));
	   if (!fb_115.fb_119 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
		put(tdgbl, rec_files);
		const SSHORT l = PUT_TEXT (att_file_filename, /*X.RDB$FILE_NAME*/
							      fb_115.fb_116);
		MISC_terminate (/*X.RDB$FILE_NAME*/
				fb_115.fb_116, temp, l, sizeof(temp));
		BURP_verbose (163, temp);
		// msg 163 writing shadow file %s
		put_int32 (att_file_sequence, /*X.RDB$FILE_SEQUENCE*/
					      fb_115.fb_122);
		put_int32 (att_file_start, /*X.RDB$FILE_START*/
					   fb_115.fb_118);
		put_int32 (att_file_length, /*X.RDB$FILE_LENGTH*/
					    fb_115.fb_117);
		put_int32 (att_file_flags, /*X.RDB$FILE_FLAGS*/
					   fb_115.fb_121);
		put_int32 (att_shadow_number, /*X.RDB$SHADOW_NUMBER*/
					      fb_115.fb_120);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_sql_roles()
{
   struct fb_102_struct {
          short fb_103;	/* fbUtility */
          char  fb_104 [253];	/* RDB$ROLE_NAME */
          char  fb_105 [253];	/* RDB$OWNER_NAME */
   } fb_102;
   struct fb_107_struct {
          char  fb_108 [8];	/* RDB$SYSTEM_PRIVILEGES */
          ISC_QUAD fb_109;	/* RDB$DESCRIPTION */
          short fb_110;	/* fbUtility */
          short fb_111;	/* gds__null_flag */
          char  fb_112 [253];	/* RDB$ROLE_NAME */
          char  fb_113 [253];	/* RDB$OWNER_NAME */
   } fb_107;
/**************************************
 *
 *	w r i t e _ s q l _ r o l e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each SQL roles.
 *
 **************************************/
	Firebird::IRequest* req_handle1 = nullptr;
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL11)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$ROLES
			WITH X.RDB$SYSTEM_FLAG EQ 0 OR X.RDB$SYSTEM_FLAG MISSING*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_106), fb_106);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 526, CAST_MSG(&fb_107));
		   if (!fb_107.fb_110 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			put(tdgbl, rec_sql_roles);
			const SSHORT l = PUT_TEXT(att_role_name, /*X.RDB$ROLE_NAME*/
								 fb_107.fb_112);
			PUT_TEXT (att_role_owner_name, /*X.RDB$OWNER_NAME*/
						       fb_107.fb_113);
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     fb_107.fb_111) {
				put_source_blob (att_role_description, att_role_description, /*X.RDB$DESCRIPTION*/
											     fb_107.fb_109);
			}

			const UCHAR ll = sizeof(/*X.RDB$SYSTEM_PRIVILEGES*/
						fb_107.fb_108);
			put(tdgbl, att_role_sys_priveleges);
			put(tdgbl, ll);
			put_block(tdgbl, (const UCHAR*) (/*X.RDB$SYSTEM_PRIVILEGES*/
							 fb_107.fb_108), ll);

			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$ROLE_NAME*/
					fb_107.fb_112, temp, l, sizeof(temp));
			BURP_verbose (249, temp);
			// msg 249 writing SQL role: %s

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$ROLES*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_101), fb_101);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 508, CAST_MSG(&fb_102));
		   if (!fb_102.fb_103 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			put(tdgbl, rec_sql_roles);
			const SSHORT l = PUT_TEXT(att_role_name, /*X.RDB$ROLE_NAME*/
								 fb_102.fb_104);
			PUT_TEXT (att_role_owner_name, /*X.RDB$OWNER_NAME*/
						       fb_102.fb_105);
			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$ROLE_NAME*/
					fb_102.fb_104, temp, l, sizeof(temp));
			BURP_verbose (249, temp);
			// msg 249 writing SQL role: %s

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_mapping()
{
   struct fb_81_struct {
          short fb_82;	/* fbUtility */
          short fb_83;	/* RDB$SYSTEM_FLAG */
   } fb_81;
   struct fb_79_struct {
          char  fb_80 [253];	/* RDB$ROLE_NAME */
   } fb_79;
   struct fb_85_struct {
          ISC_QUAD fb_86;	/* RDB$DESCRIPTION */
          short fb_87;	/* fbUtility */
          short fb_88;	/* gds__null_flag */
          short fb_89;	/* gds__null_flag */
          short fb_90;	/* RDB$MAP_TO_TYPE */
          short fb_91;	/* gds__null_flag */
          short fb_92;	/* gds__null_flag */
          short fb_93;	/* gds__null_flag */
          char  fb_94 [253];	/* RDB$MAP_NAME */
          char  fb_95 [5];	/* RDB$MAP_USING */
          char  fb_96 [253];	/* RDB$MAP_PLUGIN */
          char  fb_97 [253];	/* RDB$MAP_DB */
          char  fb_98 [253];	/* RDB$MAP_FROM_TYPE */
          char  fb_99 [1021];	/* RDB$MAP_FROM */
          char  fb_100 [253];	/* RDB$MAP_TO */
   } fb_85;
/**************************************
 *
 *	w r i t e _ m a p p i n g
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each names mapping.
 *
 **************************************/
	Firebird::IRequest* req_handle = nullptr;
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->runtimeODS >= DB_VERSION_DDL12)
	{
		/*FOR (REQUEST_HANDLE req_handle)
			M IN RDB$AUTH_MAPPING
			WITH M.RDB$SYSTEM_FLAG EQ 0*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle && DB)
		      req_handle = DB->compileRequest(fbStatus, sizeof(fb_84), fb_84);
		   if (req_handle)
		      req_handle->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle->release(); req_handle = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle->receive (fbStatus, 0, 0, 2313, CAST_MSG(&fb_85));
		   if (!fb_85.fb_87 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			put(tdgbl, rec_mapping);
			const SSHORT l = PUT_TEXT(att_map_name, /*M.RDB$MAP_NAME*/
								fb_85.fb_94);
			PUT_TEXT(att_map_using, /*M.RDB$MAP_USING*/
						fb_85.fb_95);

			if (!/*M.RDB$MAP_PLUGIN.NULL*/
			     fb_85.fb_93)
				PUT_TEXT(att_map_plugin, /*M.RDB$MAP_PLUGIN*/
							 fb_85.fb_96);

			if (!/*M.RDB$MAP_DB.NULL*/
			     fb_85.fb_92)
				PUT_TEXT(att_map_db, /*M.RDB$MAP_DB*/
						     fb_85.fb_97);

			PUT_TEXT(att_map_from_type, /*M.RDB$MAP_FROM_TYPE*/
						    fb_85.fb_98);

			if (!/*M.RDB$MAP_FROM.NULL*/
			     fb_85.fb_91)
				PUT_TEXT(att_map_from, /*M.RDB$MAP_FROM*/
						       fb_85.fb_99);

			put_int32(att_map_to_type, /*M.RDB$MAP_TO_TYPE*/
						   fb_85.fb_90);

			if (!/*M.RDB$MAP_TO.NULL*/
			     fb_85.fb_89)
				PUT_TEXT(att_map_to, /*M.RDB$MAP_TO*/
						     fb_85.fb_100);

			if (!/*M.RDB$DESCRIPTION.NULL*/
			     fb_85.fb_88)
				put_source_blob(att_map_description, att_map_description, /*M.RDB$DESCRIPTION*/
											  fb_85.fb_86);

			put(tdgbl, att_end);

			MISC_terminate (/*M.RDB$MAP_NAME*/
					fb_85.fb_94, temp, l, sizeof(temp));
			BURP_verbose (297, temp);
			// msg 297 writing mapping for %s

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else if (tdgbl->runtimeODS >= DB_VERSION_DDL11_2)
	{
		/*FOR (REQUEST_HANDLE req_handle)
			X IN RDB$ROLES
			WITH X.RDB$ROLE_NAME EQ ADMIN_ROLE*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle && DB)
		      req_handle = DB->compileRequest(fbStatus, sizeof(fb_78), fb_78);
		   isc_vtov ((const char*) ADMIN_ROLE, (char*) fb_79.fb_80, 253);
		   if (req_handle)
		      req_handle->startAndSend(fbStatus, fbTrans, 0, 0, 253, CAST_CONST_MSG(&fb_79));
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle->release(); req_handle = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle->receive (fbStatus, 0, 1, 4, CAST_MSG(&fb_81));
		   if (!fb_81.fb_82 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			if (/*X.RDB$SYSTEM_FLAG*/
			    fb_81.fb_83 == 6)		// constant 6 turns on auto admin mapping in FB 2.5
			{
				put(tdgbl, rec_mapping);
				put_text(att_auto_map_role, ADMIN_ROLE, static_cast<SSHORT>(strlen(ADMIN_ROLE) + 1));
				put(tdgbl, att_end);
				BURP_verbose (297, ADMIN_ROLE);
				// msg 297 writing mapping for @1
			}

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle);
}


void write_db_creators()
{
   struct fb_72_struct {
          short fb_73;	/* fbUtility */
          short fb_74;	/* gds__null_flag */
          short fb_75;	/* gds__null_flag */
          short fb_76;	/* RDB$USER_TYPE */
          char  fb_77 [253];	/* RDB$USER */
   } fb_72;
/**************************************
 *
 *	w r i t e _ d b _ c r e a t o r s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each grant to create database.
 *
 **************************************/
	Firebird::IRequest* req_handle = nullptr;
	TEXT temp[GDS_NAME_LEN];
	bool first = true;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle)
		C IN RDB$DB_CREATORS*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle && DB)
	      req_handle = DB->compileRequest(fbStatus, sizeof(fb_71), fb_71);
	   if (req_handle)
	      req_handle->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle->release(); req_handle = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle->receive (fbStatus, 0, 0, 261, CAST_MSG(&fb_72));
	   if (!fb_72.fb_73 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

		if (first)
		{
			BURP_verbose(391);
			// msg 391 writing database create grants
			first = false;
		}

		bool fl = true;

		if (!/*C.RDB$USER_TYPE.NULL*/
		     fb_72.fb_75)
		{
			put(tdgbl, rec_db_creator);
			fl = false;
			put_int32(att_dbc_type, /*C.RDB$USER_TYPE*/
						fb_72.fb_76);
		}

		if (!/*C.RDB$USER.NULL*/
		     fb_72.fb_74)
		{
			if (fl)
				put(tdgbl, rec_db_creator);
			fl = false;
			const SSHORT l = PUT_TEXT(att_dbc_user, /*C.RDB$USER*/
								fb_72.fb_77);

			MISC_terminate (/*C.RDB$USER*/
					fb_72.fb_77, temp, l, sizeof(temp));
			BURP_verbose (392, temp);
			// msg 392 writing db creator %s
		}

		if (!fl)
			put(tdgbl, att_end);

	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle);
}


void write_triggers()
{
   struct fb_32_struct {
          ISC_QUAD fb_33;	/* RDB$DESCRIPTION */
          ISC_QUAD fb_34;	/* RDB$TRIGGER_SOURCE */
          ISC_QUAD fb_35;	/* RDB$TRIGGER_BLR */
          ISC_INT64 fb_36;	/* RDB$TRIGGER_TYPE */
          short fb_37;	/* fbUtility */
          short fb_38;	/* gds__null_flag */
          short fb_39;	/* RDB$FLAGS */
          short fb_40;	/* RDB$TRIGGER_INACTIVE */
          short fb_41;	/* RDB$SYSTEM_FLAG */
          short fb_42;	/* RDB$TRIGGER_SEQUENCE */
          short fb_43;	/* gds__null_flag */
          char  fb_44 [253];	/* RDB$TRIGGER_NAME */
          char  fb_45 [253];	/* RDB$RELATION_NAME */
   } fb_32;
   struct fb_47_struct {
          char  fb_48 [256];	/* RDB$ENTRYPOINT */
          ISC_QUAD fb_49;	/* RDB$DEBUG_INFO */
          ISC_QUAD fb_50;	/* RDB$DESCRIPTION */
          ISC_QUAD fb_51;	/* RDB$TRIGGER_SOURCE */
          ISC_QUAD fb_52;	/* RDB$TRIGGER_BLR */
          ISC_INT64 fb_53;	/* RDB$TRIGGER_TYPE */
          short fb_54;	/* fbUtility */
          short fb_55;	/* gds__null_flag */
          short fb_56;	/* gds__null_flag */
          short fb_57;	/* gds__null_flag */
          short fb_58;	/* gds__null_flag */
          short fb_59;	/* gds__null_flag */
          short fb_60;	/* RDB$VALID_BLR */
          short fb_61;	/* gds__null_flag */
          short fb_62;	/* RDB$FLAGS */
          short fb_63;	/* RDB$TRIGGER_INACTIVE */
          short fb_64;	/* RDB$SYSTEM_FLAG */
          short fb_65;	/* RDB$TRIGGER_SEQUENCE */
          short fb_66;	/* gds__null_flag */
          char  fb_67 [253];	/* RDB$TRIGGER_NAME */
          char  fb_68 [253];	/* RDB$RELATION_NAME */
          char  fb_69 [253];	/* RDB$ENGINE_NAME */
          FB_BOOLEAN fb_70;	/* RDB$SQL_SECURITY */
   } fb_47;
/**************************************
 *
 *	w r i t e _ t r i g g e r s
 *
 **************************************
 *
 * Functional description
 * 	write the triggers in rdb$triggers
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// if we have all capabilities, use the first request to get the
	// most performance out of the latest engine; if we don't
	// have one of the capabilities we must use the second set of
	// requests--this requires more code but it is well worth it
	// for the performance benefits, especially remotely--deej

	if (tdgbl->runtimeODS >= DB_VERSION_DDL11_1)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$TRIGGERS WITH
			X.RDB$SYSTEM_FLAG NE 1 OR
			X.RDB$SYSTEM_FLAG MISSING*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_46), fb_46);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 1082, CAST_MSG(&fb_47));
		   if (!fb_47.fb_54 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			put(tdgbl, rec_trigger);
			const SSHORT l = PUT_TEXT (att_trig_name, /*X.RDB$TRIGGER_NAME*/
								  fb_47.fb_67);
			MISC_terminate (/*X.RDB$TRIGGER_NAME*/
					fb_47.fb_67, temp, l, sizeof(temp));
			BURP_verbose (156, temp);
			// msg 156   writing trigger %s

			if (!/*X.RDB$RELATION_NAME.NULL*/
			     fb_47.fb_66)
				PUT_TEXT (att_trig_relation_name, /*X.RDB$RELATION_NAME*/
								  fb_47.fb_68);

			put_int32 (att_trig_sequence, /*X.RDB$TRIGGER_SEQUENCE*/
						      fb_47.fb_65);

			if (/*X.RDB$TRIGGER_TYPE*/
			    fb_47.fb_53 >= SLONG_MIN && /*X.RDB$TRIGGER_TYPE*/
		 fb_47.fb_53 <= SLONG_MAX)
				put_int32 (att_trig_type, (SLONG) /*X.RDB$TRIGGER_TYPE*/
								  fb_47.fb_53);
			else
				put_int64 (att_trig_type2, /*X.RDB$TRIGGER_TYPE*/
							   fb_47.fb_53);

			put_blr_blob (att_trig_blr, /*X.RDB$TRIGGER_BLR*/
						    fb_47.fb_52);
			put_source_blob (att_trig_source2, att_trig_source, /*X.RDB$TRIGGER_SOURCE*/
									    fb_47.fb_51);
			put_source_blob (att_trig_description2, att_trig_description, /*X.RDB$DESCRIPTION*/
										      fb_47.fb_50);
			put_int32 (att_trig_system_flag, /*X.RDB$SYSTEM_FLAG*/
							 fb_47.fb_64);
			put_int32 (att_trig_inactive, /*X.RDB$TRIGGER_INACTIVE*/
						      fb_47.fb_63);

			if (!/*X.RDB$FLAGS.NULL*/
			     fb_47.fb_61)
				put_int32 (att_trig_flags, /*X.RDB$FLAGS*/
							   fb_47.fb_62);

			if (!/*X.RDB$VALID_BLR.NULL*/
			     fb_47.fb_59)
				put_int32 (att_trig_valid_blr, /*X.RDB$VALID_BLR*/
							       fb_47.fb_60);

			if (!/*X.RDB$DEBUG_INFO.NULL*/
			     fb_47.fb_58)
				put_blr_blob (att_trig_debug_info, /*X.RDB$DEBUG_INFO*/
								   fb_47.fb_49);

			if (!/*X.RDB$ENGINE_NAME.NULL*/
			     fb_47.fb_57)
				PUT_TEXT(att_trig_engine_name, /*X.RDB$ENGINE_NAME*/
							       fb_47.fb_69);

			if (!/*X.RDB$ENTRYPOINT.NULL*/
			     fb_47.fb_56)
				PUT_TEXT(att_trig_entrypoint, /*X.RDB$ENTRYPOINT*/
							      fb_47.fb_48);

			if (!/*X.RDB$SQL_SECURITY.NULL*/
			     fb_47.fb_55)
				put_boolean(att_trig_sql_security, /*X.RDB$SQL_SECURITY*/
								   fb_47.fb_70);

			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$TRIGGERS WITH
			X.RDB$SYSTEM_FLAG NE 1 OR
			X.RDB$SYSTEM_FLAG MISSING*/
		{
		for (int retries = 0; retries < 2; ++retries)
		   {
		   if (!req_handle1 && DB)
		      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_31), fb_31);
		   if (req_handle1)
		      req_handle1->start(fbStatus, fbTrans, 0);
		   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
		   else break;
		   }
		if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
		while (1)
		   {
		   req_handle1->receive (fbStatus, 0, 0, 552, CAST_MSG(&fb_32));
		   if (!fb_32.fb_37 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

			put(tdgbl, rec_trigger);
			const SSHORT l = PUT_TEXT (att_trig_name, /*X.RDB$TRIGGER_NAME*/
								  fb_32.fb_44);
			MISC_terminate (/*X.RDB$TRIGGER_NAME*/
					fb_32.fb_44, temp, l, sizeof(temp));
			BURP_verbose (156, temp);
			// msg 156   writing trigger %s

			if (!/*X.RDB$RELATION_NAME.NULL*/
			     fb_32.fb_43)
				PUT_TEXT (att_trig_relation_name, /*X.RDB$RELATION_NAME*/
								  fb_32.fb_45);

			put_int32 (att_trig_sequence, /*X.RDB$TRIGGER_SEQUENCE*/
						      fb_32.fb_42);
			put_int32 (att_trig_type, /*X.RDB$TRIGGER_TYPE*/
						  fb_32.fb_36);
			put_blr_blob (att_trig_blr, /*X.RDB$TRIGGER_BLR*/
						    fb_32.fb_35);
			put_source_blob (att_trig_source2, att_trig_source, /*X.RDB$TRIGGER_SOURCE*/
									    fb_32.fb_34);
			put_source_blob (att_trig_description2, att_trig_description, /*X.RDB$DESCRIPTION*/
										      fb_32.fb_33);
			put_int32 (att_trig_system_flag, /*X.RDB$SYSTEM_FLAG*/
							 fb_32.fb_41);
			put_int32 (att_trig_inactive, /*X.RDB$TRIGGER_INACTIVE*/
						      fb_32.fb_40);

			if (!/*X.RDB$FLAGS.NULL*/
			     fb_32.fb_38)
				put_int32 (att_trig_flags, /*X.RDB$FLAGS*/
							   fb_32.fb_39);

			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}


void write_trigger_messages()
{
   struct fb_26_struct {
          char  fb_27 [1024];	/* RDB$MESSAGE */
          short fb_28;	/* fbUtility */
          short fb_29;	/* RDB$MESSAGE_NUMBER */
          char  fb_30 [253];	/* RDB$TRIGGER_NAME */
   } fb_26;
/**************************************
 *
 *	w r i t e _ t r i g g e r _ m e s s a g e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each trigger message.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		T IN RDB$TRIGGERS CROSS X IN RDB$TRIGGER_MESSAGES
		OVER RDB$TRIGGER_NAME
		WITH T.RDB$SYSTEM_FLAG NE 1 OR T.RDB$SYSTEM_FLAG MISSING*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle1 && DB)
	      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_25), fb_25);
	   if (req_handle1)
	      req_handle1->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle1->receive (fbStatus, 0, 0, 1281, CAST_MSG(&fb_26));
	   if (!fb_26.fb_28 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;

		put(tdgbl, rec_trigger_message);
		const SSHORT l = PUT_TEXT (att_trigmsg_name, /*X.RDB$TRIGGER_NAME*/
							     fb_26.fb_30);
		MISC_terminate (/*X.RDB$TRIGGER_NAME*/
				fb_26.fb_30, temp, l, sizeof(temp));
		BURP_verbose (157, temp);
		// msg 157 writing trigger message for %s
		put_int32 (att_trigmsg_number, /*X.RDB$MESSAGE_NUMBER*/
					       fb_26.fb_29);
		PUT_MESSAGE (att_trigmsg_text, att_end, /*X.RDB$MESSAGE*/
							fb_26.fb_27);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_types()
{
   struct fb_18_struct {
          ISC_QUAD fb_19;	/* RDB$DESCRIPTION */
          short fb_20;	/* fbUtility */
          short fb_21;	/* RDB$SYSTEM_FLAG */
          short fb_22;	/* RDB$TYPE */
          char  fb_23 [253];	/* RDB$TYPE_NAME */
          char  fb_24 [253];	/* RDB$FIELD_NAME */
   } fb_18;
/**************************************
 *
 *	w r i t e _ t y p e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each type.
 *
 **************************************/
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$TYPES WITH X.RDB$SYSTEM_FLAG NE 1 OR
		X.RDB$SYSTEM_FLAG MISSING*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle1 && DB)
	      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_17), fb_17);
	   if (req_handle1)
	      req_handle1->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle1->receive (fbStatus, 0, 0, 520, CAST_MSG(&fb_18));
	   if (!fb_18.fb_20 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
		put(tdgbl, rec_system_type);
		PUT_TEXT (att_type_name, /*X.RDB$TYPE_NAME*/
					 fb_18.fb_23);
		PUT_TEXT (att_type_field_name, /*X.RDB$FIELD_NAME*/
					       fb_18.fb_24);
		BURP_verbose (160, SafeArg() << /*X.RDB$TYPE_NAME*/
						fb_18.fb_23 << /*X.RDB$FIELD_NAME*/
    fb_18.fb_24);
		// msg 160 writing type %s for field %s
		put_int32 (att_type_type, /*X.RDB$TYPE*/
					  fb_18.fb_22);
		put_source_blob (att_type_description2, att_type_description, /*X.RDB$DESCRIPTION*/
									      fb_18.fb_19);
		if (/*X.RDB$SYSTEM_FLAG*/
		    fb_18.fb_21)
			put_int32 (att_type_system_flag, /*X.RDB$SYSTEM_FLAG*/
							 fb_18.fb_21);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_user_privileges()
{
   struct fb_5_struct {
          short fb_6;	/* fbUtility */
          short fb_7;	/* RDB$OBJECT_TYPE */
          short fb_8;	/* RDB$USER_TYPE */
          short fb_9;	/* gds__null_flag */
          short fb_10;	/* gds__null_flag */
          short fb_11;	/* RDB$GRANT_OPTION */
          char  fb_12 [253];	/* RDB$USER */
          char  fb_13 [253];	/* RDB$GRANTOR */
          char  fb_14 [7];	/* RDB$PRIVILEGE */
          char  fb_15 [253];	/* RDB$RELATION_NAME */
          char  fb_16 [253];	/* RDB$FIELD_NAME */
   } fb_5;
/**************************************
 *
 *	w r i t e _ u s e r _ p r i v i l e g e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each user privilege.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	Firebird::IRequest* req_handle1 = nullptr;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$USER_PRIVILEGES
		WITH X.RDB$GRANTOR NOT MISSING*/
	{
	for (int retries = 0; retries < 2; ++retries)
	   {
	   if (!req_handle1 && DB)
	      req_handle1 = DB->compileRequest(fbStatus, sizeof(fb_4), fb_4);
	   if (req_handle1)
	      req_handle1->start(fbStatus, fbTrans, 0);
	   if (fbStatus->getErrors()[1] == isc_bad_req_handle) { req_handle1->release(); req_handle1 = NULL; }
	   else break;
	   }
	if (!(fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) {
	while (1)
	   {
	   req_handle1->receive (fbStatus, 0, 0, 1031, CAST_MSG(&fb_5));
	   if (!fb_5.fb_6 || (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)) break;
		put(tdgbl, rec_user_privilege);
		const SSHORT l = PUT_TEXT (att_priv_user, /*X.RDB$USER*/
							  fb_5.fb_12);
		MISC_terminate (/*X.RDB$USER*/
				fb_5.fb_12, temp, l, sizeof(temp));
		BURP_verbose (152, temp);
		// msg 152 writing privilege for user %s
		PUT_TEXT (att_priv_grantor, /*X.RDB$GRANTOR*/
					    fb_5.fb_13);
		PUT_TEXT (att_priv_privilege, /*X.RDB$PRIVILEGE*/
					      fb_5.fb_14);
		if (!/*X.RDB$GRANT_OPTION.NULL*/
		     fb_5.fb_10)
			put_int32 (att_priv_grant_option, /*X.RDB$GRANT_OPTION*/
							  fb_5.fb_11);
		PUT_TEXT (att_priv_object_name, /*X.RDB$RELATION_NAME*/
						fb_5.fb_15);
		if (!/*X.RDB$FIELD_NAME.NULL*/
		     fb_5.fb_9)
		   PUT_TEXT (att_priv_field_name, /*X.RDB$FIELD_NAME*/
						  fb_5.fb_16);
		put_int32 (att_priv_user_type, /*X.RDB$USER_TYPE*/
					       fb_5.fb_8);
		put_int32 (att_priv_obj_type, /*X.RDB$OBJECT_TYPE*/
					      fb_5.fb_7);
		put(tdgbl, att_end);
	/*END_FOR*/
	   }
	   };
	/*ON_ERROR*/
	if (fbStatus->getState() & Firebird::IStatus::STATE_ERRORS)
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}

} // namespace

